
--***************************************************************************
--***************************************************************************
-- This function is used to broadcast spells on the custom channel, so that
-- other players will know if/when a heal is happening. This is to provide
-- visual data for when heals occur.

function CastParty_Channel_Comms(_messageText)
   -- to prevent nil error problems when we don't know the location!!!
   if GetZoneText() == nil then
      return;
   end

   zoneText = 'CP'..string.gsub(GetZoneText(), '%A', "");
   _, tempChanName = GetChannelName(zoneText);


   --this either creates the channel if it doesn't already exist.. OR, it will switch to the correct one.
   if (CastParty_Chan_name and CastParty_Chan_name ~= tempChanName) then
      --leave the channel!
      if CastParty_Debug then CastParty_Debug(3, 'Leaving channel!', 'Different name', CastParty_Chan_name) end;
      LeaveChannelByName(CastParty_Chan_name);
      CastParty_Chan_name = nil;
   end

   if UnitInGroup('player') then
      if CastParty_Chan_name == nil then
         --create the channel!
         CastParty_Chan_name = zoneText;
         JoinChannelByName(CastParty_Chan_name)
         if CastParty_Debug then CastParty_Debug(3, 'Creating channel!', CastParty_Chan_name) end;
      end

      if CastParty_Debug then CastParty_Debug(3, 'Sending message on channel!') end;
      SendChatMessage(_messageText, 'CHANNEL', this.language, GetChannelName(CastParty_Chan_name));
   else
      --leave the channel!
      if CastParty_Debug then CastParty_Debug(3, 'Leaving channel!', 'Not in group!', CastParty_Chan_name) end;
      if CastParty_Chan_name ~= nil then
         LeaveChannelByName(CastParty_Chan_name);
      end
      CastParty_Chan_name = nil;
   end
end


--***************************************************************************
--***************************************************************************
-- this function parses the recieved chat message, to know important stuff!
function CastPart_Channel_Parse(...)
   -- this is to monitor the chat channels for important stuff... like heal info!
   if CastParty_UpdateHealer and arg[9] == CastParty_Chan_name then
      for _id, target, name, rank, spellDuration, ammount in string.gfind(arg[1], '(.*)#(.*)#(.*)#(.*)#(.*)#(.*)') do
         _id = tonumber(_id);
         if CP_units[_id] and UnitName(CP_units[_id]) == target then
            if CastParty_Debug then CastParty_Debug(3, 'We know who is healing who!!') end;
            CastParty_UpdateHealer(arg[2], _id, target, name, rank, spellDuration, ammount);
            break;
         else
            for index, _unit in CP_units do   -- this scans everyone, and try's to find out who they are healing!
               if CastParty_Debug then CastParty_Debug(3, 'Scanning everyone to find the healed unit!', _unit) end;
               if UnitExists(_unit) and UnitName(_unit) == target then
                  CastParty_UpdateHealer(arg[2], index, target, name, rank, spellDuration, ammount);
                  break;
               end
            end
         end
         break;
      end
   end
end