
--***************************************************************************
--***************************************************************************
function CastParty.Event.OnClickByUnit(_action, _unitid)
   if (not _action) then
      _action = 'LeftButton';
   end

   -- where is arg1 getting a value?
   if arg1 then
      _action = arg1;
   elseif (arg1 and not string.find(arg1, 'Button')) then
      _action = 'LeftButton';
   end

   if _unitid then
      if CP_units[_ext_unit_id] then
         _ext_unit_id = _unitid;
      else
         local unit
         for unit in pairs(CP_ids) do
            local unitName = UnitName(unit);
            if unitName and unitName == UnitName(_unitid) then
               if CastParty_Debug then CastParty_Debug(2, _unitid, ' : ', unit ,' : ' , unitName , '::' , UnitName(_unitid)) end;
               _ext_unit_id = unit;
               break;
            end
         end
      end
   else
      local frameName = this:GetName();
      local i
   
      if (string.sub(frameName, 1, 5) == 'CT_RA') then
         _ext_unit_id = 'raid' .. this.frameParent.id;
         if ( string.sub(this.frameParent.name, 6, 12) == 'MTGroup' ) then
            for i = 1, GetNumRaidMembers(), 1 do
               if ( UnitName('raid' .. i) == CT_RA_MainTanks[this.frameParent.id] ) then
                  _ext_unit_id = 'raid' .. i .. 'target';
               end
            end
         elseif ( string.sub(this.frameParent.name, 6, 12) == 'PTGroup' ) then
            for i = 1, GetNumRaidMembers(), 1 do
               if ( UnitName('raid' .. i) == CT_RA_PTargets[this.frameParent.id] ) then
                  _ext_unit_id = 'raid' .. i;
               end
            end
         end
      end
   
      if (string.sub(frameName, 1, 4) == 'Nurf') then
         _ext_unit_id = string.sub(frameName, 8, string.len(frameName));
      end
   
      if frameName == 'CT_AssistFrame' then
         _ext_unit_id = 'targettarget'
      end
   
      --this part handles the custom click behavior stuff.
      if CastPartyConfig.cp_blizz_clicks then
         if string.find(frameName, 'TargetofTargetFrame') then
            _ext_unit_id = 'targettarget';
         elseif string.find(frameName, 'TargetFrame') then
            _ext_unit_id = 'target';
         elseif string.find(frameName, 'PlayerFrame') then
            _ext_unit_id = 'player';
         elseif string.find(frameName, 'PetFrame') then
            _ext_unit_id = 'pet';
         elseif string.find(frameName, 'PartyMemberFrame') then
            frameName = string.gsub(frameName, 'PartyMemberFrame', "");
            frameName = string.gsub(frameName, 'Health', "");
            frameName = string.gsub(frameName, 'Mana', "");
            frameName = string.gsub(frameName, 'Bar', "");
            CastParty.Debug(1, BLU.. frameName, string.len(frameName));
            if string.find(frameName, 'PetFrame') then
               frameName = string.gsub(frameName, 'PetFrame', "");
               _ext_unit_id = 'partypet'..frameName;
            else
               _ext_unit_id = 'party'..frameName;
            end
            CastParty.Debug(1, BLU.. UnitName(_ext_unit_id))
         elseif string.find(frameName, 'RaidPullout') then
            _ext_unit_id = this.unit;
            if not _ext_unit_id then
               -- If no unit assume that this is a manabar or healthbar and look at the parent's unit info
               _ext_unit_id = this:GetParent().unit;
            end
         end
      end
   end
   
   --note(this:GetName())
   --note('action '.._action)
   if CastParty_Debug then CastParty_Debug(2, GRN..'external frame clicked was', this:GetName()) end;
   if CastParty_Debug then CastParty_Debug(2, GRN..'external addon passed button press and unit', _action, _ext_unit_id ) end;
   CastParty.Event.OnClick(_action);

   --reset the passed in id...
   _ext_unit_id = nil;
   --to keep CT_RA from switching targets
   return true;
end

--***************************************************************************
--***************************************************************************
function CastParty_ClickAura()

   local name = this:GetName();
   local buffButtonClickedIsCP

   if string.find(name, 'CastParty') then
      buffButtonClickedIsCP = true;
   else
      buffButtonClickedIsCP = false;
   end

   if CastParty_Debug then CastParty_Debug( 1, GRY..'clicked on castparty?', buffButtonClickedIsCP ) end;

   local unitID   = nil;
   local buffName = nil;
   local buffID   = nil;
   local debuffID = nil;
   local buffType = nil;

   if buffButtonClickedIsCP then
      unitID   = this:GetParent():GetID();
      buffName = this.name;
      buffID   = this.buff_index;
      debuffID = this.debuff_index;
      buffType = this.type;
   else
      if string.find(name, 'Target') then
         unitID   = 90;
      elseif string.find(name, 'Party') then
         name   = string.gsub(name, 'PartyMemberFrame', "");
         unitID = tonumber(string.sub(name, 1, 1));
         name   = string.sub(name, 2)
         name   = string.gsub(name, 'Debuff', "");
         debuffID = tonumber(name);
      else
         unitID   = 0;
      end

      buffName = getglobal('GameTooltipTextLeft1'):GetText();

      if unitID == 0 or unitID == 90 then
         if this.buffFilter == 'HELPFUL' then
            buffID   = this.buffIndex;
            debuffID = nil;
         elseif this.buffFilter == 'HARMFUL' then
            buffID   = nil;
            debuffID = this.buffIndex;
         end
      end
   end

   local unit = CP_units[unitID];
   local ills = CastParty.State.ills[unit];

   --this is to make CT mod work, and possibly others.
   if not (buffID or debuffID) and this:GetID() and this.buffIndex then
      local number = GetPlayerBuff(this.buffIndex, 'HELPFUL');
      if  number >= 0 then
         buffID   = this.buffIndex;
         debuffID = nil;
      else
         buffID   = nil;
         debuffID = this.buffIndex;
      end
      -- if not (buffID and debuffID) then
          -- if CastParty_CastParty_Debug then CastParty_CastParty_Debug( 1, 'no clue what it is! HELPFUL', GetPlayerBuff(this.buffIndex, 'HELPFUL')) end;
          -- if CastParty_CastParty_Debug then CastParty_CastParty_Debug( 1, 'no clue what it is! HARMFUL', GetPlayerBuff(this.buffIndex, 'HARMFUL')) end;
          -- if CastParty_CastParty_Debug then CastParty_CastParty_Debug( 1, 'no clue what it is! BOTH', GetPlayerBuffTexture(this:GetID(), 'HELPFUL|HARMFUL')) end;
          -- return;
      -- end
   end

   CastParty.Debug( 1, 'buff id:', buffID)
   CastParty.Debug( 1, 'debuff id:', debuffID)
   CastParty.Debug( 1, 'buff name:', buffName)
   if buffType then CastParty.Debug( 1, 'buff type:', buffType) end;
   CastParty.Debug( 1, 'unit id:', unitID)
   CastParty.Debug( 1, 'button clicked:', arg1)


   if buffName == 'pet_happiness' then
      --maybe hook into feeding the pet? or opening the pet frame thing?
      ToggleCharacter('PetPaperDollFrame');
      return;
   end

   if buffName == CASTPARTY_GHOST then
      return;
   end

   --ctrl-click to add/remove auras to the watched list!
   if arg1 == 'LeftButton' then
      if debuffID ~= nil then
         -- Cure debuff
         if CastPartyConfig.click_to_debuff then
            CastParty.Debug(3, 'curing debuff')
            CastParty.Healomatic.CureAny(unit);
         end
      else
         if buffButtonClickedIsCP
         and IsControlKeyDown()
         and CastParty.Brain.best_spell_ids[buffName] then
            if CP_watched[unit][buffName] then
               if CastParty.Debug then CastParty.Debug(3, 'removing watched buff') end;
               --setting to nil...
               CP_watched[unit][buffName] = nil;
               --setting table size to appropriate size.
               --doing this and setting nil, is the same thing that table.remove does, but I just don't have and
               -- index to do this, i have a name... so i have to do it manually.
               table.setn(CP_watched[unit], table.getn(CP_watched[unit])-1)
            else
               if table.getn(CP_watched[unit]) <= 8 then
                  if CastParty.Debug then CastParty.Debug(3, 'inserting watched buff') end;
                  CP_watched[unit][buffName] =
                     {
                        buffFilter = this.buffFilter;
                        icon = this.icon;
                        overlay = this.overlay;
                        name = this.name;
                        watching = true;
                        show = false;
                     }
               else
                 if CastParty.Debug then CastParty.Debug(3, 'too many watched buffs!!') end;
               end
            end
            CastParty_UpdateAuras(CP_ids[unit]);
            if CastParty_DisplayAuras then
               CastParty_DisplayAuras(CP_ids[unit]);
            end
            return;
         elseif CastPartyConfig.click_to_rebuff then
            if CastParty.Debug then CastParty.Debug( 1, 'Click to Rebuff player config option', CastPartyConfig.click_to_rebuff ) end;
            CastParty_CastBuff(buffName, unit, unitID);
         end
      end

   elseif arg1 == 'RightButton' then
      if CastPartyConfig.rightclick_to_remove then
         if unitID == 0 then
            --right-click to remove buff.
            if buffID then
               CancelPlayerBuff(GetPlayerBuff(buffID,this.buffFilter));

            --right-click to remove debuff. (mind vision, mind control)
            elseif debuffID then
               CancelPlayerBuff(GetPlayerBuff(debuffID,this.buffFilter));
            end
         end
      end
   end
end

--***************************************************************************
--***************************************************************************
local function CastParty_BuildActionKey()
   local actionKey = ""
   if IsAltKeyDown() then
      actionKey = actionKey .. 'Alt';
   end
   if IsControlKeyDown() then
      actionKey = actionKey .. 'Ctrl';
   end
   if IsShiftKeyDown() then
      actionKey = actionKey .. 'Shift';
   end
   if actionKey == "" then
      actionKey = 'None';
   end
   return actionKey;
end


--***************************************************************************
--***************************************************************************
function CastParty.Event.OnClick(_button, _subTargetClicked)
   local unit = nil;
   local id   = nil;

   CastParty.Debug( 1, 'parent frame:', this:GetName())

   if _subTargetClicked then
      CastParty.Debug(1, 'sub target frame clicked!')

      local _unit
      for _, _unit in CP_units do
         if UnitName(_unit)
         and UnitName(this.unit)
         and string.find(UnitName(_unit), UnitName(this.unit))
         and not UnitIsUnit(_unit, 'target') then
            unit = _unit;
         end
      end

      if not unit then
         TargetUnit(CP_units[this:GetParent():GetID()]..'target');
         return;
      end

      id = CP_ids[unit];
   else
      if not _ext_unit_id then
         id = this:GetID();
         unit = CP_units[id];
      else
         unit = _ext_unit_id;
         id = CP_ids[unit];
      end
   end

   CastParty.Debug( 1, 'OnClick', id, _button)

   if not (unit or id) then
      CastParty.Debug( 3, 'no unit or id for CastParty.Event.OnClick')
      return;
   end

   CastParty.Debug( 1, 'clicked unit:', unit)
   CastParty.Debug( 1, 'clicked unitID:', id)

   if type(CastParty_CustomOnClickFunction) == 'function' then
      CastParty_CustomOnClickFunction(_button, unit);
      return;
   end

   -- if a spell is already targeting, cast it on the clicked player and return
   if SpellIsTargeting() then
      if _button == 'LeftButton' then
         SpellTargetUnit(unit);
         return;
      elseif _button == 'RightButton' then
         SpellStopTargeting();
         return;
      end
      if CastParty_UpdateUnitPing and not _subTargetClicked then
         CastParty_UpdateUnitPing(1, id);
      end
   end

   -- always take care of items on cursor with left clicks
   if _button == 'LeftButton' and CursorHasItem() then
      if unit == 'player' then
         AutoEquipCursorItem();
      else
         DropItemOnUnit(unit);
      end
      return;
   end

   local actionKey = CastParty_BuildActionKey();
   local action = nil

   CastParty.Debug( 1, 'action key', actionKey)

   if CastPartyConfig.key_bindings[_button][actionKey] then
      action = CastPartyConfig.key_bindings[_button][actionKey];
   end

   CastParty.Debug( 1, 'action', action)
   
   if not action then
      CastParty.Debug(1, 'no action provided for that keystroke combination')
      return
   end

   if not _subTargetClicked then
      -- it's the 'default' click
      if action == 'CastParty_WoWDefaultClick' then
         if _button == 'LeftButton' then
            TargetUnit(unit)
         else
            CastParty_PartyDropDown()
         end
      end
   end
   
   if CastParty.Healomatic[action] then
      CastParty.Debug( 1, 'standard healomatic action, calling CastParty.Healomatic.'..action..'('..unit..')')
      CastParty.Healomatic[action](unit);
      return
   end
   
   -- execute a function action
   if type(action) == 'function' or (_subTargetClicked and type(action) == 'function' and string.find(action, 'yDropD')) then
      CastParty.Debug( 1, 'standard action!!')
      action(unit);
      return;
   end

   -- lookup a global function action
   local action_global = getglobal(action);
   CastParty.Debug(3, 'Searching for function '..tostring(action)..' in the global namespace: '..tostring(action_global))
   if type(action_global) == 'function' then
      CastParty.Debug( 1, 'global standard action!!')
      action_global(unit);
      return;
   end

   -- cast a particular spell
   if CastParty.Brain.spell_ids[action] then
      CastParty.Debug( 2, 'casting specific spell found in spell_ids')
      -- if we have another friendly unit targeted that is not the clicked player, we need
      -- to target the clicked player first, and then retarget right before we return

      CastParty.State.spell_target_unit = unit;
      CastParty.State.spell_being_cast  = CastParty.Brain.spell_ids[action];

      if CastParty_UpdateUnitPing and not _subTargetClicked then
         CastParty_UpdateUnitPing(1, id);
      end

      CastParty_Retarget(unit);

      CastSpell(CastParty.State.spell_being_cast.id, SpellBookFrame.bookType);
      SpellTargetUnit(unit);

      CastParty_Retarget('SET');
      return;
   end

   -- cast the best of a particular spell series
   
   --TODO: some of this logic is similar to CastParty_CastBuff, maybe look at merging --pb
   if CastParty.Brain.best_spell_ids[action] then
      CastParty.Debug( 2, 'casting best spell', CastParty.Brain.best_spell_ids[action].name, CastParty.Brain.best_spell_ids[action].rank)
      
      -- if we have another friendly unit targeted that is not the clicked player, we need
      -- to target the clicked player first, then retarget right before we return

      CastParty.State.spell_target_unit = unit;

      -- if a buff is chosen, cap the rank based on the spell target level
      if CastParty.Brain.class_buffs and CastParty.Brain.class_buffs[action] then
         CastParty.State.spell_being_cast = CastParty.Brain.spell_ids[CastParty_ChooseBuffRank(unit, action)];
      -- else the spell isn't in the class_buffs table, and the logic is different
      else
         CastParty.State.spell_being_cast  = CastParty.Brain.best_spell_ids[action];
      end

      if CastParty_UpdateUnitPing and not _subTargetClicked then
         CastParty_UpdateUnitPing(1, id);
      end
      
      if not CastParty.State.spell_being_cast then
         CastParty.Debug(4, RED..'Failed to find spell to cast:', action)
         return;
      end

      CastParty_Retarget(unit);

      CastSpell(CastParty.State.spell_being_cast.id, SpellBookFrame.bookType);
      SpellTargetUnit(unit);

      CastParty_Retarget('SET');

      return;
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_PartyDropDown()
   local frameName = this:GetName();
   local unit
   local id
   local isCustomFrame
   
   CastParty.Debug(2, 'fn:'..frameName)

   if (string.sub(frameName, 1, 4) == 'Nurf') then  -- Nurfed Unit Frames
      unit = this.unit;
      id   = CP_ids[unit];
      isCustomFrame = true;
   elseif (string.sub(frameName, 1, 10) == 'CastPartyM') then -- CastParty Unit Frames
      id   = this:GetID();
      unit = CP_units[id];
      isCustomFrame = true;
   elseif (string.sub(frameName, 1, 5) == 'CT_RA') then
      unit = _ext_unit_id;
      id   = CP_ids[_ext_unit_id];
      isCustomFrame = true; -- use CT_RA dropdown, but CP heal-clicks
      --don't want a dropdown on the MT or PT targets. that's just silly!
      if string.find(frameName, 'Group') and (string.find(frameName, 'MT') or string.find(frameName, 'PT')) then
         return;
      end
   else
      isCustomFrame = false;
   end


   -- if we are casparty or nurfed frames!
   if isCustomFrame then
      if id == 0 then  --it's ME!
         CastParty.Debug( 1, 'Player DropDown', unit)
         ToggleDropDownMenu(1, nil, getglobal('PlayerFrameDropDown'), 'cursor')
      elseif id == 90 then --it's the target frame
         CastParty.Debug( 1, 'Target DropDown', unit)
         ToggleDropDownMenu(1, nil, getglobal('TargetFrameDropDown'), 'cursor')
      else
         --we are a pet... bring up the pet frame.
         if id == 45 then
            CastParty.Debug( 1, 'Pet DropDown', unit)
            ToggleDropDownMenu(1, nil, getglobal('PetFrameDropDown'), 'cursor')
         elseif id > 45 and id < 50 then
            CastParty.Debug( 1, 'PartyPet DropDown', unit)
            -- there is no dropdown for partymember pet frames anymore?
            --ToggleDropDownMenu(1, nil, getglobal('PartyMemberFramePetFrame'.. mod(id, 45) ..'DropDown'), 'cursor')
         elseif id < 5 then  --else it's not a pet
            CastParty.Debug( 1, 'Party DropDown', unit)
            ToggleDropDownMenu(1, nil, getglobal('PartyMemberFrame'..id..'DropDown'), 'cursor')
         elseif (id >= 5 and id < 45) or (id >= 50 and id < 90 ) then  --else it's the raid member stuff...
            this.name = UnitName(unit);
            this.unit = unit;
            this.id   = id;
            CastParty.Debug( 1, 'Raid DropDown', unit)
            FriendsDropDown.initialize = RaidFrameDropDown_Initialize;
            FriendsDropDown.displayMode = 'MENU';
            ToggleDropDownMenu(1, nil, FriendsDropDown, 'cursor');
         end
      end
   else  --this must be the default frames then!!
      CastParty.Debug( 1, 'Normal_FrameDropDown', unit)
      if string.find(frameName, 'RaidPullout') then
         ToggleDropDownMenu(1, nil, getglobal(this:GetParent():GetParent():GetName()..'DropDown'), 'cursor');
      else --if string.find(frameName, 'Player') then
         ToggleDropDownMenu(1, nil, getglobal(frameName .. 'DropDown'), 'cursor');
      end
   end

end

