--
-- these need to be converted to tables at a later date, so we can insert and remove
-- I think this will go a long ways towards fixing all the CastPartyOption errors
-- when new features come out we can load then check for CastPartyConfig[optionname] == nil
-- much the way spells are done, this should help cut down on the corrupted savevaribals
-- and require less user interaction to get things right, I know people want to save
-- there tweeks, I think this one time fix, will be worth the complaints, to fix a long
-- standing complication just to get it to work correctly, also if we move to a table
-- format will no longer need CastPartyConfig.lua as CastPartyOptions will be able to
-- handle everything.  Also features should be able to be added to CastParty without
-- the need to update CastPartyOptions all the time, thus if CastPartyOptions lags
-- behind it simply means it won't be able to access all the data, but the data will
-- be there
--


--
-- tables
--

-- need to keep pets in second 1/2 of the list so that we don't have to recalulate offsets
-- depending on what were doing, +0 for players +45 for pets, and this will hold true
-- for what ever table were looking at, and target will always be 90

--not sure what to do exactly!
CP_monitor_units = {};

CP_units        = { [0] = 'player',    'party1',    'party2',    'party3',    'party4',
                           'raid1',     'raid2',     'raid3',     'raid4',     'raid5',
                           'raid6',     'raid7',     'raid8',     'raid9',    'raid10',
                          'raid11',    'raid12',    'raid13',    'raid14',    'raid15',
                          'raid16',    'raid17',    'raid18',    'raid19',    'raid20',
                          'raid21',    'raid22',    'raid23',    'raid24',    'raid25',
                          'raid26',    'raid27',    'raid28',    'raid29',    'raid30',
                          'raid31',    'raid32',    'raid33',    'raid34',    'raid35',
                          'raid36',    'raid37',    'raid38',    'raid39',    'raid40',
                             'pet', 'partypet1', 'partypet2', 'partypet3', 'partypet4',
                        'raidpet1',  'raidpet2',  'raidpet3',  'raidpet4',  'raidpet5',
                        'raidpet6',  'raidpet7',  'raidpet8',  'raidpet9', 'raidpet10',
                       'raidpet11', 'raidpet12', 'raidpet13', 'raidpet14', 'raidpet15',
                       'raidpet16', 'raidpet17', 'raidpet18', 'raidpet19', 'raidpet20',
                       'raidpet21', 'raidpet22', 'raidpet23', 'raidpet24', 'raidpet25',
                       'raidpet26', 'raidpet27', 'raidpet28', 'raidpet29', 'raidpet30',
                       'raidpet31', 'raidpet32', 'raidpet33', 'raidpet34', 'raidpet35',
                       'raidpet36', 'raidpet37', 'raidpet38', 'raidpet39', 'raidpet40',
                       'target'}

CP_ids          = {  player = 0,     party1 = 1,     party2 = 2,     party3 = 3,     party4 = 4,
                      raid1 = 5,      raid2 = 6,      raid3 = 7,      raid4 = 8,      raid5 = 9,
                      raid6 = 10,     raid7 = 11,     raid8 = 12,     raid9 = 13,    raid10 = 14,
                     raid11 = 15,    raid12 = 16,    raid13 = 17,    raid14 = 18,    raid15 = 19,
                     raid16 = 20,    raid17 = 21,    raid18 = 22,    raid19 = 23,    raid20 = 24,
                     raid21 = 25,    raid22 = 26,    raid23 = 27,    raid24 = 28,    raid25 = 29,
                     raid26 = 30,    raid27 = 31,    raid28 = 32,    raid29 = 33,    raid30 = 34,
                     raid31 = 35,    raid32 = 36,    raid33 = 37,    raid34 = 38,    raid35 = 39,
                     raid36 = 40,    raid37 = 41,    raid38 = 42,    raid39 = 43,    raid40 = 44,
                        pet = 45, partypet1 = 46, partypet2 = 47, partypet3 = 48, partypet4 = 49,
                   raidpet1 = 50,  raidpet2 = 51,  raidpet3 = 52,  raidpet4 = 53,  raidpet5 = 54,
                   raidpet6 = 55,  raidpet7 = 56,  raidpet8 = 57,  raidpet9 = 58, raidpet10 = 59,
                  raidpet11 = 60, raidpet12 = 61, raidpet13 = 62, raidpet14 = 63, raidpet15 = 64,
                  raidpet16 = 65, raidpet17 = 66, raidpet18 = 67, raidpet19 = 68, raidpet20 = 69,
                  raidpet21 = 70, raidpet22 = 71, raidpet23 = 72, raidpet24 = 73, raidpet25 = 74,
                  raidpet26 = 75, raidpet27 = 76, raidpet28 = 77, raidpet29 = 78, raidpet30 = 79,
                  raidpet31 = 80, raidpet32 = 81, raidpet33 = 82, raidpet34 = 83, raidpet35 = 84,
                  raidpet36 = 85, raidpet37 = 86, raidpet38 = 87, raidpet39 = 88, raidpet40 = 89,
                     target = 90}

CP_auras        = { player = {},    party1 = {},    party2 = {},    party3 = {},    party4 = {},
                     raid1 = {},     raid2 = {},     raid3 = {},     raid4 = {},     raid5 = {},
                     raid6 = {},     raid7 = {},     raid8 = {},     raid9 = {},    raid10 = {},
                    raid11 = {},    raid12 = {},    raid13 = {},    raid14 = {},    raid15 = {},
                    raid16 = {},    raid17 = {},    raid18 = {},    raid19 = {},    raid20 = {},
                    raid21 = {},    raid22 = {},    raid23 = {},    raid24 = {},    raid25 = {},
                    raid26 = {},    raid27 = {},    raid28 = {},    raid29 = {},    raid30 = {},
                    raid31 = {},    raid32 = {},    raid33 = {},    raid34 = {},    raid35 = {},
                    raid36 = {},    raid37 = {},    raid38 = {},    raid39 = {},    raid40 = {},
                       pet = {}, partypet1 = {}, partypet2 = {}, partypet3 = {}, partypet4 = {},
                  raidpet1 = {},  raidpet2 = {},  raidpet3 = {},  raidpet4 = {},  raidpet5 = {},
                  raidpet6 = {},  raidpet7 = {},  raidpet8 = {},  raidpet9 = {}, raidpet10 = {},
                 raidpet11 = {}, raidpet12 = {}, raidpet13 = {}, raidpet14 = {}, raidpet15 = {},
                 raidpet16 = {}, raidpet17 = {}, raidpet18 = {}, raidpet19 = {}, raidpet20 = {},
                 raidpet21 = {}, raidpet22 = {}, raidpet23 = {}, raidpet24 = {}, raidpet25 = {},
                 raidpet26 = {}, raidpet27 = {}, raidpet28 = {}, raidpet29 = {}, raidpet30 = {},
                 raidpet31 = {}, raidpet32 = {}, raidpet33 = {}, raidpet34 = {}, raidpet35 = {},
                 raidpet36 = {}, raidpet37 = {}, raidpet38 = {}, raidpet39 = {}, raidpet40 = {},
                    target = {}}

CastParty.State.ills = {
                    player = {},    party1 = {},    party2 = {},    party3 = {},    party4 = {},
                     raid1 = {},     raid2 = {},     raid3 = {},     raid4 = {},     raid5 = {},
                     raid6 = {},     raid7 = {},     raid8 = {},     raid9 = {},    raid10 = {},
                    raid11 = {},    raid12 = {},    raid13 = {},    raid14 = {},    raid15 = {},
                    raid16 = {},    raid17 = {},    raid18 = {},    raid19 = {},    raid20 = {},
                    raid21 = {},    raid22 = {},    raid23 = {},    raid24 = {},    raid25 = {},
                    raid26 = {},    raid27 = {},    raid28 = {},    raid29 = {},    raid30 = {},
                    raid31 = {},    raid32 = {},    raid33 = {},    raid34 = {},    raid35 = {},
                    raid36 = {},    raid37 = {},    raid38 = {},    raid39 = {},    raid40 = {},
                       pet = {}, partypet1 = {}, partypet2 = {}, partypet3 = {}, partypet4 = {},
                  raidpet1 = {},  raidpet2 = {},  raidpet3 = {},  raidpet4 = {},  raidpet5 = {},
                  raidpet6 = {},  raidpet7 = {},  raidpet8 = {},  raidpet9 = {}, raidpet10 = {},
                 raidpet11 = {}, raidpet12 = {}, raidpet13 = {}, raidpet14 = {}, raidpet15 = {},
                 raidpet16 = {}, raidpet17 = {}, raidpet18 = {}, raidpet19 = {}, raidpet20 = {},
                 raidpet21 = {}, raidpet22 = {}, raidpet23 = {}, raidpet24 = {}, raidpet25 = {},
                 raidpet26 = {}, raidpet27 = {}, raidpet28 = {}, raidpet29 = {}, raidpet30 = {},
                 raidpet31 = {}, raidpet32 = {}, raidpet33 = {}, raidpet34 = {}, raidpet35 = {},
                 raidpet36 = {}, raidpet37 = {}, raidpet38 = {}, raidpet39 = {}, raidpet40 = {},
                    target = {}}

CP_watched      = { player = {},    party1 = {},    party2 = {},    party3 = {},    party4 = {},
                     raid1 = {},     raid2 = {},     raid3 = {},     raid4 = {},     raid5 = {},
                     raid6 = {},     raid7 = {},     raid8 = {},     raid9 = {},    raid10 = {},
                    raid11 = {},    raid12 = {},    raid13 = {},    raid14 = {},    raid15 = {},
                    raid16 = {},    raid17 = {},    raid18 = {},    raid19 = {},    raid20 = {},
                    raid21 = {},    raid22 = {},    raid23 = {},    raid24 = {},    raid25 = {},
                    raid26 = {},    raid27 = {},    raid28 = {},    raid29 = {},    raid30 = {},
                    raid31 = {},    raid32 = {},    raid33 = {},    raid34 = {},    raid35 = {},
                    raid36 = {},    raid37 = {},    raid38 = {},    raid39 = {},    raid40 = {},
                       pet = {}, partypet1 = {}, partypet2 = {}, partypet3 = {}, partypet4 = {},
                  raidpet1 = {},  raidpet2 = {},  raidpet3 = {},  raidpet4 = {},  raidpet5 = {},
                  raidpet6 = {},  raidpet7 = {},  raidpet8 = {},  raidpet9 = {}, raidpet10 = {},
                 raidpet11 = {}, raidpet12 = {}, raidpet13 = {}, raidpet14 = {}, raidpet15 = {},
                 raidpet16 = {}, raidpet17 = {}, raidpet18 = {}, raidpet19 = {}, raidpet20 = {},
                 raidpet21 = {}, raidpet22 = {}, raidpet23 = {}, raidpet24 = {}, raidpet25 = {},
                 raidpet26 = {}, raidpet27 = {}, raidpet28 = {}, raidpet29 = {}, raidpet30 = {},
                 raidpet31 = {}, raidpet32 = {}, raidpet33 = {}, raidpet34 = {}, raidpet35 = {},
                 raidpet36 = {}, raidpet37 = {}, raidpet38 = {}, raidpet39 = {}, raidpet40 = {},
                    target = {}}

-- -----------------------
-- Miscellaneous Functions
-- -----------------------

-- fill in the Brain's heal_data table by iterating over spells in spellbook
-- and parsing tool tips for info
--
-- Currently used by:
--    _event_dispatch['SPELL_CHANGED'] = function ()
--    _event_dispatch['PLAYER_ENTERING_WORLD'] = function ()
--
--***************************************************************************
--***************************************************************************
function CastParty_LoadSpellData()
   local className = UnitClass('player');
   if not className then
      return false;
   end
   
   CastParty.Debug(3, "loading spell data")
   if CastParty and CastParty.Brain and CastParty.Brain.ReloadSpellData then
     CastParty.Debug(3, "loading namespace spell data")
     --local tt = GetTime()
     --note(tt)
     local loaded = CastParty.Brain.ReloadSpellData()
     --note(GetTime()-tt)
     --note(loaded)
     if loaded then
       return true
     end
   else
     CastParty.Debug(4, "unable to load spell data for: "..className)
     if not CastParty then
       CastParty.Debug(4, "CastParty is nil")
     elseif not CastParty.Brain then
       CastParty.Debug(4, "CastParty.Brain is nil")
     elseif not CastParty.Brain.ReloadSpellData then
       CastParty.Debug(4, "CastParty.Brain.ReloadSpellData is nil")
     end
   end
   CastParty.Debug(4, "class-specific LoadSpellData failed, using legacy load")
   
   note(RED.. "Not loading legacy spell data, you need a brain for ".. className.. "!!");
   --local t = GetTime();
   --note(t)
   
   return true;
end

