local	vCursorX, vCursorY
local	vCenterX, vCenterY
local	vMinimapCenterX, vMinimapCe

local alphaValueFlashy = 1;
local alphaValueBattle = 1;
local increasingValueFlashy = false;
local increasingValueBattle = false;
local IsDragging = false;

local	vCursorDeltaX
local	vCursorDeltaY
local	vAngle
local	vRadius = 80;

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_OnLoad()
	this:RegisterForDrag('LeftButton');
	this:RegisterForClicks('LeftButtonUp', 'RightButtonUp');
	this:SetFrameLevel(this:GetFrameLevel()+1);
end

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_OnEnter(_manualUpdate)
	if ( not GameTooltip:IsOwned(this) and CastPartyConfig) or _manualUpdate then
		GameTooltip:SetOwner(this, 'ANCHOR_BOTTOMLEFT')
      GameTooltip:ClearLines();

		GameTooltip:AddLine( TOOLTIP_MAPDRAGICON );

		if CastPartyConfig.locked then
		   GameTooltip:AddLine( TOOLTIP_MAP21DRAGICON, 1, 1, 1, 1, 1 );
         GameTooltip:AddLine( TOOLTIP_MAP41DRAGICON, 1, 1, 1, 1, 1 );

		else
		   GameTooltip:AddLine( TOOLTIP_MAP22DRAGICON, 1, 1, 1, 1, 1 );
		   GameTooltip:AddLine( TOOLTIP_MAP42DRAGICON, 1, 1, 1, 1, 1 );
		end

		if this.doFlashTheFlashyButton then
         GameTooltip:ClearLines();
		   GameTooltip:AddLine( TOOLTIP_MAPDRAGICON );
         GameTooltip:AddLine( TOOLTIP_MAP32DRAGICON, 1, 1, 1, 1, 1 );
      else
         GameTooltip:AddLine( TOOLTIP_MAP31DRAGICON, 1, 1, 1, 1, 1 );
		end

      GameTooltip:Show();
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_OnMouseDown()
   -- Remember where the cursor was in case the user drags
	vCursorX, vCursorY = GetCursorPosition();

	vCursorX = vCursorX / this:GetEffectiveScale();
	vCursorY = vCursorY / this:GetEffectiveScale();

	CastPartyMinimapButton.CursorStartX = vCursorX;
	CastPartyMinimapButton.CursorStartY = vCursorY;

	vCenterX, vCenterY = CastPartyMinimapButton:GetCenter();
	vMinimapCenterX, vMinimapCenterY = Minimap:GetCenter();

	CastPartyMinimapButton.CenterStartX = vCenterX - vMinimapCenterX;
   CastPartyMinimapButton.CenterStartY = vCenterY - vMinimapCenterY;
end

--***************************************************************************
--***************************************************************************
-- This toggles if I want to heal by clicking on people on the battlefield!!!
function CastParty_ToggleBattleFieldHeal()
   if CastPartyConfig.useBattlefieldHeal then
      CastPartyConfig.useBattlefieldHeal = false;
      CastPartyMinimapButtonBattleFlashy:Hide();
   else
      CastPartyConfig.useBattlefieldHeal = true;
      CastPartyMinimapButtonBattleFlashy:Show();
   end
end

--***************************************************************************
--***************************************************************************
-- This toggles if I want to use the max rank of a heal NO MATTER WHAT!!!
function CastParty_ToggleMaxRankHeal()
   if CastPartyConfig.useMaxRankNoMatterWhat then
      CastPartyConfig.useMaxRankNoMatterWhat = false;
      CastPartyMinimapButtonFlashy:Hide();
   else
      CastPartyConfig.useMaxRankNoMatterWhat = true;
      CastPartyMinimapButtonFlashy:Show();
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_OnMouseUp()

   if arg1 == 'RightButton' then
	   CastPartyConfig.locked = not CastPartyConfig.locked;
      CastParty.GUI.Init();
      if CastParty_GUI_Init then
         CastParty_GUI_Init();
         local frame;
         for k,v in pairs(CP_units) do
            frame = getglobal('CastPartyMember' .. k);
            if frame then
               frame.forceUpdate = true;
            end
         end
      end

	elseif ( CastPartyChangeOption and (CastPartyOptions:IsVisible() or CastPartyKeyBindingsFrame:IsVisible()) ) then
		CastPartyOptionsCloseButton:Click();
		CastPartyKeyBindingsFrameCloseButton:Click();

   elseif EzDismount_onload and EzDismount_Menu:IsVisible() then
      EzDismount_Menu:Hide();

   --this is so I can toggle on/off the MAX RANK HEAL option.
   elseif IsControlKeyDown() or IsShiftKeyDown() then
      if IsControlKeyDown() then
         CastParty_ToggleMaxRankHeal();
      end
      --this is so I can toggle on/off the BATTLEFIELD HEAL option.
      if IsShiftKeyDown() then
         CastParty_ToggleBattleFieldHeal();
      end
   else
      CastParty.Event.OnSlashCmd(nil);
   end
	CastParty_MinimapButton_OnEnter(true);
	PlaySound('igMainMenuOptionCheckBoxOn');
end

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_DragStart()
	if not CastPartyConfig.locked then
	   IsDragging = true;
	end
end

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_DragEnd()
	IsDragging = false;
end


--***************************************************************************
--***************************************************************************
function CastParty_UpdateMinimapButton()
   if IsDragging then
      CastParty_MinimapButton_UpdateDragPosition();
   end

   if CastPartyConfig.useMaxRankNoMatterWhat then
      if increasingValueFlashy then
         alphaValueFlashy = alphaValueFlashy + .02;
      else
         alphaValueFlashy = alphaValueFlashy - .02;
      end

      if alphaValueFlashy > 1 then
         increasingValueFlashy = false
      elseif alphaValueFlashy < .3 then
         increasingValueFlashy = true;
      end
      CastPartyMinimapButtonFlashy:SetAlpha(alphaValueFlashy);
   end

   if CastPartyConfig.useBattlefieldHeal then
      if increasingValueBattle then
         alphaValueBattle = alphaValueBattle + .02;
      else
         alphaValueBattle = alphaValueBattle - .02;
      end

      if alphaValueBattle > 1 then
         increasingValueBattle = false
      elseif alphaValueBattle < .3 then
         increasingValueBattle = true;
      end
      CastPartyMinimapButtonBattleFlashy:SetAlpha(alphaValueBattle);
   end
end


function CastParty_UpdateFlashy()
   if CastPartyConfig.useMaxRankNoMatterWhat then
      CastPartyMinimapButtonFlashy:Show();
   else
      CastPartyMinimapButtonFlashy:Hide();
   end

   if CastPartyConfig.useBattlefieldHeal then
      CastPartyMinimapButtonBattleFlashy:Show();
   else
      CastPartyMinimapButtonBattleFlashy:Hide();
   end
end


--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_UpdateDragPosition()
   -- Hacked up from Outfitter on curse! I know they didn't invent this concept, but, they are the only
   -- ones i could find who do it!
	-- Remember where the cursor was in case the user drags
	vCursorX, vCursorY = GetCursorPosition();

	vCursorX = vCursorX / this:GetEffectiveScale();
	vCursorY = vCursorY / this:GetEffectiveScale();


	vCursorDeltaX = vCursorX - CastPartyMinimapButton.CursorStartX;
	vCursorDeltaY = vCursorY - CastPartyMinimapButton.CursorStartY;

	--

	vCenterX = CastPartyMinimapButton.CenterStartX + vCursorDeltaX;
	vCenterY = CastPartyMinimapButton.CenterStartY + vCursorDeltaY;

	-- Calculate the angle

	vAngle = math.atan2(vCenterX, vCenterY);

	-- Set the new position

	CastParty_MinimapButton_SetPositionAngle(vAngle);
end

--***************************************************************************
--***************************************************************************
function CastParty_MinimapButton_SetPositionAngle(pAngle)
	vAngle = pAngle;

	if not vAngle then
	   vAngle = 90;
	end

	vCenterX = math.sin(vAngle) * vRadius;
	vCenterY = math.cos(vAngle) * vRadius;

	CastPartyMinimapButton:SetPoint('CENTER', 'Minimap', 'CENTER', vCenterX - 1, vCenterY - 1);

	CastPartyConfig.MinimapButtonAngle = vAngle;
end