--[[***************************************************************************
*
*                        Works with MobInfo2 v2.81
*                          Optimized by Skeeve
*
***************************************************************************]]--
local llife = 100;
local refreshAllowed = 0;


-- tables for interpolating health of targets outside the group
local _class_health = {
   ['DRUID']   = { ['1'] = 30, ['60'] = 4000 },
   ['MAGE']    = { ['1'] = 30, ['60'] = 3000 },
   ['HUNTER']  = { ['1'] = 30, ['60'] = 4000 },
   ['PALADIN'] = { ['1'] = 30, ['60'] = 4500 },
   ['PRIEST']  = { ['1'] = 30, ['60'] = 3000 },
   ['ROGUE']   = { ['1'] = 30, ['60'] = 4000 },
   ['SHAMAN']  = { ['1'] = 30, ['60'] = 4800 },
   ['WARLOCK'] = { ['1'] = 30, ['60'] = 4000 },
   ['WARRIOR'] = { ['1'] = 30, ['60'] = 6000 },
}

if not CastParty then CastParty = {} end
CastParty.MobHealth = {}

function CastParty.MobHealth.GetTargetMaxHP()
   if  MI2_Target and MI2_Target.index  then
      if  refreshAllowed > 0  then
         llife = MI2_Target.maxHealth;
         refreshAllowed = refreshAllowed - 1;
      end
      if llife then
         return llife;
      end
   end
   return 100;
--~    --use interpolation if nothing else!
--~    local _,targetClass = UnitClass('target');
--~    local unitLevel = UnitLevel('target');

--~    if unitLevel < 0 then
--~       unitLevel = 70;
--~    end

--~    local targetHealthMax   = unitLevel * (( _class_health[targetClass]['60'] - _class_health[targetClass]['1'] ) / 59) + _class_health[targetClass]['1'];

--~    if CastParty_Debug then CastParty_Debug( 1, 'interpolate class', targetClass, 'level', unitLevel, 'percent', _unitHealthPercent, 'targetHealthMax', targetHealthMax ) end;
--~    --health = (targetHealthMax * _unitHealthPercent / 100) -- removed so i don't create so many vars!!
--~    return targetHealthMax;
end


function CastParty.MobHealth.GetTargetCurHP()
   if  MI2_Target and MI2_Target.index  then
      if MI2_Target.curHealth then
         return MI2_Target.curHealth;
      end
   end

return 0
--~    --use interpolation if nothing else!
--~    local _,targetClass = UnitClass('target');
--~    local unitLevel = UnitLevel('target');

--~    if unitLevel < 0 then
--~       unitLevel = 70;
--~    end

--~    local targetHealthMax   = unitLevel * (( _class_health[targetClass]['60'] - _class_health[targetClass]['1'] ) / 59) + _class_health[targetClass]['1'];

--~    if CastParty_Debug then CastParty_Debug( 1, 'interpolate class', targetClass, 'level', unitLevel, 'percent', CP_UnitHealth('target'), 'health', (targetHealthMax * _unitHealthPercent / 100) , 'targetHealthMax', targetHealthMax ) end;
--~    --health = (targetHealthMax * _unitHealthPercent / 100) -- removed so i don't create so many vars!!
--~    return (targetHealthMax * CP_UnitHealth('target') / 100);


--~    return UnitHealth('target') or 0;
end


function CastParty.MobHealth.SetCurTarget()
   if UnitName('target') then
     -- did the user JUST now select this target?
     -- this is used to display a stable health_max.
     -- I am going to allow 4 changes to the max health before I stop showing changes.
     refreshAllowed = 4;
   end
end


function CP_UnitHealth(_unit)
   if _unit then
      return UnitHealth(_unit) or 1;
   else
      --fail case for no unitCP_UnitHealth
      return 1;
   end
end


--~    if (_unit == 'target') then
--~       return CastParty.MobHealth.GetTargetCurHP();
--~    else

--~       -- check to see if we can see there health, if not take a guess
--~       if not (UnitIsUnit('player', _unit) or UnitInGroup(_unit)) and (CP_UnitHealthMax(_unit) and UnitHealthMax(_unit) == 100) then
--~          if CastParty_Debug then CastParty_Debug( 1, 'Applyheal check for in unit false or healthMax = 100', _unit ) end;
--~          if UnitIsUnit('target', _unit) then
--~             return CastParty.MobHealth.GetTargetCurHP();
--~          end
--~       end
--~       return UnitHealth(_unit);
--~    end
--~ end


function CP_UnitHealthMax(_unit)
   if _unit then
      return UnitHealthMax(_unit) or 100;
   else
      --fail case for no unitCP_UnitHealth
      return 100;
   end
end

function CP_UnitMana(_unit)
   if not _unit then return 1 end
   return UnitMana(_unit) or 1;
end

function CP_UnitManaMax(_unit)
   if not _unit then return 100 end
   return UnitManaMax(_unit) or 100;
end


--~    -- check to see if we can see there health, if not take a guess
--~    if not (UnitIsUnit('player', _unit) or UnitInGroup(_unit)) and (UnitHealthMax(_unit) and UnitHealthMax(_unit) == 100) then
--~       if CastParty_Debug then CastParty_Debug( 1, 'Applyheal check for in unit false or healthMax = 100', _unit ) end;
--~       if UnitIsUnit('target', _unit) then
--~          return CastParty.MobHealth.GetTargetMaxHP();
--~       end
--~    end
--~    return UnitHealthMax(_unit);
--~ end




--***************************************************************************
--***************************************************************************
-- interpolates the health of the given unit (used for those outside the party)
-- should make this function a local it does not leave the file.  Also there is
-- a point in the forums about a better function to replace this one, has anyone
-- tested it, how does it work out?  Should this be replaced?
--
-- Currently used by:
--    DoTheRightThing
--    _event_dispatch['UNIT_HEALTH'] = function (unit)
--
function CastParty_UnitInterpolateHealth(_unit, _unitHealthPercent)
   CastParty.Debug( 1, 'interpolating health values!')

   -- use MobInfo2 Data if available.
   if CastParty.MobHealth.GetTargetCurHP() > 0 and CastParty.MobHealth.GetTargetMaxHP() ~= 100 then
--~       note(RED..CastParty.MobHealth.GetTargetCurHP())
--~       note(YEL..CastParty.MobHealth.GetTargetMaxHP())
      return (CastParty.MobHealth.GetTargetMaxHP() * _unitHealthPercent), CastParty.MobHealth.GetTargetMaxHP();

   --use interpolation if nothing else!
   else
      local _,targetClass = UnitClass(_unit);
      local unitLevel = UnitLevel(_unit);
      local targetHealthMax   = unitLevel * (( _class_health[targetClass]['60'] - _class_health[targetClass]['1'] ) / 59) + _class_health[targetClass]['1'];

      CastParty.Debug( 1, 'interpolate class', targetClass, 'level', unitLevel, 'percent', _unitHealthPercent, 'health', (targetHealthMax * _unitHealthPercent / 100) , 'targetHealthMax', targetHealthMax )
      --health = (targetHealthMax * _unitHealthPercent / 100) -- removed so i don't create so many vars!!
      return (targetHealthMax * _unitHealthPercent / 100), targetHealthMax;
   end
end