
if not CastParty then CastParty = {} end
CastParty.Profiler = {}
CastParty.Profiler.Data = {}

--***************************************************************************
--***************************************************************************
-- used for profile the event code

function CastParty.Profiler.Print()
   local totalTime = 0;
   local totalMem  = 0;
   local key, value
   
   note(WHT.."::::::::");
   note(RED..'Printing out the Statistics for CastParty!!');
   note(WHT.."::::::::");
   for key, value in CastParty.Profiler.Data do
      note(WHT..key)
      note(GRY..'        ' .. value.numberOfRuns .. ' times.');
      note(GRY..'        ' .. string.format('%.5f', value.runTime) .. ' seconds total.')
      note(GRY..'        ' .. string.format('%.5f', value.runTime / value.numberOfRuns) .. ' average seconds.')
      note(GRY..'        ' .. string.format('%.5f', value.memUsed/1024) .. ' Kb used.')
      note(GRY..'        ' .. string.format('%.5f', (value.memUsed/1024) / value.numberOfRuns) .. ' average Kb used.')
      totalTime = totalTime + value.runTime;
      totalMem = totalMem + value.memUsed/1024;
   end
   note(WHT.."::::::::");
   note(RED..'Total statistics for CastParty!!');
   note(WHT.."::::::::");
   note(GRY..'        ' .. string.format('%.5f', totalTime) .. ' seconds total.')
   note(GRY..'        ' .. string.format('%.5f', totalMem) .. ' Kb used.')
end

-- Don't call this outside the profiler. Call Start or Stop
function CastParty.Profiler.Init(event)
   if not CastParty.Profiler.Data[event] then
      CastParty.Profiler.Data[event] = {};
      CastParty.Profiler.Data[event].numberOfRuns = 0;
      CastParty.Profiler.Data[event].runTime      = 0;
      CastParty.Profiler.Data[event].memUsed      = 0;
      CastParty.Profiler.Data[event].startTime    = 0;
      CastParty.Profiler.Data[event].startMem     = 0;
   end

   return GetTime(), gcinfo();
end


function CastParty.Profiler.Start(event)
   local currentTime
   local currentMem
   currentTime, currentMem = CastParty.Profiler.Init(event)

   CastParty.Profiler.Data[event].numberOfRuns = CastParty.Profiler.Data[event].numberOfRuns + 1;
   CastParty.Profiler.Data[event].startTime = currentTime;
   CastParty.Profiler.Data[event].startMem  = currentMem;
end


function CastParty.Profiler.Stop(event)
   local currentTime
   local currentMem
   currentTime, currentMem = CastParty.Profiler.Init(event)

   local deltaTime = currentTime - CastParty.Profiler.Data[event].startTime;
   local deltaMem  = currentMem  - CastParty.Profiler.Data[event].startMem;

   CastParty.Profiler.Data[event].runTime = CastParty.Profiler.Data[event].runTime + deltaTime;
   CastParty.Profiler.Data[event].memUsed = CastParty.Profiler.Data[event].memUsed + deltaMem;
end
