--[[
Here the CastParty namespace is defined with several important sub spaces
The main namespace is CastParty, which should eventually contain
all the functions, variables, tables, and logic of the addon.

CastParty.Event contains functions named for each event this addon handles
]]

CastParty = {} -- Has all the external binding handlers
CastParty.Event = {} -- Has WoW event handlers, named by the event
CastParty.Brain = {} -- Has all the logic for the class you entered the game as, or missing/empty functions
CastParty.State = {} -- Has all the state data, such as is-casting, is-attacking, current-target, etc.
CastParty.Healomatic = {} -- Has healing action spells and bandage data
CastParty.Config = {} -- Contains all player config information
CastParty.GUI = {} -- Functions in CP Core that do GUI-type stuff, such as clickery
CastParty.StoredHooks = {} -- Functions that CP hooked that we may need to revert to

CastPartySave = {} -- This table is written to saved variables

-- myAddOns support
CastParty.MyAddOnsData = {
   name         = 'CastParty',
   version      = CASTPARTY_VERSION,
   releaseDate  = '??/??/2006',
   author       = 'Zodeus, Nathan R., Paul B',
   email        = 'Zodeus@cox.net, nathanrobisnon@gmail.com',
   website      = 'http://wowcastparty.sourceforce.net',
   category     = MYADDONS_CATEGORY_COMBAT,
   optionsframe = 'CastPartyOptions',
}
