-- Make a class for Hunter-based constants and funcitonality
-- load this class when castparty starts and detects the player's class as Hunter
-- use an instance to call desired overloaded methods

local HUNTER_NAMESPACE = {} -- declare the namespace
CastParty.BrainFactory.HUNTER = HUNTER_NAMESPACE

--DEFAULT_CHAT_FRAME:AddMessage("loading brainHunter.lua")

function HUNTER_NAMESPACE.new()
  CastParty.Debug(4, "making a new Hunter brain")
  
  HUNTER_NAMESPACE.className = 'HUNTER'
  
  HUNTER_NAMESPACE.heal_types = {
      [CASTPARTY_HEAL_MEND_PET]               = 'efficient',
  }
  
  HUNTER_NAMESPACE.class_buffs = {
      [CASTPARTY_HEAL_MEND_PET]               = {1,1,1,1,1,1,1},
      --TODO: add non heal/shield buffs
  }
  
  HUNTER_NAMESPACE.spell_parsers = {
      [CASTPARTY_HEAL_MEND_PET]               = 1,
  }
  
  HUNTER_NAMESPACE.heal_multipliers = {
      [CASTPARTY_HEAL_MEND_PET]               = 5,
  }
  
  return HUNTER_NAMESPACE
end

--@Override
function HUNTER_NAMESPACE.ReloadSpellData()
  CastParty.Debug(1, "calling Hunter.ReloadSpellData")
  return CastParty.BrainBase.ReloadSpellData(HUNTER_NAMESPACE)
end

function HUNTER_NAMESPACE.GetHealAmount(spellEntry)
  --CastParty.Debug(1, 'calling Hunter.GetHealAmount')
  return CastParty.BrainBase.GetHealAmount(spellEntry, HUNTER_NAMESPACE);
end







