-- Make a class for Mage-based constants and funcitonality
-- load this class when castparty starts and detects the player's class as Mage
-- use an instance to call desired overloaded methods

local MAGE_NAMESPACE = {} -- declare the namespace
CastParty.BrainFactory.MAGE = MAGE_NAMESPACE

--DEFAULT_CHAT_FRAME:AddMessage("loading brainMage.lua")

function MAGE_NAMESPACE.new()
   CastParty.Debug(4, "making a new mage brain")
   
   MAGE_NAMESPACE.className = 'MAGE'
   
   MAGE_NAMESPACE.heal_types = {
      [CASTPARTY_BUFF_MANA_SHIELD]            = 'shield',
      [CASTPARTY_BUFF_ICE_BARRIER]            = 'shield',
   }
   
   MAGE_NAMESPACE.class_buffs = {
      [CASTPARTY_BUFF_MANA_SHIELD]            = {20,28,36,44,52,60},
      [CASTPARTY_BUFF_ICE_BARRIER]            = {40,46,52,58},
     
      -- non-heal/shield buffs
      [CASTPARTY_BUFF_ARCANE_INTELLECT]       = {1,14,28,42,56},
      [CASTPARTY_BUFF_FROST_ARMOR]            = {1,10,20},
      [CASTPARTY_BUFF_ICE_ARMOR]              = {30,40,50,60},
   }
   
   MAGE_NAMESPACE.spell_parsers = {
      [CASTPARTY_BUFF_MANA_SHIELD]            = 1,
      [CASTPARTY_BUFF_ICE_BARRIER]            = 1,
   }
   
   MAGE_NAMESPACE.cures = {
      { spell = CASTPARTY_CURE_CURSE_1,   cures = { CASTPARTY_AILMENT_CURSE   } },
      { spell = CASTPARTY_CURE_CURSE_2,   cures = { CASTPARTY_AILMENT_CURSE   } },
   }
   
   MAGE_NAMESPACE.default_key_bindings = {
     LeftButton  = {
        None              = 'TargetUnit',
        Shift             = 'AssistUnit',
        },
     RightButton = {
        None              = 'CureAny',
        Ctrl              = 'CastParty_PartyDropDown',
        Shift             = 'CureGroupMember',
        },
     MiddleButton  = {
        None              = 'Arcane Intellect',
        Alt               = 'Dampen Magic',
        Ctrl              = 'Amplify Magic',
        Shift             = 'ApplyBandage',
        },
     Button4 = {
        None              = 'TargetUnit',
        Shift             = 'CastParty_PartyDropDown',
        },
     Button5 = {
        None              = 'AssistUnit',
        },
   }
   
   
   return MAGE_NAMESPACE
end

--@Override
function MAGE_NAMESPACE.ReloadSpellData()
  CastParty.Debug(1, "calling mage.ReloadSpellData")
  return CastParty.BrainBase.ReloadSpellData(MAGE_NAMESPACE)
end

function MAGE_NAMESPACE.GetHealAmount(spellEntry)
  --CastParty.Debug(1, 'calling mage.GetHealAmount')
  return CastParty.BrainBase.GetHealAmount(spellEntry, MAGE_NAMESPACE);
end
