
--to save who was the last leader/master, so we know if we need to update our frames or not.
local previousPartyLeader = 'player';
local previousPartyMaster = 'player';

--save last pet happiness state.
local CastParty_Previous_Happiness_State = 0;

--save which aura we are on
local auraCount = 1;

local CP_COMBO_FRAME_LAST_NUM_POINTS = 0;
local _name;
local _rank;
local addBuff;
local addDebuff;
local alignBuff;
local alignDebuff;
local auraFrame;
local auraNewAnchor;
local bottom;
local buffExists;
local button;
local color;
local combatIcon;
local comboPoint;
local comboPointHighlight;
local comboPoints;
local coords;
local currentPartyLeader;
local damagePercentage;
local debuffCount;
local debuffCountIcon;
local debuffExists;
local doNotAdjust;
local factionGroup;
local fadeInfo;
local firstBuff;
local firstDebuff;
local found;
local frame;
local happiness;
local health;
local healthMax;
local healthPercent;
local healthRGB;
local healthbar;
local height;
local icon;
local index;
local indicator;
local left;
local lootMaster;
local lootMethod;
local loyaltyRate;
local mana;
local manaMax;
local manaPercent;
local manaPowerType;
local manaRGB;
local masterIcon;
local name;
local nameText;
local parentFrame;
local powerTypeIndex;
local previousPartyPet;
local raidNumber;
local rangeRGB;
local rank;
local right;
local size;
local spotBuff;
local spotDebuff;
local subgroup;
local tempButton;
local text;
local top;
local unit;
local unitBarText;
local unitClassification;
local unitName;
local unit_type;
local xff;
local yoff;
local coordIncrement;
local k;
local v;

--***************************************************************************
--***************************************************************************
local function CastParty_RGBtoRGB_Stub( _depletion, _full, _percentFull )
   -- * 2 to try to help with the brightness. this *should* result is *almost* the same color scheme as 3.2
   color = abs( _full - _depletion ) * 2
   if _full ~= _depletion then
      if _full > _depletion then
         color = color * _percentFull
      else
         color = color * (1 - _percentFull)
      end
      -- instead of just return color, this is to try to fix the brightness issues.
      return max(min(color, 1), 0)
   else
      return _full
   end
end

--***************************************************************************
--***************************************************************************
local function CastParty_RGBtoRGB( _depletion, _full, _percentFull )

   return { r = CastParty_RGBtoRGB_Stub( _depletion.r, _full.r, _percentFull ),
            g = CastParty_RGBtoRGB_Stub( _depletion.g, _full.g, _percentFull ),
            b = CastParty_RGBtoRGB_Stub( _depletion.b, _full.b, _percentFull )}
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateIdHealth(_id)
   if not _id then
      return;
   end

   --what to do when I'm the target frame...
   if _id == 90 and not CastPartyConfig.showTarget then
      return;
   end
   
   --CastParty.Debug(3, 'health updating')

   local frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      if CastParty_Debug then CastParty_Debug( 1, '<UpdateIdHealth> Frame doesnt exits!', _id) end;
      return;
   end;

   local unit = CP_units[_id];
   local nameText  = getglobal(frame:GetName() .. 'Name')
   local unitBarText

   if _id == 90 then
      unitBarText = CastPartyConfig.target_text_template;
   else
      unitBarText = CastPartyConfig.unit_text_template;
   end

   nameText:SetTextColor(CastPartyConfig.text_rgb.r, CastPartyConfig.text_rgb.g, CastPartyConfig.text_rgb.b);
   unitBarText = CastParty.FormatString( unitBarText, unit );
   nameText:SetText(unitBarText);

   local health    = CP_UnitHealth(unit);
   local healthMax = CP_UnitHealthMax(unit);

   -- don't process their health if they aren't there...
   if not ( health and healthMax ) or not UnitIsConnected(unit) then
      return;
   end

   --check to see if the healthmax is less that the unit health (which causes bugged frames...)
   if healthMax < health then
      healthMax = health;
   end

   frame.healthbar:SetMinMaxValues(0, healthMax);

   if CastPartyConfig.grow_with_depletion_health then
      frame.healthbar:SetValue(healthMax - health);
   else
      frame.healthbar:SetValue(health);
   end

   if healthMax > 0 then
      local healthPercent = health / healthMax;
      healthRGB = CastParty_RGBtoRGB(CastPartyConfig.bar_colors[10], CastPartyConfig.bar_colors[11], healthPercent);

      --tapped code to grey out the health...
      if UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) and _id == 90 then
         frame.healthbar:SetStatusBarColor( 0.9, 0.9, 0.9);
      else
         frame.healthbar:SetStatusBarColor( healthRGB.r, healthRGB.g, healthRGB.b);
      end
   end

end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateIdMana(_id)
   --CastParty.Debug(2, YEL..'update id mana')
   if not _id then
      return;
   end

   --what to do when I'm the target frame...
   if _id == 90 and not CastPartyConfig.showTarget then
      return;
   end

   local frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      if CastParty_Debug then CastParty_Debug( 1, '<UpdateIdMana> Frame doesnt exits!', _id) end;
      return;
   end;

   local unit = CP_units[_id];
   local nameText  = getglobal(frame:GetName() .. 'Name')
   local unitBarText

   if _id == 90 then
      unitBarText = CastPartyConfig.target_text_template;
   else
      unitBarText = CastPartyConfig.unit_text_template;
   end

   nameText:SetTextColor(CastPartyConfig.text_rgb.r, CastPartyConfig.text_rgb.g, CastPartyConfig.text_rgb.b);
   unitBarText = CastParty.FormatString( unitBarText, unit );
   nameText:SetText(unitBarText);

   if not UnitIsConnected(unit) then
      return;
   end

   --local mana_bar = getglobal('CastPartyMember' .. _id .. 'ManaBar')

   manaPowerType = UnitPowerType(unit);

   if manaPowerType == 0 or ( ( manaPowerType == 1 or manaPowerType == 2 or manaPowerType == 3) and CastPartyConfig.show_power ) then
      mana = UnitMana(unit)
      manaMax = UnitManaMax(unit)
      frame.manabar:SetMinMaxValues(0, manaMax)

      -- mana
      if manaPowerType == 0 then
         if CastPartyConfig.grow_with_depletion_mana then
            frame.manabar:SetValue(manaMax - mana);
         else
            frame.manabar:SetValue(mana);
         end
      -- rage
      elseif manaPowerType == 1 then
         if CastPartyConfig.grow_with_depletion_rage then
            frame.manabar:SetValue(manaMax - mana);
         else
            frame.manabar:SetValue(mana);
         end
       -- focus
      elseif manaPowerType == 2 then
         if CastPartyConfig.grow_with_depletion_focus then
            frame.manabar:SetValue(manaMax - mana);
         else
            frame.manabar:SetValue(mana);
         end
      -- energy
      else
         if CastPartyConfig.grow_with_depletion_energy then
            frame.manabar:SetValue(manaMax - mana);
         else
            frame.manabar:SetValue(mana);
         end
      end

      if manaMax > 0 then
         powerTypeIndex = manaPowerType * 2;
         manaPercent = mana / manaMax;
         manaRGB = CastParty_RGBtoRGB(CastPartyConfig.bar_colors[powerTypeIndex], CastPartyConfig.bar_colors[powerTypeIndex + 1], manaPercent);

         --tapped code to grey out the health...
         if UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) and _id == 90 then
            frame.manabar:SetStatusBarColor( 0.9, 0.9, 0.9);
         else
            frame.manabar:SetStatusBarColor( manaRGB.r, manaRGB.g, manaRGB.b);
         end
      end
   else

      --this is if we have no clue what their mana type is...
      healthMax = CP_UnitHealthMax(unit);
      health = CP_UnitHealth(unit);
      frame.manabar:SetMinMaxValues(0, healthMax);

      if CastPartyConfig.grow_with_depletion_health then
         frame.manabar:SetValue(healthMax - health);
      else
         frame.manabar:SetValue(health);
      end

      if healthMax > 0 then
         healthPercent = health / healthMax;
         healthRGB = CastParty_RGBtoRGB(CastPartyConfig.bar_colors[10], CastPartyConfig.bar_colors[11], healthPercent);
         --tapped code to grey out the health...
         if UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) and _id == 90 then
            frame.manabar:SetStatusBarColor( 0.9, 0.9, 0.9);
         else
            frame.manabar:SetStatusBarColor( healthRGB.r, healthRGB.g, healthRGB.b);
         end
      end
   end

   if _id == 90 then
      CastParty_Target_Tap();
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateId(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      CastParty.Debug( 1, '<UpdateID> Frame doesnt exits!', _id)
      return;
   end;

   unit = CP_units[_id];

   --if CastParty_Debug then CastParty_Debug( 1, '<UpdateID>', _id) end;

   --what to do for target!!
   if not CastPartyConfig.showTarget and _id == 90 then
      frame:Hide();
      return;
   end

   --what to do for player!!
   if not CastPartyConfig.showPlayer and (_id == 0 or _id == 45) then
      frame:SetScript('OnUpdate', nil );
      frame:Hide();
      return;
   end

   --what to do for the party frame...
   if not CastPartyConfig.showParty and ((_id >= 1 and _id <= 4) or ( _id > 45 and _id <= 49)) then
      frame:SetScript('OnUpdate', nil );
      frame:Hide();
      return;
   end

   --show or hide the parent drag frame icons!
   if not CastPartyConfig.locked then --and
     --( _id ~= 90 and UnitExists(CP_units[(frame:GetParent():GetID())] ) or
     --( _id == 90 and UnitExists('target')) ) or
     --( _id == 0 ) then
      getglobal(frame:GetParent():GetName() .. 'Drag'):Show();
   else
      getglobal(frame:GetParent():GetName() .. 'Drag'):Hide();
   end

   if not UnitIsConnected(unit) then
      frame:SetAlpha(0.5,0.5,0.5);
      frame.healthbar:SetStatusBarColor(0.5,0.5,0.5);
      frame.healthbarbg:SetStatusBarColor(0.5,0.5,0.5);
      frame.manabar:SetStatusBarColor(0.5,0.5,0.5);
      frame.manabarbg:SetStatusBarColor(0.5,0.5,0.5);
   else
      frame:SetAlpha(1.0,1.0,1.0);
      frame:SetScript('OnUpdate', CP_Template_OnUpdate);
   end

   frame:Show();

   --set the size for the pet frames...
   if _id >= 45 and _id <= 89 then
      size = 1.5;
   else
      size = 1;
   end

   --set the size of the frame
   frame:SetWidth(CastPartyConfig.bar_width / size);
   frame:SetHeight((CastPartyConfig.health_bar_height + CastPartyConfig.mana_bar_height) / size);

   --show/hide the status bar frame
   if CastPartyConfig.show_statusbar_frames then
      frame.texture:SetWidth( frame:GetWidth() + 8);
      frame.texture:SetHeight( frame:GetHeight() + 8);
      frame.texture:Show();
   else
      frame.texture:Hide();
   end

   --setup the health bar
   frame.healthbar:SetWidth( frame:GetWidth() );
   frame.healthbar:SetHeight(CastPartyConfig.health_bar_height / size);
   frame.healthbar:SetFrameLevel(3);

   --setup the health bar background
   frame.healthbarbg:SetWidth( frame:GetWidth() );
   frame.healthbarbg:SetHeight(CastPartyConfig.health_bar_height / size);
   frame.healthbarbg:SetStatusBarColor( CastPartyConfig.health_bg_rgb.r, CastPartyConfig.health_bg_rgb.g, CastPartyConfig.health_bg_rgb.b, CastPartyConfig.health_bg_rgb.a);
   frame.healthbarbg:SetFrameLevel(2);

   --setup the mana bar
   frame.manabar:SetWidth( frame:GetWidth() );
   frame.manabar:SetHeight(CastPartyConfig.mana_bar_height / size);
   frame.manabar:SetFrameLevel(3);

   --setup the mana bar background
   frame.manabarbg:SetWidth( frame:GetWidth() );
   frame.manabarbg:SetHeight(CastPartyConfig.mana_bar_height / size);
   frame.manabarbg:SetStatusBarColor( CastPartyConfig.mana_bg_rgb.r, CastPartyConfig.mana_bg_rgb.g, CastPartyConfig.mana_bg_rgb.b, CastPartyConfig.mana_bg_rgb.a);
   frame.manabarbg:SetFrameLevel(2);

end

--***************************************************************************
--***************************************************************************
function CastParty_PlaceFrames(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);
   unit = CP_units[_id];

   --if it's me
   if _id == 0 then
   CastParty_PlacePlayerFrame(_id)

   --if it's anyone else besides me (player's only)
   elseif _id > 0 and _id < 45 then
      CastParty_PlacePlayerFrame(_id)

   --if it's a pet
   elseif _id > 44 and _id < 90 then
      CastParty_PlacePetFrame(_id)

   --it must be the target frame
   else
      if not UnitExists(unit) then
         --this makes sure that if there is no target, then the frame is hidden.
         frame:Hide()
         frame.range = 0;
         CastParty_UpdateRangeDisplay(90, true);
         --don't get rid of the OnUpdate for the target frame!
      else
         --display the leader icon if the target is the leader.
         icon = getglobal('CastPartyMember90LeaderIcon');
         if ( CastPartyConfig.show_flags and UnitIsPartyLeader('target') ) then
   			icon:Show();
   		else
   			icon:Hide();
   		end
   		--display the master looter icon if the target is that
   		masterIcon = getglobal('CastPartyMember90MasterIcon');
         lootMethod, lootMaster = GetLootMethod();
         if ( CastPartyConfig.show_flags and _id == lootMaster ) then
            masterIcon:Show();
         else
            masterIcon:Hide();
         end
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_PlacePlayerFrame(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);
   unit = CP_units[_id];

   if not frame then
      if CastParty_Debug then CastParty_Debug( 1, '<PlacePlayerFrame> Frame doesnt exits!', unit) end;
      return;
   end;

   --hide the buttons that shouldn't be there. (this only applies for player frames, as pet frames are handled elsewhere.)
   if not UnitExists(unit) then
     frame:Hide();
     frame.range = -1;
     --I need to REMOVE the OnUpdate code, so that I can MAKE SURE that only created frames UPDATE!
     frame:SetScript('OnUpdate', nil);
     return;
   end

   icon = getglobal('CastPartyMember'.._id..'LeaderIcon');
   if UnitIsPartyLeader(unit) then
      icon:Show();
   else
      icon:Hide();
   end

   if _id == 0 or _id == 1 or _id == 5 or _id == 90 then
      return
   end


   height = 0;

   height = 8 * CastPartyConfig.frameSpacing * CastPartyConfig.frameSpacing;

   if CastPartyConfig.buff_alignment == CASTPARTY_ALIGNMENT_BELOW or CastPartyConfig.debuff_alignment == CASTPARTY_ALIGNMENT_BELOW then
      height = height + 22;
   end

   if frame.showSubTarget then
      height = height + 15;
   end

   --so we know what pet to look at when we display the frames
   if CastPartyConfig.flow_up then
      num = 45;
   else
      num = 44;
   end

   previousPartyPet = getglobal('CastPartyMember' .. _id+num);
   if CastPartyConfig.pet_alignment == CASTPARTY_ALIGNMENT_BELOW and previousPartyPet and previousPartyPet:IsVisible() and UnitExists(CP_units[previousPartyPet:GetID()]) then
      height = height + 16

      if CastPartyConfig.pet_buff_alignment == CASTPARTY_ALIGNMENT_BELOW or CastPartyConfig.pet_debuff_alignment == CASTPARTY_ALIGNMENT_BELOW then
         height = height + 14
      end
   end

   doNotAdjust = false;

   --set what the parent frame is
   if _id == 0 or _id == 1 or _id == 5 or _id == 90 then
      height = 0;
      doNotAdjust = true;
      parentFrame = frame:GetParent();
   else
      --now is the tricky part.
      --if the frame above it ISN'T visible, then check the one above that, etc... on up, unitl we get to the parent frame.
      --this is so I can show whatever monitor members I want, and they will all be in a nice column, instead of all spread out.

      if _id>=5 then  --this is for the raid monitor frame...
         --this is when everything is nice and in order!
         if getglobal('CastPartyMember' .. (_id - 1)):IsVisible() then
            parentFrame = 'CastPartyMember' .. (_id - 1);
         else
            --this is when there are gaps in the frames...
            for i=_id-1, 5, -1 do
               if getglobal('CastPartyMember' .. i):IsVisible() then
                  parentFrame = 'CastPartyMember' .. i;
               else
                  parentFrame = frame:GetParent();
               end
            end
         end
      else
         parentFrame = 'CastPartyMember' .. (_id - 1);
      end
   end

   frame:ClearAllPoints();
   frame:Show();

   if CastPartyConfig.flow_up and not doNotAdjust then
      frame:SetPoint('BOTTOMLEFT', parentFrame, 'TOPLEFT', 0, height)
   else
      frame:SetPoint('TOPLEFT', parentFrame, 'BOTTOMLEFT', 0, 0-height)
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_PlacePetFrame(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);
   parentFrame = getglobal('CastPartyMember' .. _id-45);

   unit = CP_units[_id];

   if not frame then
      if CastParty_Debug then CastParty_Debug( 1, '<PlacePetFrame> Frame doesnt exits!', unit) end;
      return;
   end;

   frame:ClearAllPoints();
   frame:Show();

   if CastPartyConfig.pet_alignment == CASTPARTY_ALIGNMENT_HIDE or
      not UnitExists(unit) or
      not parentFrame:IsVisible() or
      _id ~= parentFrame.pet
   then
      frame:Hide();
      frame.range = -1;
      --I need to REMOVE the OnUpdate code, so that I can MAKE SURE that only created frames UPDATE!
      frame:SetScript('OnUpdate', nil);
   elseif CastPartyConfig.pet_alignment == CASTPARTY_ALIGNMENT_BELOW then
      height = 4;

      --have to move the pet frame down to make space for player auras
      if CastPartyConfig.buff_alignment == CASTPARTY_ALIGNMENT_BELOW or CastPartyConfig.debuff_alignment == CASTPARTY_ALIGNMENT_BELOW then
         height = height + 22;
      end

      frame:SetPoint('TOPRIGHT', 'CastPartyMember' .. _id-45, 'BOTTOMRIGHT', 0, 0-height)

   elseif CastPartyConfig.pet_alignment == CASTPARTY_ALIGNMENT_RIGHT then
      frame:SetPoint('LEFT', 'CastPartyMember' .. _id-45, 'RIGHT', 30, 0);

   elseif CastPartyConfig.pet_alignment == CASTPARTY_ALIGNMENT_LEFT then
      frame:SetPoint('RIGHT', 'CastPartyMember' .. _id-45, 'LEFT', -30, 0);
   end

   --so we know what player to look at when we run forceUpdate on the frames
   if CastPartyConfig.flow_up then
      num = 45;
   else
      num = 44;
   end

   --attach the bottom frame to the right spot. frame is to fix the frame overlap that can occur..
   tempButton = getglobal('CastPartyMember' .. _id-num);
   if tempButton then
      --now we also have to bump up the frame below me...
      tempButton.forceUpdate = true;
   end
end


--***************************************************************************
--***************************************************************************
-- to make readability easier
local function findName(iconName, myString)
   return myString and string.find(iconName, myString)
end

--***************************************************************************
--***************************************************************************
-- called by Update_Auras. this was abstracted some, because this deals with displaying the frames,
-- and Update_Auras deals with just updating the table with the proper data.
--the modification (removal of the localauras table) is an attempt to lessen the impact this has on memory!
function CastParty_DisplayAuras(_id)

   --CastParty.Debug(1, RED.."id is:".._id)
   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      --if CastParty_Debug then CastParty_Debug(3, '<DisplayAuras> Frame doesn't exits!', unit, 'aura event for non displayed frame!') end;
      return;
   end;

   unit = CP_units[_id];

   --set what aura number we are on.
   auraCount = 1;

   --need to add ALL the contents of the CP_watched[unit] table to the beginning of the localAuras table.
   --this is to have the pet happiness icon, as well as the watched icons.
   -- don't want to do this when the unit is dead!!!
   if not UnitIsDeadOrGhost(unit) then
      for k,v in pairs(CP_watched[unit]) do
         --i really only want to add it if it's a watched buff, and the aura ISN'T there... If it IS there... then, don't insert it!
         --loop through the auras, and see if our aura is there. if not, then insert it, else don't!
         found = false;
         --if CastParty_Debug then CastParty_Debug(2, 'searching for match ', v.name) end;
         for k2, v2 in pairs(CP_auras[unit]) do
            -- check for presence of aura
            if v.name == v2.name then
               --if CastParty_Debug then CastParty_Debug(2,'found match!',v2.name) end;
               found = true;
            end
         end
         if not found then
            --if CastParty_Debug then CastParty_Debug(2, 'not found!', v.name) end;
            --now set each the aura to the right one..
            v.show = true;
            CastParty_ActualAuraDisplayCode(_id, auraCount, v);
            auraCount = auraCount + 1;
         end
      end
   end

   --loop through the auras, to see if we want to add it or not..
   -- default to true....
   for _,v in pairs(CP_auras[unit]) do

      local iconName = "";
      local kk,vv
      for kk,vv in pairs(v) do
        --CastParty.Debug(2, BLU.. "v:".. tostring(kk).. "::"..tostring(vv))
      end

      if v.name then
         iconName = string.sub(v.icon, 17, string.len(v.icon));  --this is because there are MANY types of food/drink/mounts, and doing the names for all of them would SUCK!

         if CastParty_Debug then CastParty_Debug(1, 'name check '.. iconName.." : ".. tostring(v.type)) end;

         addDebuff = false;
         addBuff   = false;
         
         -- CastParty.Debug(1, BLU.. "debuff index: ".. tostring(v.debuff_index))

         if v.debuff_index then
            -- don't show debuffs that have a nil type, or we can't cure
            if v.type and CastParty.Brain.curables[v.type] then
               if (CastParty.Brain.className == 'SHAMAN' and v.type == 'Magic') then
                  addDebuff = false;
               else
                  addDebuff = true;
               end
            end

            -- but always show buffs for the target.
            if _id == 90 then
               addDebuff = true;

            -- but always show Weakened Soul for a Priest
            elseif findName(iconName, 'oAsh') then
               if CastParty.Brain.className == 'PRIEST' then
                  addDebuff = true;
               end

            -- normal debuffs to add.
            elseif findName(iconName, 'hSc') or  -- rez sick buff
               findName(iconName, 'ty_V') or     -- ghost icon
               findName(iconName, 'c_Les') or    -- honorless target
               findName(iconName, 'ndV') or      -- mindvision
               findName(iconName, 'hD')          -- itch (turns into a poison eventually)
            then
               addDebuff = true;

            --common debuffs
            elseif (findName(iconName, 'geBl') or  --mortal strike
                    findName(iconName, 'ge_08') or -- the first aid debuff icon.
                    findName(iconName, 'age_08')) and  -- recently bandaged
                    CastPartyConfig.show_common_buffs
               then
                  addDebuff = true;
            end

            if CastPartyConfig.show_debuffs then
               if CastPartyConfig.filter_debuffs then
                  if addDebuff then
                     v.show = true;
                  end
               else
                  v.show = true;
               end
            end
         end

         -- CastParty.Debug(1, BLU.. "buff index: "..tostring(v.buff_index))
         if v.buff_index then
            -- CastParty.Debug(1, GRN.. "isbuff ".. tostring(CastParty.Brain.best_spell_ids[v.name]) )
            if CastParty.Brain.best_spell_ids[v.name] then
               addBuff = true;
            end

            -- CastParty.Debug(1, GRN.. "add? ".. tostring(addBuff));
            -- but always show buffs for the target.
            if _id == 90 then
               addBuff = true;

            -- always show innervate, divine intervention
            elseif (findName(iconName, 're_Lig') and not
                    (findName(iconName, 'Bolt') and
                     findName(iconName, 'Shield'))) or --innervate...
                    findName(iconName, 'imeSt') -- divine intervention
               then
                  addBuff = true;

            -- always show ancestral fortitude and inspiration and Totems for our Shaman
            elseif (CastParty.Brain.className == 'SHAMAN') and
                   ((findName(iconName, 'll_N') and  -- find the two parts that are in our shaman totem spells.
                     findName(iconName, 'Tot') or    -- most totems
                     findName(iconName, 'Bri') or    -- Tranquil air totem
                     findName(iconName, 'Bin')       -- Windwall Totem
                    ) or
                    (findName(iconName, 'll_F') and
                     findName(iconName, 'Tot') or    -- Fire, frost totems.
                     findName(iconName, 'Sum')       -- mana tide totem
                    ) or
                    findName(iconName, 'pear_04')   -- Healing Stream Totem
                    or 
                    findName(iconName, 'yingStr') -- anc.fortitude (Spell_Nature_UndyingStrength)
                    or
                    findName(iconName, 'Shield_06') -- inspiration (INV_Shield_06)
                    ) 
               then
                  addBuff = true;

            -- but always show all shields (and fear ward) for a Priest/Paladin
            elseif (findName(iconName, 'rdSh') or   -- power word shield
                    findName(iconName, 'lOfP') or   -- blessing of protection
                    findName(iconName, 'ctLe') or   -- mana shield
                    findName(iconName, 'e_Lam') or  -- ice barrier
                    findName(iconName, 'y_Rest') or -- divine protection
                    findName(iconName, 'eInter') or -- divine shield
                    (findName(iconName, 'y_Exc') and not findName(iconName, '02'))) and -- fear ward
                    (CastParty.Brain.className == 'PRIEST' or CastParty.Brain.className == 'PALADIN')
               then
                  addBuff = true;

            --show all the hots
            elseif (findName(iconName, 'y_Ren') or -- renew
                    findName(iconName, 'onLi') or  -- lightwell renew
                    findName(iconName, 'e_Rej') or -- rejuvenation
                    findName(iconName, 'istNa') or -- regrowth
                    (findName(iconName, 'y_He') and not
                     (findName(iconName, '02') and
                      findName(iconName, 'Aura') and
                      findName(iconName, 'Focus')))) and -- first aid buff
                     CastPartyConfig.show_hots
               then
                  addBuff = true;

            --common buffs.
            elseif (findName(iconName, '_Fo') or         --all possbile food buffs
                    findName(iconName, '_Dri') or        --all possible drink buffs
                    findName(iconName, '_Mount_') or     --all mount types
                    findName(iconName, 'tTr')) and       --feed pet icon on the pet.
                    CastPartyConfig.show_common_buffs
               then
                  addBuff = true;
            end
            
            -- CastParty.Debug(1, GRN.. "show? ".. tostring(v.show))
            

            if CastPartyConfig.show_buffs then
               -- CastParty.Debug(1, GRN.. "showing ")
               if CastPartyConfig.filter_buffs then
                  -- CastParty.Debug(1, GRN.. "filtering ")
                  if addBuff then
                     -- CastParty.Debug(1, GRN.. "showing2 ")
                     v.show = true;
                  end
               else
                  -- CastParty.Debug(1, GRN.. "showing3 ")
                  v.show = true;
               end
            end
            -- CastParty.Debug(1, GRN.. "show 2? ".. tostring(v.show))
         end
      end
   end


   for index = 1, CastPartyConfig.max_auras do
     -- if CastParty_Debug then CastParty_Debug( 1, 'parsing', 'aura', unit, auraCount, index, CP_auras[unit][index].icon) end;
      CastParty_ActualAuraDisplayCode(_id, auraCount, CP_auras[unit][index] );
      auraCount = auraCount + 1;
   end

   CastParty_MoveAuras(_id);
end



--***************************************************************************
--***************************************************************************
function CastParty_ActualAuraDisplayCode(_id, _i, _v)

   if not _id then
      return;
   end

   auraFrame = getglobal('CastPartyMember' .. _id .. 'Aura' .. _i);
   unit = CP_units[_id];
   if ( _v and _v.show ) then
      -- if CastParty_Debug then CastParty_Debug( 1, 'aura', unit, _i, _v.icon) end;
      --insert the pet happiness icon here...
      if _v.pet_happiness then
         auraFrame.name = 'pet_happiness';
         auraFrame.pet_happiness = pet_happiness;
         auraFrame.tooltip = _v.tooltip;
         auraFrame.tooltipDamage = _v.tooltipDamage;
         auraFrame.tooltipLoyalty = _v.tooltipLoyalty;

         coords = _v.coords;
         getglobal(auraFrame:GetName() .. 'Icon'):SetTexture(_v.icon);
         getglobal(auraFrame:GetName() .. 'Icon'):SetTexCoord(coords[0], coords[1], coords[2], coords[3]);
         getglobal(auraFrame:GetName() .. 'Overlay'):SetTexture();
         getglobal(auraFrame:GetName() .. 'Overlay'):SetVertexColor(1,1,1);

         auraFrame:SetScale(.95);
         --to reset the frame status to normal (instead of watched status)
         getglobal(auraFrame:GetName() .. 'Count'):Hide();
         auraFrame:SetAlpha(1);
         getglobal(auraFrame:GetName() .. 'Icon'):SetVertexColor(1,1,1);
         auraFrame.show = _v.show;
         auraFrame:Show();
      else
         getglobal(auraFrame:GetName() .. 'Icon'):SetTexture(_v.icon)
         getglobal(auraFrame:GetName() .. 'Icon'):SetTexCoord(0, 1, 0, 1);
         getglobal(auraFrame:GetName() .. 'Overlay'):SetTexture(_v.overlay);
         getglobal(auraFrame:GetName() .. 'Overlay'):SetVertexColor(1,1,1);
         debuffCount = _v.debuffCount;
         debuffCountIcon = getglobal(auraFrame:GetName() .. 'Count');
         if ( debuffCount and debuffCount > 1 ) then
            debuffCountIcon:SetText(debuffCount);
            debuffCountIcon:Show();
         else
            debuffCountIcon:Hide();
         end
         auraFrame:SetScale(1);
         auraFrame:Show();

         if not _v.watching and CP_watched[unit] and CP_watched[unit][_v.name] then
            if debuffCount > 1 then
               debuffCountIcon:SetText(debuffCount);
            else
               debuffCountIcon:SetText('+');
            end
            getglobal(auraFrame:GetName() .. 'Overlay'):SetVertexColor(0,1,0);
            debuffCountIcon:Show();
         end
         if _v.watching then
            getglobal(auraFrame:GetName() .. 'Icon'):SetVertexColor(1,0,0);
--               auraFrame:SetAlpha(.5);
         else
--               auraFrame:SetAlpha(1);
            getglobal(auraFrame:GetName() .. 'Icon'):SetVertexColor(1,1,1);
         end
         auraFrame.watching   = _v.watching;
         auraFrame.icon       = _v.icon;
         auraFrame.overlay    = _v.overlay;
         auraFrame.buff_index = _v.buff_index;
         auraFrame.debuff_index = _v.debuff_index;
         auraFrame.debuffCount  = _v.debuffCount;
         auraFrame.name       = _v.name;
         auraFrame.show       = _v.show;
         auraFrame.buffFilter = _v.buffFilter;
      end
   else
      if auraFrame then
         auraFrame.watching   = false;
         auraFrame.icon       = "";
         auraFrame.overlay    = "";
         auraFrame.debuff_index = nil;
         auraFrame.buff_index   = nil;
         auraFrame.debuffCount  = 0;
         auraFrame.name       = "";
         auraFrame.show       = false;
         auraFrame:Hide();
         getglobal(auraFrame:GetName() .. 'Count'):Hide();
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_MoveAuras(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      if CastParty_Debug then CastParty_Debug( 3, '<MoveAuras> Frame doesnt exits!', CP_units[_id]) end;
      return;
   end;

   if _id < 45 then
      alignBuff = CastPartyConfig.buff_alignment
      alignDebuff = CastPartyConfig.debuff_alignment
   elseif _id < 90 then
      alignBuff = CastPartyConfig.pet_buff_alignment
      alignDebuff = CastPartyConfig.pet_debuff_alignment
   else --(force the target frame to have the auras on the bottom. This is a much better idea than having them on top.
      alignBuff = CASTPARTY_ALIGNMENT_BELOW
      alignDebuff = CASTPARTY_ALIGNMENT_BELOW
   end

   -- move auras
   unit_type = CP_units[_id]
   auraFrame = getglobal(frame:GetName() .. 'Aura1');

   firstDebuff = frame;
   firstBuff   = frame;

   spotDebuff = { 'TOPLEFT', 'BOTTOMLEFT', -3};
   spotBuff   = { 'TOPLEFT', 'BOTTOMLEFT', -3};

   buffExists = false;
   debuffExists = false;

   for index = 1, CastPartyConfig.max_auras do
      auraFrame = getglobal(frame:GetName() .. 'Aura' .. index);
      if auraFrame.show then
         --if CastParty_Debug then CastParty_Debug( 3, '<MoveAuras>'.._id..' Fiddling with ', index, 'shown?', auraFrame.show) end;
         if ( auraFrame:IsVisible() ) then
            auraFrame:ClearAllPoints();
            --this is a debuff!!!
            if ( auraFrame.debuff_index or auraFrame.watching ) then
               --moving the frames around!
               if alignDebuff == CASTPARTY_ALIGNMENT_BELOW then
                  auraFrame:SetPoint(spotDebuff[1], firstDebuff, spotDebuff[2] , 0, spotDebuff[3])
               elseif alignDebuff == CASTPARTY_ALIGNMENT_LEFT then
                  auraFrame:SetPoint('RIGHT', firstDebuff, 'LEFT', -2, 0)
               elseif alignDebuff == CASTPARTY_ALIGNMENT_RIGHT then
                  auraFrame:SetPoint('LEFT', firstDebuff, 'RIGHT', 2, 0)
               end
               firstDebuff = getglobal(frame:GetName() .. 'Aura' .. index);
               spotDebuff[1] = 'LEFT';
               spotDebuff[2] = 'RIGHT';
               spotDebuff[3] = 0;
               debuffExists = true;
               --logic for counting debuffs, and arranging them in a ?x8 grid
               --ONLY for the target frame, as we can display a LOT
               --also, the auras are FORCED to be below the frame
               if _id == 90 then
                  if mod(index, 8) == 1 then
                     auraNewAnchor = auraFrame;
                  end
                  if  mod(index, 8) == 0 then
                     firstDebuff = auraNewAnchor;
                     spotDebuff[1] = 'TOPLEFT';
                     spotDebuff[2] = 'BOTTOMLEFT';
                     spotDebuff[3] = -3;
                  end
               end
            else
               --moving the frames around!
               if alignBuff == CASTPARTY_ALIGNMENT_BELOW then
                  auraFrame:SetPoint(spotBuff[1], firstBuff, spotBuff[2], 1, spotBuff[3])
               elseif alignBuff == CASTPARTY_ALIGNMENT_LEFT then
                  auraFrame:SetPoint('RIGHT', firstBuff, 'LEFT', -1, 0)
               elseif alignBuff == CASTPARTY_ALIGNMENT_RIGHT then
                  auraFrame:SetPoint('LEFT', firstBuff, 'RIGHT', 1, 0)
               end
               firstBuff = getglobal(frame:GetName() .. 'Aura' .. index);
               spotBuff[1] = 'LEFT';
               spotBuff[2] = 'RIGHT';
               spotBuff[3] = 0;
               --logic for counting buffs, and arranging them in a ?x8 grid
               --ONLY for the target frame, as we can display a LOT
               --also, the auras are FORCED to be below the frame
                if _id == 90 and not debuffExists then
                  if mod(index, 8) == 1 then
                     auraNewAnchor = auraFrame;
                  end
                  if  mod(index, 8) == 0 then
                     firstBuff = auraNewAnchor;
                     spotBuff[1] = 'TOPLEFT';
                     spotBuff[2] = 'BOTTOMLEFT';
                     spotBuff[3] = -3;
                  end
               end
               if auraFrame.buff_index then
                  buffExists = true;
               end
            end
            --need to check now if de-buffs and buffs are in the same spot.
            if debuffExists and not buffExists and (alignDebuff == alignBuff) then
               firstBuff = firstDebuff;
               spotBuff  = spotDebuff;
            end
         end
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_Target_CheckClassification()

   --this only happens with the target frame...
   frame = getglobal('CastPartyMember90');

   unitClassification = UnitClassification('target');
   if ( unitClassification == 'worldboss' ) then
      frame.status:SetTexture('Interface\\Addons\\CastPartyGUI\\Images\\elite');
      frame.status:Show();
   elseif ( unitClassification == 'rareelite'  ) then
      frame.status:SetTexture('Interface\\Addons\\CastPartyGUI\\Images\\elite');
      frame.status:Show();
   elseif ( unitClassification == 'elite'  ) then
      frame.status:SetTexture('Interface\\Addons\\CastPartyGUI\\Images\\elite');
      frame.status:Show();
   elseif ( unitClassification == 'rare'  ) then
      frame.status:SetTexture('Interface\\Addons\\CastPartyGUI\\Images\\rare');
      frame.status:Show();
   else
      frame.status:Hide()
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateCombatStatus(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      if CastParty_Debug then CastParty_Debug( 3, '<PlacePlayerFrame> Frame doesnt exits!', _id) end;
      return;
   end;

   unit = CP_units[_id];

   combatIcon = getglobal('CastPartyMember'.._id..'CombatIcon');

   if (  CastPartyConfig.show_flags and UnitAffectingCombat(unit) ) then
      combatIcon:Show();
   else
      combatIcon:Hide();
   end
   frame.combatTime = GetTime();
end

--***************************************************************************
--***************************************************************************
local function updateMasterIcon(_id)

   if not _id then
      return;
   end

   lootMethod, lootMaster = GetLootMethod();
   masterIcon = getglobal('CastPartyMember'.._id..'MasterIcon');
   if not masterIcon then
      if CastParty_Debug then CastParty_Debug( 3, '<UpdateMasterStatus> Frame doesnt exits!', _id) end;
      return;
   end;
   if ( CastPartyConfig.show_flags and _id == lootMaster ) then
      masterIcon:Show();
   else
      masterIcon:Hide();
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateMasterStatus()

   currentPartyMaster = previousPartyMaster;
   lootMethod, lootMaster = GetLootMethod();

   if UnitExists(previousPartyMaster) and lootMaster and lootMaster ~= CP_ids[previousPartyMaster] then
      currentPartyMaster = CP_units[lootMaster];
   end


   if previousPartyMaster == currentPartyMaster then
--      if CastParty_Debug then CastParty_Debug( 2, 'No change, Current Master', currentPartyMaster) end;
      updateMasterIcon(CP_ids[currentPartyMaster]);
   else
      -- if wow is not quick enough in clearing flags, sometimes both previous
      -- leader and current leader as asked to update, both will have party crowns
--      if CastParty_Debug then CastParty_Debug( 2, 'Changed, Old master', previousPartyMaster, 'new master', currentPartyMaster ) end;
      updateMasterIcon(CP_ids[currentPartyMaster]);
      updateMasterIcon(CP_ids[previousPartyMaster]);
      previousPartyMaster = currentPartyMaster;
   end
end

--***************************************************************************
--***************************************************************************
local function updateLeaderIcon(_unit)

   if not _unit or (_unit and not CP_ids[_unit]) then
      return;
   end

   icon = getglobal('CastPartyMember'..CP_ids[_unit]..'LeaderIcon');
   if not icon then
      if CastParty_Debug then CastParty_Debug( 1, '<UpdateLeaderStatus> Frame doesnt exits!', _unit) end;
      return;
   end;
   --because i now have this even delayed, everything is reporting correctly. :)
   -- it used to be all messed up.
   if( CastPartyConfig.show_flags and UnitIsPartyLeader(_unit)) then
      icon:Show();
   else
      icon:Hide();
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateLeaderStatus()

   -- There is some (reported) SERIOUS lag occuring here! People reported that this will cause WoW to
   -- freeze for like 5-10 seconds...

   -- I need to add a frame limiter here, so this will ONLY be called once per second. The only
   -- thing I can think of is that, in large groups, I am calling updateMember (so I'm looping
   -- through every memeber) and then here, I'm looping AGAIN to see if it's been changed.

   -- so like... if there are N members in the raid/party, this funcion should not be called N times
   -- but sometimes it is (when someone - like raid2 - changes in a 30 man raid, because everyone shifts
   -- down in number.

   -- THEN, this loops though EACH one N times... I don't want to call the leader update N^N times, which is HUUUUGE!!!
   -- This is an attempt to fix that.

   --This will REALLY run the code ONE sec, AFTER the last update has been called,
   -- in the time frame of a second.
   updateLeaderStatusFlagTime = GetTime() + 1;
   CastParty.State.runReallyRunLeader         = true;
end


function CastParty_ReallyUpdateLeaderStatus()

   -- if it's the same dude, no reason to even TOUCH this code! This is hoping to save
   -- some time with update events, as this function gets called a lot.
   if UnitIsPartyLeader( currentPartyLeader ) then
      return;
   end

   currentPartyLeader = previousPartyLeader;

   if IsPartyLeader() then
      currentPartyLeader = 'player';
   else
      if GetPartyLeaderIndex() > 1 and GetPartyLeaderIndex() < 5 then
         currentPartyLeader = CP_ids[GetPartyMember(GetPartyLeaderIndex())];
      end
   end

   --if this is some sort of false update, or the leader for some reason doesn't exist at all.
   if currentPartyLeader == null then
      currentPartyLeader = previousPartyLeader;
   end


   if previousPartyLeader == currentPartyLeader then
      --if CastParty_Debug the CastParty_Debug( 2, 'No change, Current Leader', currentPartyLeader) end;
      -- be sure to update the party leader, this will casue a rare case of the leader
      -- not being updated, if not placed here, the problem will clear itself eventualy
      -- if this is not called.
      updateLeaderIcon(currentPartyLeader);
   else
      -- if wow is not quick enough in clearing flags, sometimes both previous
      -- leader and current leader as asked to update, both will have party crowns
      --if CastParty_Debug then CastParty_Debug( 2, 'Changed, Old leader', previousPartyLeader, 'new Leader', currentPartyLeader ) end;
      updateLeaderIcon(currentPartyLeader);
      updateLeaderIcon(previousPartyLeader);
      previousPartyLeader = currentPartyLeader;
   end

   --now always check and update the target too!!! (cause it can happen..)
   -- TODO: this runs CONSTANTLY.. need to optimize this to run every 2 seconds...
   if UnitExists('target') and UnitIsFriend('target', 'player') then
      updateLeaderIcon('target');
   end

-- old raid code..
--   index = 0;
--   raidNumber = GetNumRaidMembers();
--   --check and update the raid...
--   if raidNumber > 0 then
--      -- we are in a raid
--         for i = 1,raidNumber do
--            _name, _rank = GetRaidRosterInfo(i);
--            if _rank == 2 then
--               --note('found leader'..i);
--               currentPartyLeader = 'raid'..i;
--               break;
--            end
--      end
--   end

end


--***************************************************************************
--***************************************************************************
function CastParty_UpdatePvPStatus(_id)

   if not _id then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);
   if not frame then
--      if CastParty_Debug then CastParty_Debug( 3, '<UpdatePvPStatus> Frame doesn't exits!', _id) end;
      return;
   end;
   unit = CP_units[_id];

   icon = getglobal('CastPartyMember' .. _id .. 'PVPIcon');
   factionGroup = UnitFactionGroup(unit);
   if ( UnitIsPVPFreeForAll(unit) and CastPartyConfig.show_flags) then
      icon:SetTexture('Interface\\TargetingFrame\\UI-PVP-FFA');
      icon:Show();
   elseif ( factionGroup and UnitIsPVP(unit) and CastPartyConfig.show_flags) then
      icon:SetTexture('Interface\\GroupFrame\\UI-Group-PVP-'..factionGroup);
      icon:Show();
   else
      icon:Hide();
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateGroupIndicator()

   --who to anchor the group indicator to...
   frame = getglobal('CastPartyMember0');

   indicator = getglobal(frame:GetParent():GetName() .. 'GroupIndicator')

   numRaidMembers = GetNumRaidMembers();
   if ( numRaidMembers == 0 ) then
      indicator:Hide()
      return;
   end
   for i=1, MAX_RAID_MEMBERS do
      if ( i <= numRaidMembers ) then
         name, rank, subgroup = GetRaidRosterInfo(i);
         -- Set the player's group number indicator
         if ( name == UnitName('player') ) then
            frame:GetParent().subgroup = subgroup;
            local text = getglobal(indicator:GetName() .. 'Text');
            text:SetText(GROUP..' '..subgroup);
            indicator:SetPoint('BOTTOMLEFT',frame,'TOPLEFT')
            indicator:SetWidth(text:GetWidth()+37);
            indicator:Show();
         end
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateSubTarget(_id, updateSubSubTargetToo)

   if not _id then
      return;
   end

   if updateSubSubTargetToo then
      unit = CP_units[_id] .. 'targettarget';
   else
      unit = CP_units[_id] .. 'target';
   end

   --what to anchor the sub target indicator to...
   frame = getglobal('CastPartyMember' .. _id);

   --specify the components of the sub target frame indicator.
   if updateSubSubTargetToo then
      indicator = getglobal(frame:GetName() .. 'SubSubTarget');
   else
      indicator = getglobal(frame:GetName() .. 'SubTarget');
   end
   healthbar = getglobal(indicator:GetName() .. 'HealthBar');

   --get the name of the target's target...
   unitName = UnitName(unit);

   indicator.unit = unit;

   if updateSubSubTargetToo and not getglobal(frame:GetName() .. 'SubTarget'):IsShown() then
      indicator:Hide();
   end

   if not ((this.showSubTarget) and unitName and UnitExists(unit) ) then
--      if CastParty_Debug then CastParty_Debug(1, 'hiding sub target for ', _id , ' UNIT: ', unit) end;
      indicator:Hide();
      getglobal(frame:GetName() .. 'SubSubTarget'):Hide();
      return;
   end

   --set the frame level for the background
   getglobal(indicator:GetName() .. 'BG'):SetFrameLevel(1)

   text = getglobal(indicator:GetName() .. 'Text');
   text:SetText(unitName);

   --set the location size for the sub target indicator
   if updateSubSubTargetToo then
      indicator:SetPoint('BOTTOMLEFT',getglobal(frame:GetName()..'SubTarget'),'BOTTOMRIGHT', ((text:GetWidth()*-1)-20)/3, 0)
   else
      indicator:SetPoint('BOTTOMLEFT',frame,'TOPRIGHT', ((text:GetWidth()*-1)-20)/3, 0)
   end
   indicator:SetWidth(text:GetWidth()+20);

   --incase the width is too narrow... this will set a lower bound to its width
   if indicator:GetWidth() < 50 then
      indicator:SetWidth(50);
   end

   --set the size and frame level of the sub target health bar.
   healthbar:SetWidth( indicator:GetWidth()-4 )
   healthbar:SetHeight(CastPartyConfig.health_bar_height / 5)
   healthbar:SetFrameLevel(2)

   --do the health function thing, to determine the sub targets health, then display the bar in the right color...
   health = CP_UnitHealth(unit);
   healthMax = CP_UnitHealthMax(unit);

   --check to see if the healthmax is less that the unit health (which causes bugged frames...)
   if healthMax < health then
      healthMax = health;
   end

   healthbar:SetMinMaxValues(0, healthMax);

   if CastPartyConfig.grow_with_depletion_health then
      healthbar:SetValue(healthMax - health);
   else
      healthbar:SetValue(health);
   end

   if healthMax > 0 then
      healthPercent = health / healthMax;
      healthRGB = CastParty_RGBtoRGB(CastPartyConfig.bar_colors[10], CastPartyConfig.bar_colors[11], healthPercent);

      --tapped code to grey out the health...
      if UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) and _id == 90 then
         healthbar:SetStatusBarColor( 0.9, 0.9, 0.9);
      else
         healthbar:SetStatusBarColor( healthRGB.r, healthRGB.g, healthRGB.b);
      end

   end

   --now that everything is calculated, show it!!!
   indicator:Show();

   if this.showSubSubTarget and updateSubSubTargetToo == nil then
      CastParty_UpdateSubTarget(_id, true);
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_PetHappiness()
   --this is the pet happiness thing!
   happiness, damagePercentage, loyaltyRate = GetPetHappiness();

   --only need to change happiness, if it actually changed!
   -- this causes the events to lag somehow? i might need to remove this.
   if happiness == CastParty_Previous_Happiness_State then
      return;
   end

   CastParty_Previous_Happiness_State = happiness;
	if ( happiness == 1 ) then
		coords = {[0]=0.375, [1]=0.5625, [2]=0, [3]=0.359375};
	elseif ( happiness == 2 ) then
		coords = {[0]=0.1875, [1]=0.375, [2]=0, [3]=0.359375};
	elseif ( happiness == 3 ) then
		coords = {[0]=0, [1]=0.1875, [2]=0, [3]=0.359375};
	end
	if ( loyaltyRate < 0 ) then
		tooltipLoyalty = getglobal('LOSING_LOYALTY');
	elseif ( loyaltyRate > 0 ) then
		tooltipLoyalty = getglobal('GAINING_LOYALTY');
	else
		tooltipLoyalty = "";
	end

   if happiness then
     if CastParty_Debug then CastParty_Debug(2, 'we have pet happines!') end;
      CP_watched['pet']['pet_happiness'] =
         {
           icon = 'Interface\\PetPaperDollFrame\\UI-PetHappiness',
           pet_happiness = happiness,
           coords = coords;
           name = 'pet_happiness';
           tooltip = getglobal('PET_HAPPINESS'..happiness);
           tooltipDamage = format(PET_DAMAGE_PERCENTAGE, damagePercentage);
           tooltipLoyalty = tooltipLoyalty;
         }
   else
      --since there is no happiness, REMOVE it from the table!
      if CP_watched['pet'] and CP_watched['pet']['pet_happiness'] then
         if CastParty_Debug then CastParty_Debug(2, 'sadness icon removed from table!') end;
         CP_watched['pet']['pet_happiness'] = nil;
         --setting table size to appropriate size.
         --doing this and setting nil, is the same thing that table.remove does, but I just don't have and
         -- index to do this, i have a name... so i have to do it manually.
         table.setn(CP_watched['pet'], table.getn(CP_watched['pet'])-1)
      end
   end

   --GOSH! I hate chaining obscure functions, but this cuts down on logic and code elsewhere, so... oh well!
   CastParty_UpdateAuras(45);
   --now display those auras!
   if CastParty_DisplayAuras then
      CastParty_DisplayAuras(45);
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateHealer(_healer, _id, _target, _name, _rank, _duration, _ammount)

   if not _id then
      return;
   end

   if CastParty_Debug then CastParty_Debug(3, 'Update the healer icon!') end;
   if CastParty_Debug then CastParty_Debug(3, _healer, _id, _target, _name, _rank, _duration, _ammount) end;

   if _unit == 'mouseover' then
      if CastParty_Debug then CastParty_Debug(4, 'Exiting on mouseover unit! (shouldnt happen <1371>)') end;
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);

   if not frame then
      return;
   end

   frame.PH_healer   = _healer;
   frame.PH_unit     = CP_units[_id];
   frame.PH_target   = _target;
   frame.PH_name     = _name;
   frame.PH_rank     = _rank;
   frame.PH_duration = _duration;
   frame.PH_ammount  = _ammount;

   getglobal('CastPartyMember' .. _id).PH_expire   = GetTime() + _duration;
   getglobal('CastPartyMember' .. _id .. 'HealerIcon'):Show();
end

--***************************************************************************
--***************************************************************************
function CastParty_GUI_Init()

   --this is pretty much the ONLY function here called by the CastParty frame loader.
   --also called when we change an option in the Options GUI

   --this is because WoW doesn't save our frame location!! (onloaded frames can't be saved.)
   for i=0,2 do
      frame = getglobal('CastPartyFrame' .. i);
      if frame then
         frame:SetPoint('TOPLEFT','UIParent','BOTTOMLEFT', CastPartyConfig.Spot[i]['x'], CastPartyConfig.Spot[i]['y'])
         if CastPartyConfig.locked then
            getglobal(frame:GetName()..'Drag'):Hide();
         end
      end
   end

   --player frame
   if not CastPartyConfig.showPlayer then
      CastPartyFrame0:Hide();
   else
      CastPartyFrame0:Show();
   end

   --party frame
   if not CastPartyConfig.showParty then
      CastPartyFrame1:Hide();
   else
      CastPartyFrame1:Show();
   end

   --target frame
   ClearTarget();
   if CastPartyConfig.showTarget then
      CastPartyFrame2:Show();
   else
      CastPartyFrame2:Hide();
   end

   --this is to refresh all of our party members.
   CastParty_UpdateMember(nil, true);

--   --raid monitor
--   if CastPartyFrame1 then
--      if CastPartyConfig.showMonitor then
--         CastPartyFrame1:Show();
--      else
--         CastPartyFrame1:Hide();
--      end
--   end



end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateRangeDisplay(_id, _forceUpdatePing)

   if not _id then
      return;
   end

   --need to double check this and it's calls

   --the logic is...
   -- range = 0 -> they just passed the interact distance check
   -- if 0 < range < 30, thats normal -> they passed the interact distance check recently
   --
   -- range = 30 -> they just passed the combat log check
   -- if 30 < range < 60, thats good -> they passed the combat log check recently
   --
   -- if 60 < range < 90, no clue where they are (unknown)
   --
   -- range > 90 : they are dead, disconn, or don't exist

   -- me and the target frame are not reaching this...so they shouldn't update.
   --TODO add color based on difficulty level of target (if I can attack them)

   --have to have passed an ID so we can update specific frames...

   --don't want this to mess with the target frame...
   if _id == 90 then
      return;
   end

   frame = getglobal('CastPartyMember' .. _id);
   if not frame then
      if CastParty_Debug then CastParty_Debug( 3, '<UpdateRangeDisplay> Frame doesnt exits!', _id) end;
      return;
   end;
   unit = CP_units[_id];

   -- unit is not connected OR dead
   if CastPartyConfig.update_range and (not UnitIsConnected(unit) or UnitIsGhost(unit)) then
      frame.range = 100;
   end

   -- people within follow distance and are obviously close by
   if CastPartyConfig.update_range and not _forceUpdatePing and (CheckInteractDistance(unit,4)) then
      frame.range = 0;
   end

   --if we have a range, we now display it.
   if frame.range >= 0 then
      --now we figure out what color to make the range indicator status bar thing....
      -- it goes... colorA -> colorB, colorB is when percent is %100

      if not CastPartyConfig.update_range then
         frame.range = 0;
      end

      if frame.range >= 0 and frame.range <= 30 then  -- 0-30 -> normal->green
         colorA = { r = 0.00, g = 1.00,   b = 0.00 }  ;
         colorB = { r = 1.00, g = 1.00,   b = 1.00 };
         percent = (30 - frame.range)/30;
      elseif frame.range > 30 and frame.range <= 60 then     -- 30-60 -> green->yellow
         colorA = { r = 1.00, g = 1.00,   b = 0.00 } ;
         colorB = { r = 0.00, g = 1.00,   b = 0.00 };
         percent = (30 - (frame.range-30))/30;
      elseif frame.range > 60 and frame.range <= 90 then     -- 60-90 -> yellow->red
         colorA = { r = 1.00, g = 0.00,   b = 0.00 } ;
         colorB = { r = 1.00, g = 1.00,   b = 0.00 };
         percent = (30 - (frame.range-60))/30;
      else -- >90 : red
         colorA = { r = 1.00, g = 0.00,   b = 0.00 } ;
         colorB = { r = 1.00, g = 0.00,   b = 0.00 };
         percent = 1;
      end

      rangeRGB = CastParty_RGBtoRGB(colorA, colorB, percent );
      button = getglobal(frame:GetName() .. 'Texture');
      if button then
         if UnitExists(unit) then
            button:SetVertexColor( rangeRGB.r, rangeRGB.g, rangeRGB.b);
         else
            button:SetVertexColor( 1.00, 1.00, 1.00 );
            frame.range = -1;
         end
      end
   end

   if not CastPartyConfig.update_range then
      frame.range = -1;
   end

   --this is so we can let the updater timer know we just forced an update
   if _forceUpdatePing then
      frame.forceUpdatePing = true;
   end

   if frame.range and frame.range < 100 then
      --slowly fade them out of range if they aren't close.
      frame.range = frame.range + 3;
   elseif frame.range and frame.range > 130 then
      --they've been gone a while, so get rid their status.
      getglobal(frame:GetName() .. 'Texture'):SetVertexColor( 1.00, 1.00, 1.00 );
      frame.range = -1;
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateComboPoints()
	comboPoints = GetComboPoints();

	if ( comboPoints > 0 ) then
		if ( not CastPartyComboFrame:IsVisible() ) then
			CastPartyComboFrame:Show();
			UIFrameFadeIn(CastPartyComboFrame, COMBOFRAME_FADE_IN);
		end

		for i=1, MAX_COMBO_POINTS do
			comboPointHighlight = getglobal('CPComboPoint'..i..'Highlight');
			comboPointShine = getglobal('CPComboPoint'..i..'Shine');
			if ( i <= comboPoints ) then
				if ( i > CP_COMBO_FRAME_LAST_NUM_POINTS ) then
					-- Fade in the highlight and set a function that triggers when it is done fading
					fadeInfo = {};
					fadeInfo.mode = 'IN';
					fadeInfo.timeToFade = COMBOFRAME_HIGHLIGHT_FADE_IN;
					fadeInfo.finishedFunc = ComboPointShineFadeIn;
					fadeInfo.finishedArg1 = comboPointShine;
					UIFrameFade(comboPointHighlight, fadeInfo);
				end
			else
				comboPointHighlight:SetAlpha(0);
				comboPointShine:SetAlpha(0);
			end
		end
	else
		CPComboPoint1Highlight:SetAlpha(0);
		CPComboPoint1Shine:SetAlpha(0);
		CastPartyComboFrame:Hide();
	end
	CP_COMBO_FRAME_LAST_NUM_POINTS = comboPoints;
end

--***************************************************************************
--***************************************************************************
function CastParty_Target_Tap()
   if ( UnitIsTapped('target') and not UnitIsTappedByPlayer('target') ) then
      getglobal('CastPartyMember90Texture'):SetVertexColor( 1.0, 0.0, 0.0);
   else
      getglobal('CastPartyMember90Texture'):SetVertexColor( 1.0, 1.0, 1.0);
   end
end

--***************************************************************************
--***************************************************************************
local function toNum(number)
   if number then return number end;
   return 0;
end

--***************************************************************************
--***************************************************************************
function CastParty_TweakTipPosition()

   left	 = toNum(GameTooltip:GetLeft());
	right	 = UIParent:GetRight() - toNum(GameTooltip:GetRight());
	bottom = toNum(GameTooltip:GetBottom());
	top	 = UIParent:GetTop() - toNum(GameTooltip:GetTop());
	xoff, yoff = 0, 0

	if( left < 0 ) then
		xoff = abs(left)
	elseif( right < 0 ) then
		xoff = right
	end
	if( bottom < 0 ) then
		yoff = abs(bottom)
	elseif( top < 0 ) then
		yoff = top
	end

	if( (xoff ~= 0) or (yoff ~= 0) ) then
		GameTooltip:SetPoint('BOTTOMLEFT', UIParent:GetName(), 'BOTTOMLEFT', left, bottom);
	end
end


--***************************************************************************
--***************************************************************************
function CastParty_UpdateRaidTargetIconStatus(_id)

   if not _id then
      return;
   end

   index = nil;

   if not _id then
      if CastParty_Debug then CastParty_Debug(4, '<CastParty><GUI><UpdateRaidTargetIconStatus>', 'No ID!') end;
      return;
   end

   unit = CP_units[_id];
	frame = getglobal('CastPartyMember' .. _id .. 'RaidTargetIcon');

	if not frame then
	   return;
	end

   index = GetRaidTargetIndex(unit);
	if ( index ) then
		CastParty_SetRaidTargetIconTexture(frame, index);
		frame:Show();
	else
		frame:Hide();
	end

   if UnitIsUnit(unit, 'target') and _id ~= 90 then
      CastParty_UpdateRaidTargetIconStatus(90);
   end

end


--***************************************************************************
--***************************************************************************
function CastParty_SetRaidTargetIconTexture(texture, raidTargetIconIndex)
	raidTargetIconIndex = raidTargetIconIndex - 1;
	left  = 0;
	right = 0;
	top   = 0;
	bottom= 0;

	coordIncrement = RAID_TARGET_ICON_DIMENSION / RAID_TARGET_TEXTURE_DIMENSION;
	left = mod(raidTargetIconIndex , RAID_TARGET_TEXTURE_COLUMNS) * coordIncrement;
	right = left + coordIncrement;
	top = floor(raidTargetIconIndex / RAID_TARGET_TEXTURE_ROWS) * coordIncrement;
	bottom = top + coordIncrement;
	texture:SetTexCoord(left, right, top, bottom);
end
