
local buffIndex;
local untilCancelled;
local count;
local timeMinute;
local timeSecond;
local timeTotal;

local unitID;
local unit;
local buffName;
local buffID;
local debuffID;
local ills;

local tempName;
local name;

local frame;

local color;
local combatText;
local raceText;

local manaText;
local healthText;
local levelText;
local guildName;
local isLeader;
local colorLvl;
local unitClass;
local playerText;
local text;
local textTemp;
local unit;

local gameTooltipScale;
local gameTooltipScaled;


--***************************************************************************
--***************************************************************************
function CastParty_EnterAura()

--   CastParty_Debug( 1, 'enter aura', this:GetID(), this:GetParent():GetID())

   --insteresting: When the timer is 0, two cases exist. Either it is infinte (shadowform) or just
   --the timer is at 0. When the timer is at zero, and it is because it has run out, then it will
   --show the normal timer text (0 seconds remaining) for one second. If I change this, then infinite buffs
   --will lose their description text (it will just say 0). I can fix this, but the tradeoffs (in computation
   --and use of variables isn't really worth it.

   GameTooltip:SetOwner(this, 'ANCHOR_TOPLEFT')

   if not CastPartyConfig.show_aura_tooltips or ((CastPartyConfig.hide_aura_tooltips_in_combat and UnitAffectingCombat('player')) and this:GetParent():GetID() ~= 90) then
      CastParty_LeaveAura();
      return;
   end



   if this.watching then
      --maybe should set the tooltip to the spell details?
      GameTooltip:ClearLines();
      GameTooltip:AddLine('Buff-O-Matic');
      GameTooltip:AddLine('Click to Recast '..this.name, 1.0, 1.0, 1.0);
      CastParty_ShowGameTooltip();
      return;
   end

   if this:GetParent():GetID() == 0 then
      if this.debuff_index then
         --This is how you specify buff/debuff frames. DO NOT CHANGE!
         buffIndex, untilCancelled = GetPlayerBuff(this.debuff_index, this.buffFilter);
         GameTooltip:SetPlayerBuff(buffIndex, this.buffFilter);
      else
         buffIndex, untilCancelled = GetPlayerBuff(this.buff_index, this.buffFilter);
         GameTooltip:SetPlayerBuff(buffIndex, this.buffFilter);
      end
      count = GameTooltip:NumLines();

      -- Add time to player buffs, to bad we can't see other peoples buff times
      -- init these to nothing!!
      timeTotal  = nil;
      timeMinute = nil;
      timeSecond = nil;

      timeTotal = floor(GetPlayerBuffTimeLeft(buffIndex) / 1);
      if timeTotal and timeTotal > 60 then
         timeMinute = floor(timeTotal / 60);
         timeSecond = timeTotal - (timeMinute * 60);

         if (timeSecond < 10) then
            timeSecond = '0' .. timeSecond
         end
      elseif timeTotal  then
         timeSecond = timeTotal;
         if (timeSecond < 10 and timeSecond > 0) then
            timeSecond = '0' .. timeSecond
         end
      end
      if timeMinute and timeSecond then
         getglobal('GameTooltipTextLeft' .. count):SetText(GRY .. timeMinute .. ':' .. timeSecond);
      elseif timeTotal > 0 then
         getglobal('GameTooltipTextLeft' .. count):SetText(GRY .. timeSecond);
      end
      CastParty_ShowGameTooltip();
   else
      if this.name == 'pet_happiness' then
         if ( this.tooltip ) then
            GameTooltip:SetText(this.tooltip);
            if ( this.tooltipDamage ) then
               GameTooltip:AddLine(this.tooltipDamage, "", 1, 1, 1);
            end
            if ( this.tooltipLoyalty ) then
               GameTooltip:AddLine(this.tooltipLoyalty, "", 1, 1, 1);
            end
         end
         CastParty_ShowGameTooltip();

      elseif this.debuff_index then
         GameTooltip:SetUnitDebuff(CP_units[this:GetParent():GetID()], this.debuff_index)
         CastParty_ShowGameTooltip();
      else
         GameTooltip:SetUnitBuff(CP_units[this:GetParent():GetID()], this.buff_index)
         CastParty_ShowGameTooltip();
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_LeaveAura()
   CastParty_HideGameTooltip();
end


--***************************************************************************
--***************************************************************************
-- function CastParty_ClickAura() was placed into CORE because other mods make use
-- of the clickery here.



--***************************************************************************
--***************************************************************************
function CastParty_Drag_OnEnter()
   if not CastPartyConfig.locked then
      if getglobal(this:GetName() .. 'Drag'):IsShown() then

         GameTooltip:SetOwner(this, 'ANCHOR_TOPLEFT')
         GameTooltip:ClearLines();

         tempName = string.gsub(this:GetName(), 'CastPartyFrame', "")
         if tempName == '0' then
            tempName = 'Player';
         elseif tempName == '1' then
            tempName = 'Party';
         elseif tempName == '2' then
            tempName = 'Target';
         else
            tempName = 'Raid Monitor Group';
         end

         GameTooltip:AddLine( tempName, 0.5, 0.5, 1 );
         GameTooltip:AddLine( "" );
         GameTooltip:AddLine( TOOLTIP_DRAGICON, 1, 1, 1, 1, 1 );

         CastParty_ShowGameTooltip();
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty.Event.OnMouseDown()
   if not CastPartyConfig.locked  then
      if ( arg1 == 'LeftButton' ) then
         this:StartMoving();
      else
         tempName = this:GetName()
         if tempName == 'CastPartyFrame0' then -- player frame
            CastPartyConfig.showPlayer = false;
         elseif tempName == 'CastPartyFrame1' then -- party frame
            CastPartyConfig.showParty = false;
         elseif tempName == 'CastPartyFrame2' then  --target frame
            ClearTarget();
            CastParty.MobHealth.SetCurTarget();
            CastParty_UpdateId(this:GetID());
            CastParty_PlaceFrames(this:GetID());
            CastParty_UpdateIdHealth(this:GetID());
            CastParty_UpdateIdMana(this:GetID());

            CastPartyConfig.showTarget = false;
         else --its the monitor frame....
            CastPartyConfig.showMonitor = false;
         end
         for k,v in CP_units do
            frame = getglobal('CastPartyMember' .. k);
            if frame then
               frame.forceUpdate = true;
            end
         end
         CastParty_GUI_Init();
      end
   end
end

--***************************************************************************
--***************************************************************************
function CastParty.Event.OnMouseUp()
   this:StopMovingOrSizing()
   --this:SetUserPlaced(1) doesn't work!!!
   CastPartyConfig.Spot[this:GetID()] = { x=math.ceil(this:GetLeft()), y=math.ceil(this:GetTop()) };
end

--***************************************************************************
--***************************************************************************
function CastParty_EnterUnit()
--   if CastParty_Debug then CastParty_Debug( 1, 'enter unit', CP_units[this:GetID()]) end;

   unit = CP_units[this:GetID()]

	if ( SpellIsTargeting() ) then
		if ( SpellCanTargetUnit(unit) ) then
			SetCursor('CAST_CURSOR');
		else
			SetCursor('CAST_ERROR_CURSOR');
		end
	end


   if not CastPartyConfig.show_party_tooltips or ((CastPartyConfig.hide_unit_tooltips_in_combat and UnitAffectingCombat('player')) and this:GetID() ~= 90) then
      CastParty_LeaveAura();
      return;
   end

   GameTooltip:SetOwner(this, 'ANCHOR_TOPLEFT');

   CastParty_TooltipB:SetOwner(this, 'ANCHOR_TOPLEFT');
   CastParty_TooltipB:SetUnit(unit);

   GameTooltip:ClearLines();

   color = CastParty_classColor(unit);

   if UnitAffectingCombat(unit) then
      combatText = 'In Combat!';
   else
      combatText = '          ';
   end

   if UnitInGroup(unit) or unit == 'player' then
      manaText   = '('..UnitMana(unit)..'/'..UnitManaMax(unit)..')';
      healthText = '('..CP_UnitHealth(unit)..'/'..CP_UnitHealthMax(unit)..')';
   else
      manaText   = '???'
      healthText = '('..CastParty.MobHealth.GetTargetCurHP()..'/'..CastParty.MobHealth.GetTargetMaxHP()..')';
   end


   if UnitRace(unit) then
      raceText = '|cffff7f3f'..UnitRace(unit)..'|r';
   else
      raceText = ' ';
   end

   if UnitLevel(unit) then
      levelText = ""..UnitLevel(unit);
   else
      levelText = '??';
   end

   if GetGuildInfo(unit) then
      guildName = GetGuildInfo(unit);
   else
      guildName = "";
   end

   if UnitIsPartyLeader(unit) then
      isLeader = true;
   else
      isLeader = false;
   end

   -- Color level number (from tipbuddy)
	if (UnitHealth(unit) <= 0) then
		--dead unit
		colorLvl = '|cffcccccc';
	elseif ( UnitCanAttack(unit, 'player') or UnitCanAttack('player', unit) or UnitIsPVP(unit) ) then
		-- Hostile unit of friendly unit flagged for PvP
		colorLvl = CastParty_GetDifficultyColor(UnitLevel(unit));
	else
		colorLvl = '|cffD8D8D8';
	end

   -- there is a PVP name. (i.e. scout, etc..)
   if UnitPVPName(unit) and UnitName(unit) and string.gsub(UnitPVPName(unit), UnitName(unit), "") ~= "" then
      -- there is a guild too!
      if guildName ~= "" then
         GameTooltip:AddLine(UnitName(unit), color.r, color.g, color.b);
         GameTooltip:AddDoubleLine( string.gsub(UnitPVPName(unit), UnitName(unit), ""), guildName, .5, 1, 1, 0, 1, 0 );
      -- else there is NO guild!
      else
         GameTooltip:AddDoubleLine( UnitName(unit), string.gsub(UnitPVPName(unit), UnitName(unit), ""), color.r, color.g, color.b, .5, 1, 1 );
      end
   elseif UnitName(unit) then
      -- there is just a normal name...
      GameTooltip:AddDoubleLine( UnitName(unit), guildName, color.r, color.g, color.b, 0, 1, 0 );
   end

   if UnitClass(unit) then
      unitClass = UnitClass(unit);
   else
      unitClass = 'Unknown';
   end

   if UnitIsPlayer(unit) then
      playerText = '(PC)';
   else
      playerText = '(NPC)';
   end
   playerText = '|cffcccccc'..playerText..'|r';



   GameTooltip:AddDoubleLine( colorLvl..levelText..'|r'..' : '..unitClass, raceText, 1, 1, 1, 0.7, 0.7, 0.7 );

   if isLeader then
      GameTooltip:AddLine(RED.. 'Leader');
   end

   if (unit == 'player') and IsResting() then
      GameTooltip:AddLine(WHT.. 'You are resting!');
   end

   if this.PH_expire then
      local duration = string.format('%.2f', this.PH_expire - GetTime())

      GameTooltip:AddLine( this.PH_healer .. ' is healing!');
      GameTooltip:AddLine(WHT.. this.PH_name .. ' ' .. this.PH_rank .. '|r');
      GameTooltip:AddDoubleLine(GRY .. duration .. ' ' .. SECONDS_P1, this.PH_ammount, .5, .5, .5,  .5, 1, .5 );
   else
      GameTooltip:AddLine("");
   end

   textTemp = "";

   count = CastParty_TooltipB:NumLines();
   for i=2, count do
      text = getglobal('CastParty_TooltipBTextLeft'..i):GetText();
      text = gsub(text, 'Level.*', "")
      text = gsub(text, '%(Player%)', "")

      if UnitClass(unit) then
         text = gsub(text, UnitClass(unit), "")
      end

      if UnitRace(unit) then
         text = gsub(text, UnitRace(unit), "")
      end

      textTemp = gsub(text, '%s+', "")
      if textTemp ~= "" then
         GameTooltip:AddLine(text);
      end
   end

   if (UnitInGroup(unit)) or (unit == 'player') or (CastParty.MobHealth.GetTargetCurHP() > 0) then
      GameTooltip:AddDoubleLine( manaText, healthText, 0.5, 0.5,  1, 0, 1, 0);
   end
   CastParty_TooltipB:Hide();
   CastParty_ShowGameTooltip();
end


--***************************************************************************
--***************************************************************************
function CastParty_LeaveUnit()
   this.updateTooltip = 0;   --hack so if we leave and enter the frame right away, we can still see the tooltip...
   CastParty_HideGameTooltip();
end


--***************************************************************************
--***************************************************************************
function CastParty_ShowGameTooltip()
   if not gameTooltipScaled then
      gameTooltipScaled = true;
      gameTooltipScale  = GameTooltip:GetScale();
   end
   GameTooltip:SetScale(.8);
   CastParty_TweakTipPosition();
   GameTooltip:Show();
end

--***************************************************************************
--***************************************************************************
function CastParty_HideGameTooltip()
   if gameTooltipScale == null then
      gameTooltipScale = 1;
   end
   GameTooltip:SetScale(gameTooltipScale);
   gameTooltipScaled = false;
   GameTooltip:Hide();
end


--***************************************************************************
--***************************************************************************
function CastParty_UpdateUnitPing(spellRangeFeedback, id)

   if not CastPartyConfig.update_range then
      return;
   end

   --TODO: Need to doulbe check and optionimize this function, and calls other functions make to this.
   -- 2/13/06. i think I got it all working.

   --KICKASS! You can get x/y coords for partymembers AND raidmembers!
   --it's  ->  partyX, partyY = GetPlayerMapPosition(unit);
   --DOESN'T work in instances. it works in battlegrounds? so have multiple methods!

   --combat event, and spell cast events/errors
   local frame
   if not id then
      frame = getglobal('CastPartyMember' .. this:GetID());
   end


   --to fix the 447 nil errors. note: left out a part...
   if not ((frame and frame:IsVisible()) or (id and getglobal('CastPartyMember' .. id) and getglobal('CastPartyMember' .. id):IsVisible())) then
      if CastParty_Debug then CastParty_Debug(3, '<CastParty><UpdateUnitPing> CastParty frame doesnt exist!') end;
      return;
   end

   local range = 0;

   --we just saw them in the combat log AND they used to be close by
   if not spellRangeFeedback then
      if range > 60 then
         range = 60
      elseif range > 30 then
         range = 30
      end
   else
      if spellRangeFeedback == 1 then
         --we KNOW we are IN range.
         if range > 30 then
            range = 30
         end
      elseif spellRangeFeedback == 2 then
         --we KNOW we are OUT of range
         range = 100
      elseif spellRangeFeedback == 3 then
         --Out of sight!
         --we KNOW we are IN range, but not sure HOW close
         range = 60
      end
   end

   if id and getglobal('CastPartyMember' .. id) then
      getglobal('CastPartyMember' .. id).range = range;
      --since we want INSTANT feedback if spells fail, then update it ASAP!
      CastParty_UpdateRangeDisplay(id, true);
   elseif frame then
      frame.range = range;
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_SubTargetClick(_button)
   -- I should REALLY have this work with the standard click function...
   CastParty.Event.OnClick(_button, true);
 end