
local CastParty_Group_Memory = {};

local _unitName;
local button;
local class;
local englishClass;
local dropdownFrame;
local dropdownMenu;
local frame;
local id;
local CastPartyFrameCheck = false;
local index;
local levelDifference;
local levelDifferenceColor;
local monitoringUnits;
local name;
local newID;
local newUNIT;
local notFound;
local offsetID;
local offsetUnit;
local petFrame;
local petID;
local size;
local specialID;
local tempID;
local tempUnit;
local unit;
local unitName;

--***************************************************************************
--***************************************************************************
function CP_GUI_OnEvent(_event, ...)

--   note('event ' .. event)
--   if arg[[1] then note(event..' arg1: '..arg1) end

   CastParty.Profiler.Start(_event);

   getglobal('CP_GUI_' .. _event)(_event, unpack(arg));

   CastParty.Profiler.Stop(_event);

   --this is where I config what frames to update/show.
   if not CastPartyConfig.showTarget and arg[1] == 'target' then
      return;
   end
end

--***************************************************************************
--***************************************************************************
--load our player frames.
function CP_GUI_PLAYER_ENTERING_WORLD(event, ...)
   CastParty_UpdateMember();        -- group update units stuff, health, mana, name, flags, etc
   CastParty_UpdateMember(90);
   --if my dude is a hunter, then update the pet-happiness icon.
   if CastParty.Brain.className == 'HUNTER' then
      CastParty_PetHappiness();
   end
   --register health and mana
   this:RegisterEvent('UNIT_HEALTH');
   this:RegisterEvent('UNIT_MAXHEALTH');
   this:RegisterEvent('UNIT_DISPLAYPOWER');  --when a units mana type is changed
   this:RegisterEvent('UNIT_MANA');
   this:RegisterEvent('UNIT_MAXMANA');
   this:RegisterEvent('UNIT_ENERGY');
   this:RegisterEvent('UNIT_MAXENERGY');
   this:RegisterEvent('UNIT_FOCUS');
   this:RegisterEvent('UNIT_RAGE');
   this:RegisterEvent('UNIT_MAXRAGE');
   --flags
   this:RegisterEvent('PARTY_LEADER_CHANGED');
   this:RegisterEvent('PARTY_LOOT_METHOD_CHANGED') ;
   --this is so we know if someone else has 'tapped' our target before us.
   --also pvp flag updates..
   this:RegisterEvent('UNIT_FACTION');
   --register when a unit name changes (this is where we create our frames)
   this:RegisterEvent('UNIT_NAME_UPDATE');
   --party/raid member update stuff
   this:RegisterEvent('PARTY_MEMBERS_CHANGED');
   this:RegisterEvent('RAID_ROSTER_UPDATE');
   this:RegisterEvent('RAID_TARGET_UPDATE');
   --this is for pets
   this:RegisterEvent('UNIT_PET');
   --this is for the target frame.
   this:RegisterEvent('PLAYER_TARGET_CHANGED');
   --for the range thing (and attack icon)
   this:RegisterEvent('UNIT_COMBAT');
   --this is for the pet happiness thing.
   this:RegisterEvent('UNIT_HAPPINESS');
end

--***************************************************************************
--***************************************************************************
--when i leave the world.. unregister everything
function CP_GUI_PLAYER_LEAVING_WORLD(event, ...)
   --unregister health and mana
   this:UnregisterEvent('UNIT_HEALTH');
   this:UnregisterEvent('UNIT_MAXHEALTH');
   this:UnregisterEvent('UNIT_DISPLAYPOWER');  --when a units mana type is changedfunction CP_GUI_
   this:UnregisterEvent('UNIT_MANA');
   this:UnregisterEvent('UNIT_MAXMANA');
   this:UnregisterEvent('UNIT_ENERGY');
   this:UnregisterEvent('UNIT_MAXENERGY');
   this:UnregisterEvent('UNIT_FOCUS');
   this:UnregisterEvent('UNIT_RAGE');
   this:UnregisterEvent('UNIT_MAXRAGE');
   --flags
   this:UnregisterEvent('PARTY_LEADER_CHANGED');
   this:UnregisterEvent('PARTY_LOOT_METHOD_CHANGED') ;
   --this is so we know if someone else has 'tapped' our target before us.
   --also pvp flag updates
   this:UnregisterEvent('UNIT_FACTION');
   --register when a unit name changes (this is where we create our frames)
   this:UnregisterEvent('UNIT_NAME_UPDATE');
   --party/raid member update stuff
   this:UnregisterEvent('PARTY_MEMBERS_CHANGED');
   this:UnregisterEvent('RAID_ROSTER_UPDATE');
   this:UnregisterEvent('RAID_TARGET_UPDATE');
   --this is for pets
   this:UnregisterEvent('UNIT_PET');
   --this is for the target frame.
   this:UnregisterEvent('PLAYER_TARGET_CHANGED');
   --for the range thing (and attack icon)
   this:UnregisterEvent('UNIT_COMBAT');
   --this is for the pet happiness thing.
   this:UnregisterEvent('UNIT_HAPPINESS');
end

--***************************************************************************
--***************************************************************************
--when I go INTO combat.
function CP_GUI_PLAYER_REGEN_DISABLED(event, ...)
   CastParty_UpdateCombatStatus(0);
end

--***************************************************************************
--***************************************************************************
--when I go OUT of combat
function CP_GUI_PLAYER_REGEN_ENABLED(event, ...)
   CastParty_UpdateCombatStatus(0);
end

--***************************************************************************
--***************************************************************************
--this is for the target frame.
--this event was only registered for the target frame.
function CP_GUI_PLAYER_TARGET_CHANGED(event, ...)
   CastParty.MobHealth.SetCurTarget();     -- this is to initialize how many times i will update the max health of the target.
   CastParty_UpdateMember(90);             -- should ONLY update the TARGET frame...
   CastParty_UpdateSubTarget(90);          -- update who's targeting who!
   CastParty_Target_CheckClassification()  -- need to check if our target is elite or rare
   CastParty_UpdateComboPoints();          -- combo points for rogues
   CastParty_Target_Tap();                 -- check if our target is already tapped
   CastParty_UpdateRaidTargetIconStatus(90);    -- update what the raid target icon is.
end

--***************************************************************************
--***************************************************************************
--have to have a table, storing who the current leader is, and who the new one should be.
--when leader changes
function CP_GUI_PARTY_LEADER_CHANGED(event, ...)
   CastParty_UpdateLeaderStatus();
end

--***************************************************************************
--***************************************************************************
--when loot method changes
function CP_GUI_PARTY_LOOT_METHOD_CHANGED(event, ...)
   CastParty_UpdateMasterStatus();
end


--***************************************************************************
--***************************************************************************
--party/raid member update stuff
function CP_GUI_PARTY_MEMBERS_CHANGED(event, ...)
   --update the party!
   CastParty_UpdateMember(nil, true);
   CastParty_ResetWatchList();
   --update what group I'm a member of (if any...)
   CastParty_UpdateGroupIndicator();
end

--***************************************************************************
--***************************************************************************
function CP_GUI_RAID_ROSTER_UPDATE(event, ...)
   --update the party!
   CastParty_UpdateMember(nil, true);
   CastParty_ResetWatchList();
   --update what group I'm a member of (if any...)
   CastParty_UpdateGroupIndicator();
end

--***************************************************************************
--***************************************************************************
--auras registered for the other units
function CP_GUI_PLAYER_COMBO_POINTS(event, ...)
   CastParty_UpdateComboPoints();
end


--***************************************************************************
--***************************************************************************
--when a member is reconneced after a disconnect.
function CP_GUI_PARTY_MEMBER_ENABLE(event, ...)
   CastParty_UpdateRaidTargetIconStatus(CP_ids[arg[1]]);
end

--***************************************************************************
--***************************************************************************
--when a unit name changes (this is where we create our frames)
function CP_GUI_UNIT_NAME_UPDATE(event, ...)
   id = CP_ids[arg[1]];

   CastParty_UpdateId(id);
   CastParty_PlaceFrames(id);
   CastParty_UpdateIdHealth(id);
   CastParty_UpdateIdMana(id);
end

--***************************************************************************
--***************************************************************************
--health
function CP_GUI_UNIT_HEALTH(event, ...)
   CastParty_UpdateIdHealth(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_MAXHEALTH(event, ...)
   CastParty_UpdateIdHealth(CP_ids[arg[1]]);
end

--***************************************************************************
--***************************************************************************
--mana
function CP_GUI_UNIT_DISPLAYPOWER(event, ...)   --when a units mana type is changed
   CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_MANA(event, ...)
   CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_MAXMANA(event, ...)
      CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_ENERGY(event, ...)
      CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_MAXENERGY(event, ...)
      CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_FOCUS(event, ...)
      CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_RAGE(event, ...)
      CastParty_UpdateIdMana(CP_ids[arg[1]]);
end
function CP_GUI_UNIT_MAXRAGE(event, ...)
      CastParty_UpdateIdMana(CP_ids[arg[1]]);
end

--when the PVP status changes
--when a target is 'tapped' by someone...
function CP_GUI_UNIT_FACTION(event, ...)
   id = CP_ids[arg[1]];

   if ( id and id == 90 ) then
      CastParty_Target_Tap();
   elseif id then
      CastParty_UpdatePvPStatus(id);
   end
end


--***************************************************************************
--***************************************************************************
--this is for pets
--we have to make sure to display the pet frame...
function CP_GUI_UNIT_PET(event, ...)
   id = CP_ids[arg[1]];

   if id and getglobal('CastPartyMember'.. id) then
      petID = getglobal('CastPartyMember'.. id).pet;
      if petID then
         petFrame = getglobal('CastPartyMember'.. petID);
         petFrame:Show();
         petFrame:SetScript('OnUpdate', CP_Template_OnUpdate);
         petFrame.forceUpdate = true;
      end
   end
end


--***************************************************************************
--***************************************************************************
--for the range thing
function CP_GUI_UNIT_COMBAT(event, ...)
   id = CP_ids[arg[1]];

   if id and id > 0 then
      CastParty_UpdateCombatStatus(id);
      if CastPartyConfig.showTarget and id == 90 then
         --this is to allow showing if a target is tapped by another player..
         CastParty_Target_Tap();
      end
   end
end


--***************************************************************************
--***************************************************************************
--(pet happiness aura registered
function CP_GUI_UNIT_HAPPINESS(event, ...)
   if arg[1] == 'playerpet' then
      CastParty_PetHappiness();
   end
end

--***************************************************************************
--***************************************************************************
--when the icon for the raid target changes.
function CP_GUI_RAID_TARGET_UPDATE(event, ...)
   id = CP_ids[arg[1]];
   if id then
      CastParty_UpdateRaidTargetIconStatus(id);
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_GUI_Initialize()

   -- hooks to do my own link menu.
   CP_UnitPopup_HideButtons = UnitPopup_HideButtons;
   CP_UnitPopup_OnClick     = UnitPopup_OnClick;

   UnitPopup_HideButtons = CastParty_UnitPopup_HideButtons;
   UnitPopup_OnClick     = CastParty_UnitPopup_OnClick;

   --init the dropdowns!!
   CastParty.Init_DropDowns();

   --register when we enter the worlds, so I can run the code to display the frames
   --also register most of our events here, so loading screens while in a raid are faster.
   this:RegisterEvent('PLAYER_ENTERING_WORLD');

   --this is to help with the loading times.
   this:RegisterEvent('PLAYER_LEAVING_WORLD');

   --if my dude is a hunter, then update the pet-happiness icon.
   if CastParty.Brain.className == 'HUNTER' then
      CastParty_PetHappiness();
   end

   --register health and mana
   this:RegisterEvent('UNIT_HEALTH');
   this:RegisterEvent('UNIT_MAXHEALTH');
   this:RegisterEvent('UNIT_DISPLAYPOWER');  --when a units mana type is changed
   this:RegisterEvent('UNIT_MANA');
   this:RegisterEvent('UNIT_MAXMANA');
   this:RegisterEvent('UNIT_ENERGY');
   this:RegisterEvent('UNIT_MAXENERGY');
   this:RegisterEvent('UNIT_FOCUS');
   this:RegisterEvent('UNIT_RAGE');
   this:RegisterEvent('UNIT_MAXRAGE');

   --flags
   this:RegisterEvent('PARTY_LEADER_CHANGED');
   this:RegisterEvent('PARTY_LOOT_METHOD_CHANGED') ;

   --this is so we know if someone else has 'tapped' our target before us.
   --also PVP flag updates...
   this:RegisterEvent('UNIT_FACTION');

   --register when a unit name changes (this is where we create our frames)
   this:RegisterEvent('UNIT_NAME_UPDATE');

   --party/raid member update stuff
   this:RegisterEvent('PARTY_MEMBERS_CHANGED');
   this:RegisterEvent('RAID_ROSTER_UPDATE');
   this:RegisterEvent('RAID_TARGET_UPDATE');

   --this is for pets
   this:RegisterEvent('UNIT_PET');

   --this is for the target frame.
   this:RegisterEvent('PLAYER_TARGET_CHANGED');

   --for the range thing (and attack icon)
   this:RegisterEvent('UNIT_COMBAT');

   --this is for the pet happiness thing.
   this:RegisterEvent('UNIT_HAPPINESS');

   --this is for rogues combo points thing.
   this:RegisterEvent('PLAYER_COMBO_POINTS');

   --only useful for me.
   this:RegisterEvent('PLAYER_REGEN_DISABLED');
   this:RegisterEvent('PLAYER_REGEN_ENABLED');

   CastParty_TooltipB:SetOwner(UIParent, 'ANCHOR_NONE');

   updateLeaderStatusFlagTime = GetTime();

   DEFAULT_CHAT_FRAME:AddMessage('<CastParty> GUI loaded!');
end

--***************************************************************************
--***************************************************************************
function CP_Template_Initialize(_texture, _status, _healthbar, _healthbarbg, _manabar, _manabarbg )
   this.texture     = _texture;
   this.status      = _status;
   this.healthbar   = _healthbar;
   this.healthbarbg = _healthbarbg;
   this.manabar     = _manabar;
   this.manabarbg   = _manabarbg;
   this.forceUpdate = _false;
   this.inCombat    = _false;
   this.updateTooltip = GetTime();
   this.combatTime    = GetTime();
   this.lastTime      = GetTime();
   this.updateSubTargetTime = GetTime();
   this.PH_expire    = nil;

   id = this:GetID();

   --pet and target don't have a pet associated with them!
   if ( id < 45 ) then
      this.pet = id+45;
      this.showSubTarget = false;
   end

   if id == 90 then
      this.showSubTarget = true;
--~       this.showSubSubTarget = true;
   end

   --the only stuff unique to the castparty frames. other data is necessary (because we don't
   --show range (on normal frames) and we don't have custom fileters (on normal/other frames)
   this.range = -1;

   --register this frame for clicks
   this:RegisterForClicks('LeftButtonUp', 'RightButtonUp', 'MiddleButtonUp', 'Button4Up', 'Button5Up');

   this:SetScript('OnUpdate', nil );
end

--***************************************************************************
--***************************************************************************
function CP_Template_Aura_Init()

   this.updateTooltip = GetTime();

   --register this frame for clicks
   this:RegisterForClicks('LeftButtonUp', 'RightButtonUp', 'MiddleButtonUp', 'Button4Up', 'Button5Up');

   if this:GetParent():GetID() > 44 and this:GetParent():GetID() ~= 90 then
   this:SetScale(0.75); end


end

--***************************************************************************
--***************************************************************************
function CastParty_UpdateMember(_id, _group)

   --logic for when we have no clue about the party/raid member thing.
   if not _id then
      --this is because we want to FORCE a group update from CastParty_GUI_Init when we init.
      if not _group then
         runLeaderOnceMore = true;
         for i=0, 4 do
            CastParty_UpdateMember(i, true);     --update the party member.
            CastParty_UpdateMember(i+45, true);  --update their pet
         end
      else
         for i=0, 4 do
            CastParty_UpdateMember(i);     --update the party member.
            CastParty_UpdateMember(i+45);  --update their pet
         end
      end

      -- this is to allow updating for the monitor frames.
--      monitoringUnits = false;
--      for k,v in CP_monitor_units do
--         if k then
--            monitoringUnits = true;
--         end
--         if v > 100 then
--            CastParty_UpdateMember(v-100, true);
--            CastParty_UpdateMember(v-55, true);
--         else
--            CastParty_UpdateMember(v, true);
--         end
--      end
--      if monitoringUnits then
----         CastParty_Refresh_Monitor();
--      end

      return;
   end

   unit = CP_units[_id];
   unitName = UnitName(unit);
   frame = getglobal('CastPartyMember'.._id);

   if _group and frame:IsVisible() then --added the frame part because of issues with invisible (for some reason, hidden) frames not updating.
      if UnitExists(unit) then
         if CastParty_Group_Memory[unitName] and CastParty_Group_Memory[unitName]._id == _id  then
--            if CastParty_Debug then CastParty_Debug(3, 'Not Updating member', unitName, 'they haven't changed.') end;
            return;
         elseif unitName then
--            if CastParty_Debug then CastParty_Debug(3, 'Adding unit', unitName) end;
            CastParty_Group_Memory[unitName] =
               {
                  _unitName = unitName,
                  _id = _id,
                  _unit = unit,
                  _delete = false,
               }
         end
      end

      for eachName in CastParty_Group_Memory do
         _unitName = UnitName(CastParty_Group_Memory[eachName]._unit);
         if not (_unitName) then  --they no longer exist
--            if CastParty_Debug then CastParty_Debug(3, 'Removing unit (Doesn't Exist)', eachName) end;
            CastParty_Group_Memory[eachName]._delete = true;
         elseif CastParty_Group_Memory[eachName]._unit == unit then     --the unit exists, but we need to make sure to compare the same units
            if CastParty_Group_Memory[eachName]._unitName ~= unitName then
--               if CastParty_Debug then CastParty_Debug(3, 'Removing unit (Different unit than before)', eachName) end;
               CastParty_Group_Memory[eachName]._delete = true;
            end
         end
      end

      for eachName in CastParty_Group_Memory do
         if CastParty_Group_Memory[eachName]._delete == true then
            --setting to nil...
            CastParty_Group_Memory[eachName] = nil;
            --setting table size to appropriate size.
            --doing this and setting nil, is the same thing that table.remove does, but I just don't have and
            -- index to do this, i have a name... so i have to do it manually.
            table.setn(CastParty_Group_Memory, table.getn(CastParty_Group_Memory)-1)
         end
      end

   end

   --need to have error checking
   if (not CastPartyConfig.showPlayer) and (_id == 0 or _id == 45) then
      if CastParty_Debug then CastParty_Debug(2, 'player frame isnt showing! Abort update!') end;
      return;
   end
   if not CastPartyConfig.showParty and ((_id > 0 and _id <= 4) or (_id > 45 and _id <= 49)) then
      if CastParty_Debug then CastParty_Debug(2, 'party frames isnt showing! Abort update!') end;
      return;
   end
--   if not CastPartyConfig.show_raid and ((_id > 4 and _id < 45) or (_id > 49 and _id < 90)) then
--      if CastParty_Debug then CastParty_Debug(2, 'Castparty raid frame isn't showing! Abort update!') end;
--      return;
--   end

   --don't need to update this for the target, or pets. (target has it's own thing, and pets can't be leaders...)
   if _id < 45 then
      CastParty_UpdateMasterStatus();
      CastParty_UpdateLeaderStatus();
      CastParty_UpdateRaidTargetIconStatus(_id);
   end

   CastParty_UpdateId(_id)
   CastParty_PlaceFrames(_id);
   CastParty_UpdateIdHealth(_id);
   CastParty_UpdateIdMana(_id);

   CastParty_UpdateCombatStatus(_id);
   CastParty_UpdatePvPStatus(_id);


   CastParty_UpdateAuras(_id);
   CastParty_DisplayAuras(_id);
end


--***************************************************************************
--***************************************************************************
function CastParty_classColor(_unit)


	_, englishClass = UnitClass(_unit);

	if englishClass == nil then
	   return {r = 1,
	           g = 1,
	           b = 1,};
	end

	return RAID_CLASS_COLORS[englishClass];

--record of how to do color conversions...
--	return {r = tonumber(string.sub(classColor, 1, 2), 16) / 255.0,
--	        g = tonumber(string.sub(classColor, 3, 4), 16) / 255.0,
--	        b = tonumber(string.sub(classColor, 5, 6), 16) / 255.0};
end

--***************************************************************************
--***************************************************************************
-- Converts a color in the format of 3 floats in the range 0.0 - 1.0 into
-- one hexadecimal number with a fixed size of 6 digits (2 per float)
function CastParty_FloatToHex(r, g, b)
	return string.format('%02X%02X%02X', r * 255.0, g * 255.0, b * 255.0);
end

--***************************************************************************
--***************************************************************************
function CastParty_GetDifficultyColor(_level)
	levelDifference = _level - UnitLevel('player');
	if ( levelDifference >= 5 ) then
		levelDifferenceColor = '|cffff1919';
	elseif ( levelDifference >= 3 ) then
		levelDifferenceColor = '|cffff7f3f';
   elseif ( levelDifference >= -2 ) then
		levelDifferenceColor = '|cffffff00';
	elseif ( -levelDifference <= GetQuestGreenRange() ) then
		levelDifferenceColor = '|cff3fbd3f';
	else
		levelDifferenceColor = '|cff7f7f7f';
	end
	return levelDifferenceColor;
end

--***************************************************************************
--***************************************************************************
function CastParty_ResetWatchList()
   if not UnitInGroup('player') then
      for _, value in pairs(CP_units) do
         CP_watched[value] = {};
      end
   end
end


--***************************************************************************
--***************************************************************************
--this is to handle the right click menu stuff.
function CastParty.Init_DropDowns()
   --Sub Target dropdown stuff!!!
   UnitPopupButtons['SUBTARGET']	   = { text = TEXT(CASTPARTY_TARGET), dist = 0 };
   UnitPopupButtons['UNSUBTARGET']	= { text = TEXT(CASTPARTY_UNTARGET), dist = 0 };

   UnitPopupButtons['SUBSUBTARGET']	   = { text = TEXT(CASTPARTY_TARGET..' 2'), dist = 0 };
   UnitPopupButtons['UNSUBSUBTARGET']	= { text = TEXT(CASTPARTY_UNTARGET..' 2'), dist = 0 };

   table.insert(UnitPopupMenus['PLAYER'], table.getn(UnitPopupMenus['PLAYER'])-1, 'SUBTARGET');
   table.insert(UnitPopupMenus['PLAYER'], table.getn(UnitPopupMenus['PLAYER'])-1, 'SUBSUBTARGET');
   table.insert(UnitPopupMenus['PLAYER'], table.getn(UnitPopupMenus['PLAYER'])-1, 'UNSUBTARGET');
   table.insert(UnitPopupMenus['PLAYER'], table.getn(UnitPopupMenus['PLAYER'])-1, 'UNSUBSUBTARGET');

   table.insert(UnitPopupMenus['PET'], table.getn(UnitPopupMenus['PET'])-1, 'SUBTARGET');
   table.insert(UnitPopupMenus['PET'], table.getn(UnitPopupMenus['PET'])-1, 'SUBSUBTARGET');
   table.insert(UnitPopupMenus['PET'], table.getn(UnitPopupMenus['PET'])-1, 'UNSUBTARGET');
   table.insert(UnitPopupMenus['PET'], table.getn(UnitPopupMenus['PET'])-1, 'UNSUBSUBTARGET');

   table.insert(UnitPopupMenus['PARTY'], table.getn(UnitPopupMenus['PARTY'])-1, 'SUBTARGET');
   table.insert(UnitPopupMenus['PARTY'], table.getn(UnitPopupMenus['PARTY'])-1, 'SUBSUBTARGET');
   table.insert(UnitPopupMenus['PARTY'], table.getn(UnitPopupMenus['PARTY'])-1, 'UNSUBTARGET');
   table.insert(UnitPopupMenus['PARTY'], table.getn(UnitPopupMenus['PARTY'])-1, 'UNSUBSUBTARGET');

   table.insert(UnitPopupMenus['RAID'], table.getn(UnitPopupMenus['RAID'])-1, 'SUBTARGET');
   table.insert(UnitPopupMenus['RAID'], table.getn(UnitPopupMenus['RAID'])-1, 'SUBSUBTARGET');
   table.insert(UnitPopupMenus['RAID'], table.getn(UnitPopupMenus['RAID'])-1, 'UNSUBTARGET');
   table.insert(UnitPopupMenus['RAID'], table.getn(UnitPopupMenus['RAID'])-1, 'UNSUBSUBTARGET');

--   --raid dropdown stuff!!!
--   UnitPopupButtons['MONITOR']	= { text = TEXT(CASTPARTY_MONITOR), dist = 0 };
--   UnitPopupButtons['UNMONITOR']	= { text = TEXT(CASTPARTY_UNMONITOR), dist = 0 };
--
--   table.insert(UnitPopupMenus['RAID'], table.getn(UnitPopupMenus['RAID'])-1, 'MONITOR');
--   table.insert(UnitPopupMenus['RAID'], table.getn(UnitPopupMenus['RAID'])-1, 'UNMONITOR');

end

--***************************************************************************
--***************************************************************************
function CastParty_UnitPopup_HideButtons()

	CP_UnitPopup_HideButtons();

	dropdownMenu = getglobal(UIDROPDOWNMENU_INIT_MENU);
	name = dropdownMenu.name;
	id = CP_ids[dropdownMenu.unit];

   if not id then
      if CastParty_Debug then CastParty_Debug(3, 'Error with dropdown... no ID for it! (click on a frame next time!)') end;
      return;
   end

   frame = getglobal('CastPartyMember'..id);

   if string.find(this:GetName(), 'CastParty') then
      CastPartyFrameCheck = true;
   else
      CastPartyFrameCheck = false;
   end

	for index, value in UnitPopupMenus[dropdownMenu.which] do

	   if ( value == 'SUBTARGET' ) then
	      if CastPartyFrameCheck then
	         if not frame.showSubTarget then
   				UnitPopupShown[index] = 1;
   			else
   			   UnitPopupShown[index] = 0;
   			end
   		else
   		   UnitPopupShown[index] = 0;
   		end
	   elseif ( value == 'UNSUBTARGET' ) then
	      if CastPartyFrameCheck then
	         if frame.showSubTarget then
   				UnitPopupShown[index] = 1;
   			else
   			   UnitPopupShown[index] = 0;
   			end
			else
			   UnitPopupShown[index] = 0;
			end
	   elseif ( value == 'SUBSUBTARGET' ) then
	      if CastPartyFrameCheck then
	         if not frame.showSubSubTarget then
   				UnitPopupShown[index] = 1;
   			else
   			   UnitPopupShown[index] = 0;
   			end
   		else
   		   UnitPopupShown[index] = 0;
   		end
	   elseif ( value == 'UNSUBSUBTARGET' ) then
	      if CastPartyFrameCheck then
	         if frame.showSubSubTarget then
   				UnitPopupShown[index] = 1;
   			else
   			   UnitPopupShown[index] = 0;
   			end
			else
			   UnitPopupShown[index] = 0;
			end
	   elseif ( value == 'MONITOR' ) then
	      if CP_monitor_units[name] or not CastPartyConfig.showMonitor then
				UnitPopupShown[index] = 0;
			else
--          removed this until i can figure out WTF is going on.
--			   UnitPopupShown[index] = 1;
			   UnitPopupShown[index] = 0;
			end
	   elseif ( value == 'UNMONITOR' ) then
	      if CP_monitor_units[name] and CastPartyConfig.showMonitor then
				UnitPopupShown[index] = 0;
			else
			   UnitPopupShown[index] = 0;
			end
	   end
	end
end

--***************************************************************************
--***************************************************************************
 --what is the NEW id??
local function swapID(_id)
   --switch around the tables, so that the ID's that are we are monitoring are ID's 5-15. (and 50-60 for pets)
   --this is so that the current framework doesn't have to change at all.

   if table.getn(CP_monitor_units) then
      size = table.getn(CP_monitor_units);
   else
      size = 0;
   end

   offsetID = size+5;
   --this is for the UNITS table
   tempUnit = CP_units[offsetID];
   CP_units[offsetID] = CP_units[_id];
   CP_units[_id] = tempUnit;
   return offsetID;
end

--***************************************************************************
--***************************************************************************
local function swapUnit(_offsetID)
   offsetUnit = CP_units[_offsetID];
   --this is for the ID'S table
   tempID = CP_ids[offsetUnit];
   CP_ids[offsetUnit] = CP_ids[unit];
   CP_ids[unit] = tempID;
   return offsetUnit;
end

--***************************************************************************
--***************************************************************************
function CastParty_UnitPopup_OnClick()
	dropdownFrame = getglobal(UIDROPDOWNMENU_INIT_MENU);
	button = this.value;
	unit = dropdownFrame.unit;
	name = dropdownFrame.name;
   notFound = false;
   id = CP_ids[unit];
   specialID = id;

   if id then
      frame = getglobal('CastPartyMember'..id);
   end

	--allow them to show the subtarget frame
	if ( id and button == 'SUBTARGET' ) then
      frame.showSubTarget = true;
      frame.forceUpdate = true;

	--don't let them show the subtarget frame
	elseif ( id and  button == 'UNSUBTARGET' ) then
      frame.showSubTarget = false;
      frame.showSubSubTarget = false;
      frame.forceUpdate = true;

   elseif ( id and button == 'SUBSUBTARGET' ) then
      frame.showSubTarget = true;
      frame.showSubSubTarget = true;
      frame.forceUpdate = true;

	--don't let them show the subtarget frame
	elseif ( id and  button == 'UNSUBSUBTARGET' ) then
      frame.showSubSubTarget = false;
      frame.forceUpdate = true;


	--add them to the monitored list
	elseif ( id and button == 'MONITOR' ) then
      --only allow IF there are less that 10 people being monitored
      if table.getn(CP_monitor_units) > 10 then
         return;
      end

      --set the new ones...
      newID = swapID(id);
      swapID(id+45)

      newUNIT = swapUnit(newID)
      swapUnit(newID+45);

      --now, set our local vars to the new ones...
      unit = newUNIT;
      id = newID;
      specialID = id;

      --now... do they have a pet? if so... add it as well to the monitor list..
      if UnitExists(CP_units[id+45]) then
         specialID = id+100;
      end

      CP_monitor_units[name] = specialID;

      if specialID > 100 then
         CastParty_UpdateMember(specialID-100);
         CastParty_UpdateMember(specialID-55);
      else
         CastParty_UpdateMember(specialID);
      end
--      CastParty_Refresh_Monitor();
		CastParty_Debug(2, 'adding ', name, ' to the monitor list :', id)
   --remove them from the monitor list
	elseif ( id and button == 'UNMONITOR' ) then
      --now.. if they had a pet.. we need to remove it too!
      if CP_monitor_units[name] > 100 then
         specialID = CP_monitor_units[name];
         getglobal('CastPartyMember' .. specialID-100):SetScript('OnUpdate', nil );
         getglobal('CastPartyMember' .. specialID-100).showSubTarget = false;
         getglobal('CastPartyMember' .. specialID-100):Hide()
         getglobal('CastPartyMember' .. specialID-55):SetScript('OnUpdate', nil );
         getglobal('CastPartyMember' .. specialID-100).showSubTarget = false;
         getglobal('CastPartyMember' .. specialID-55):Hide()
      else
         getglobal('CastPartyMember' .. specialID):SetScript('OnUpdate', nil );
         getglobal('CastPartyMember' .. specialID).showSubTarget = false;
         getglobal('CastPartyMember' .. specialID):Hide()
      end
      --remove them from the monitor list
		CP_monitor_units[name] = nil;
		table.setn(CP_monitor_units, table.getn(CP_monitor_units)-1);
--      CastParty_Refresh_Monitor();
		CastParty_Debug(2, 'removing ', name, ' from the monitor list :', id)
	else
	   notFound = true;
	end

	if notFound then
		CP_UnitPopup_OnClick();
	else
	   PlaySound('UChatScrollButton');
	end
end


--***************************************************************************
--***************************************************************************
function CP_Aura_OnUpdate()
   local currentTime = GetTime();
   --only allow the tooltip mousovers to update ONCE every .25 seconds.
   if ( GameTooltip:IsOwned(this) and (currentTime > this.updateTooltip )) then
      CastParty_EnterAura();
      this.updateTooltip = currentTime + 0.25;
   end

end

--***************************************************************************
--***************************************************************************
function CP_Template_OnUpdate()

--   local playerX, playerY = GetPlayerMapPosition('player');
--   note(playerX);
   local currentTime = GetTime()
   --This is so I don't call the UpdateLeader code a billion times a second.
   --I acknowlege that I need to update it, then I really update it here.
   if ( CastParty.State.runReallyRunLeader and currentTime > updateLeaderStatusFlagTime ) then
      CastParty_ReallyUpdateLeaderStatus();
      CastParty.State.runReallyRunLeader = false;
   end

   --only allow the target/target indicators to update ONCE every .25 seconds.
   if ( currentTime > this.updateSubTargetTime ) then
      CastParty_UpdateSubTarget(this:GetID());
      this.updateSubTargetTime = currentTime + 0.25;
   end

   --only allow the tooltip mousovers to update ONCE every .25 seconds.
   -- need to have this update more frequently, but only when the healer stuff is active!
   if ( GameTooltip:IsOwned(this) and (currentTime > this.updateTooltip or (this.PH_expire and currentTime > this.PH_expire)) ) then
      CastParty_EnterUnit();
      this.updateTooltip = currentTime + 0.25;
   end

   -- this is for the update (hiding...) of the healer icon!
   if ( this.PH_expire and currentTime > this.PH_expire ) then
      this.PH_expire = nil;
      getglobal(this:GetName().. 'HealerIcon'):Hide();
   end

   -- want to force the display status of a frame
   -- this frame is set to :Show() right before this call.
   -- CastParty_ResetDisplay() - in options, doesn't :Show() this frame before it's called.
   if this.forceUpdate then
      this.forceUpdate = false;
      CastParty_UpdateMember(this:GetID());
      return;
   end

   --timer to check the combat status every 1 seconds.
   if (currentTime > this.combatTime) then
      CastParty_UpdateCombatStatus(this:GetID());
      this.combatTime = currentTime + 1;
   end


   --this is because we don't need to check right away if we just forced an updatePing.
   --and delay the normal operation by the range_check_interval (since we just did it)
   if this.forceUpdatePing then
      this.forceUpdatePing = false;
      this.lastTime = this.lastTime + CastPartyConfig.range_check_interval;
      return;
   end

   --normal pinger updater timer thing.
   if (currentTime > this.lastTime) then
      if not UnitExists(CP_units[this:GetID()]) then
         this.lastTime = currentTime + CastPartyConfig.range_check_interval;
         return;
      end
      CastParty_UpdateRangeDisplay(this:GetID());
      this.lastTime = currentTime + CastPartyConfig.range_check_interval;
   end
end