
local frame

local cpo_optionIDs = {
   -- General
   [1] = 'showPlayer',
   [2] = 'hide_party_frame',
   [3] = 'show_statusbar_frames',
   [4] = 'hot_key_style',
   [5] = 'showParty',
   [6] = 'locked',
   [7] = 'pet_alignment',
   [8] = 'showTarget',
   [9] = 'hide_target_frame',
   [10] = 'hide_player_frame',
   [11] = 'update_range',
   [12] = 'cp_blizz_clicks',
   [13] = 'cp_clicks',

   -- Buffs
   [101] = 'show_debuffs',
   [102] = 'show_buffs',
   [103] = 'filter_buffs',
   [104] = 'filter_debuffs',
   [106] = 'show_aura_tooltips',
   [1061] = 'hide_aura_tooltips_in_combat',
   [107] = 'show_common_buffs',
   [108] = 'buff_alignment',
   [113] = 'debuff_alignment',
   [114] = 'show_hots',
   [117] = 'max_auras',
   [118] = 'pet_buff_alignment',
   [119] = 'pet_debuff_alignment',


   -- Bars
   [200] = 'show_party_tooltips',
   [2001] = 'hide_unit_tooltips_in_combat',
   [201] = 'show_power',
   [203] = 'show_flags',
   [204] = 'flow_up',
   [205] = 'health_bar_height',
   [206] = 'mana_bar_height',
   [207] = 'bar_width',
   [208] = 'unit_text_template',
   [209] = 'target_text_template',
   [210] = 'color_names',
   [211] = 'color_level',

   -- Behavior
   [300] = 'grow_with_depletion_health',
   [3001] = 'grow_with_depletion_mana',
   [3002] = 'grow_with_depletion_rage',
   [3003] = 'grow_with_depletion_focus',
   [3004] = 'grow_with_depletion_energy',
   [301] = 'spell_choice_threshold',
   [302] = 'heal_cancel_threshold',
   [303] = 'auto_group_threshold',
   [304] = 'emergency_in_combat',
   [305] = 'emergency_health_percent',
   [306] = 'emergency_damage_window',
   [308] = 'resurrect_dead',
   [309] = 'click_to_rebuff',
   [311] = 'click_to_debuff',
   [312] = 'rightclick_to_remove',

   -- Messages
   [400] = 'message_heals',
   [401] = 'message_non_heals',
   [402] = 'message_player_only',
   [403] = 'message_health_percent',
   [404] = 'message_spell_text',
   [405] = 'message_failures',
   [406] = 'message_res',
   [407] = 'message_failure_percent',
   [408] = 'message_disable_mana',

   -- Colors
   [503] = 11,  --full color          --not it cpo_colors, because cpo_colors has alpha settings in it
   [504] = 10,  --delpleted color     --this is because it was created goofy by alleris.. BAH!
   [505] = 1,   --full color
   [506] = 0,   --depleted color

   --Advanced
   [900] = 'range_check_interval',
   [901] = 'showMonitor',
   [902] = 'auto_cast_inner_fire',
   [903] = 'stop_autocast',
   [904] = 'frameSpacing',
   [905] = 'advanced_spells',
   [906] = 'overheal_protection',
   [907] = 'shield_detection',
   [908] = 'max_rank_hot',
   [909] = 'mana_conserve_threshold',
   [910] = 'bandage_threshold',
   [911] = 'pet_health_value',
   [912] = 'debug_level',
   [913] = 'shield_if_critical',

}

local cpo_colors = {
   [500] = 'text_rgb',
   [501] = 'health_bg_rgb',
   [502] = 'mana_bg_rgb',
   
   [507] = 'text_mana_rgb',
   [508] = 'text_rage_rgb',
   [509] = 'text_energy_rgb',
}

local cpo_textboxes = {
   [208] = 'unit_text_template',
   [209] = 'target_text_template',
   [404] = 'message_spell_text'
}

local cpo_sliderValues = {
   [205] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Health Bar Height: '
         },
   [206] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Mana Bar Height: '
         },
   [207] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Bar Width: '
         },
   [117] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Max auras: '
         },
   [301] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Spell Choice Thresh: '
         },
   [302] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Heal Cancel Thresh: '
         },
   [303] = {
            value_scale = 100,
            text_scale = 100,
            text = 'AutoGroup Thresh: '
         },
   [305] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Emer. Health %: '
         },
   [306] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Emer Dmg Window: '
         },
   [307] = {
            value_scale = 10,
            text_scale = 1,
            text = 'Heal Cancel Time: '
         },
   [403] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Message Health%: '
         },
   [407] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Message Fail %: '
         },
   [408] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Disable Spam %: '
         },
   [900] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Range Check Interval: '
         },
   [904] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Frame Spacing %: '
         },
   [909] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Mana Conserve %: '
         },
   [910] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Bandage Thresh %: '
         },
   [911] = {
            value_scale = 100,
            text_scale = 100,
            text = 'Pet Health Weight %: '
         },
   [912] = {
            value_scale = 1,
            text_scale = 1,
            text = 'Debug Level: '
         },

}

-- Dropdown lists
local PET_ALIGNMENT_DDLIST = {
   CASTPARTY_ALIGNMENT_HIDE,
   CASTPARTY_ALIGNMENT_RIGHT,
   CASTPARTY_ALIGNMENT_LEFT,
   CASTPARTY_ALIGNMENT_BELOW
}

local AURA_ALIGNMENT_DDLIST = {
   CASTPARTY_ALIGNMENT_RIGHT,
   CASTPARTY_ALIGNMENT_LEFT,
   CASTPARTY_ALIGNMENT_BELOW
}

local MESSAGE_CHANNEL_DDLIST = {
   CASTPARTY_MESSAGECHANNEL_RAID,
   CASTPARTY_MESSAGECHANNEL_PARTY,
   CASTPARTY_MESSAGECHANNEL_PLAYER,
   CASTPARTY_MESSAGECHANNEL_WHISPER,
}


local dropdown_selected;

--***************************************************************************
--***************************************************************************
function CastPartyOptions_OnLoad()
   ---- Interoperability MyAddOns ----
   DEFAULT_CHAT_FRAME:AddMessage('<CastParty> Control Panel loaded!');
   if(myAddOnsList and myAddOnsFrame) then
      myAddOnsList.CastPartyOptions = {
         name = 'CastPartyOptions',
         description = 'An control panel GUI for setting the CastParty options',
         version = CASTPARTY_VERSION,
         category = MYADDONS_CATEGORY_CLASS,
         frame = 'CastPartyOptions',
         optionsframe = 'CastPartyOptions'
      };
   end

   --hooks to control the update display stuff in the options from within bonus scanner.
   if BonusScanner_Update then
      CP_BonusScanner_Update = BonusScanner_Update
      BonusScanner_Update    = CastParty_BonusScanner_Update
   end

end


--***************************************************************************
--***************************************************************************
-- hook update stuff within bonusscanner.
function CastParty_BonusScanner_Update()
   --for CastParty
   if CastPartyOptions and CastPartyOptions:IsVisible() then
      --scan the player for healing bonus items...
      CastParty.State.healing_base = 0;
      if (BonusScanner.active) then
         CastParty.State.healing_base = BonusScanner:GetBonus('HEAL')
         if tonumber(CastParty.State.healing_base) > 0 then
   		   CastPartyOptionsGeneralFrameHealingBonus:SetText(CASTPARTY_HEALING_BONUS .. GRN .. CastParty.State.healing_base);
   		else
   		   CastPartyOptionsGeneralFrameHealingBonus:SetText("");
   		end
      end
   end
   CP_BonusScanner_Update();

end
--***************************************************************************
--***************************************************************************
-- Change an option on event
function CastPartyChangeOption(option, value, value2, value3, value4)

   if cpo_sliderValues[option] then
      value = value / cpo_sliderValues[option].value_scale;
      frame = getglobal(this:GetName() .. 'Text');
      frame:SetPoint('BOTTOMRIGHT', this, 'BOTTOMLEFT', -10, 2);
      frame:SetText(cpo_sliderValues[option].text .. value * cpo_sliderValues[option].text_scale);
   end

   if cpo_colors[option] then
      value = {r = value, g = value2, b = value3, a = value4}
      CastPartyConfig[cpo_colors[option]] = value;
      CastParty_ResetDisplay();
      return;
   end

   if cpo_textboxes[option] then
      CastPartyConfig[cpo_textboxes[option]] = value;
   end

   if option >= 503 and option < 520 then
      value = {r = value, g = value2, b = value3}
      CastPartyConfig.bar_colors[cpo_optionIDs[option]] = value;
      CastParty_ResetDisplay();
      return;
   end

   if option == 912 then
      CastParty.DebugLevel = value;
      CastPartySave.DebugLevel = value;
      CastParty_ResetDisplay();
   end

   if cpo_optionIDs[option] then
      local tempValue;
      if this:GetFrameType() == 'CheckButton' then
         if value then
            tempValue = true;
         else
            tempValue = false;
         end
      end

      if tempValue == nil then
         tempValue = value;
      end

      if CastParty_Debug then CastParty_Debug(2, 'option ID', option, ' : ', cpo_optionIDs[option], ' : value ', tostring(tempValue)) end;
      CastPartyConfig[cpo_optionIDs[option]] = tempValue;
      CastParty_ResetDisplay();
      return;
   end
end

--***************************************************************************
--***************************************************************************
function CastParty_ResetDisplay()
   if CastParty_Debug then CastParty_Debug( 1, 'Force GUI Update!') end;

   --this is to save me from running updates before i really want to.
   if CastPartyOptions:IsVisible() then
      CastParty.GUI.Init();
      --scan the player for healing bonus items...
      CastParty.State.healing_base = 0;
      if (BonusScanner and BonusScanner.active) then
         CastParty.State.healing_base = BonusScanner:GetBonus('HEAL')
         if tonumber(CastParty.State.healing_base) > 0 then
   		   CastPartyOptionsGeneralFrameHealingBonus:SetText(CASTPARTY_HEALING_BONUS .. GRN .. CastParty.State.healing_base);
   		else
   		   CastPartyOptionsGeneralFrameHealingBonus:SetText("");
   		end
      end
   end
end


--***************************************************************************
--***************************************************************************
-- Dropdowns
function DDPetAlignment_Initialize()
   for i = 1, table.getn(PET_ALIGNMENT_DDLIST), 1 do
      local info = { };
      info.text = PET_ALIGNMENT_DDLIST[i];
      info.func = DDPetAlignment_OnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function DDPetBuffAlignment_Initialize()
   for i = 1, table.getn(AURA_ALIGNMENT_DDLIST), 1 do
      local info = { };
      info.text = AURA_ALIGNMENT_DDLIST[i];
      info.func = DDPetBuffAlignment_OnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function DDPetDebuffAlignment_Initialize()
   for i = 1, table.getn(AURA_ALIGNMENT_DDLIST), 1 do
      local info = { };
      info.text = AURA_ALIGNMENT_DDLIST[i];
      info.func = DDPetDebuffAlignment_OnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function DDBuffAlignment_Initialize()
   for i = 1, table.getn(AURA_ALIGNMENT_DDLIST), 1 do
      local info = { };
      info.text = AURA_ALIGNMENT_DDLIST[i];
      info.func = DDBuffAlignment_OnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function DDDebuffAlignment_Initialize()
   for i = 1, table.getn(AURA_ALIGNMENT_DDLIST), 1 do
      local info = { };
      info.text = AURA_ALIGNMENT_DDLIST[i];
      info.func = DDDebuffAlignment_OnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function DDMessageChannel_Initialize()
   for i = 1, table.getn(MESSAGE_CHANNEL_DDLIST), 1 do
      local info = { };
      info.text = MESSAGE_CHANNEL_DDLIST[i];
      info.func = DDMessageChannel_OnClick;
      UIDropDownMenu_AddButton(info);
   end
end

function DDPetAlignment_OnClick()
   UIDropDownMenu_SetSelectedID(CastPartyOptionsGeneralFrameDDPetAlignment, this:GetID())
   CastPartyConfig['pet_alignment'] = PET_ALIGNMENT_DDLIST[this:GetID()]
   CastParty_ResetDisplay();
end

function DDBuffAlignment_OnClick()
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDBuffAlignment, this:GetID())
   CastPartyConfig['buff_alignment'] = AURA_ALIGNMENT_DDLIST[this:GetID()]
   CastParty_ResetDisplay();
end

function DDDebuffAlignment_OnClick()
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDDebuffAlignment, this:GetID())
   CastPartyConfig['debuff_alignment'] = AURA_ALIGNMENT_DDLIST[this:GetID()]
   CastParty_ResetDisplay();
end
function DDMessageChannel_OnClick()
   UIDropDownMenu_SetSelectedID(CastPartyOptionsMessagesFrameDDMessageChannel, this:GetID())
   CastPartyConfig['message_channel'] = MESSAGE_CHANNEL_DDLIST[this:GetID()]
   CastParty_ResetDisplay();
end

function DDPetBuffAlignment_OnClick()
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDPetBuffAlignment, this:GetID())
   CastPartyConfig['pet_buff_alignment'] = AURA_ALIGNMENT_DDLIST[this:GetID()]
   CastParty_ResetDisplay();
end

function DDPetDebuffAlignment_OnClick()
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDPetDebuffAlignment, this:GetID())
   CastPartyConfig['pet_debuff_alignment'] = AURA_ALIGNMENT_DDLIST[this:GetID()]
   CastParty_ResetDisplay();
end

--***************************************************************************
--***************************************************************************
-- Color pickers
function CastPartyOptions_RGBColor()
   local r, g, b = ColorPickerFrame:GetColorRGB();
    if (not ColorPickerFrame:IsShown()) then
       CastPartyChangeOption(ColorPickerFrame.frame:GetID(), r, g, b);
   end
end

--***************************************************************************
--***************************************************************************
function CastPartyOptions_RGBAColor()
   local r, g, b = ColorPickerFrame:GetColorRGB();
   local a = OpacitySliderFrame:GetValue();

   if (not ColorPickerFrame:IsShown()) then
       CastPartyChangeOption(ColorPickerFrame.frame:GetID(), r, g, b, a);
   end
end

--***************************************************************************
--***************************************************************************
function CastPartyOptionsShowColorPicker(option_id)

   local frame = this;

   if CastPartyConfig[cpo_colors[option_id]] then
      frame.r = CastPartyConfig[cpo_colors[option_id]].r;
      frame.g = CastPartyConfig[cpo_colors[option_id]].g;
      frame.b = CastPartyConfig[cpo_colors[option_id]].b;
      if option_id == 501 or option_id == 502 then  --the background
         frame.swatchFunc = CastPartyOptions_RGBAColor
         frame.opacity = CastPartyConfig[cpo_colors[option_id]].a;
         frame.hasOpacity = 1
      else
         frame.swatchFunc = CastPartyOptions_RGBColor
         frame.hasOpacity = nil
      end
   elseif option_id >= 503 then  --health full color
      frame.r = CastPartyConfig.bar_colors[cpo_optionIDs[option_id]].r;
      frame.g = CastPartyConfig.bar_colors[cpo_optionIDs[option_id]].g;
      frame.b = CastPartyConfig.bar_colors[cpo_optionIDs[option_id]].b;
      frame.swatchFunc = CastPartyOptions_RGBColor
      frame.hasOpacity = nil
   end



   CloseMenus()
   ColorPickerFrame.frame = frame
   UIDropDownMenuButton_OpenColorPicker(frame);
end

--***************************************************************************
--***************************************************************************
function CastPartyOptionsResetAllValues()
   StaticPopupDialogs['CASTPARTY_RESET'] = {
      showAlert=1,
      timeout=0,
      text = TEXT(CASTPARTY_RESET_CONFIRMATION),
      button1=TEXT(OKAY),
      button2=TEXT(CANCEL),
      OnAccept = function()
         CastPartyConfig = {};
         ReloadUI();
         end,
         };
   StaticPopup_Show('CASTPARTY_RESET', nil);

end

--***************************************************************************
--***************************************************************************
function CastPartyOptionsSetTooltip(id)
   local tip;

   tip = getglobal('CASTPARTY_TOOLTIP'..id);

   GameTooltip:SetOwner(this, 'ANCHOR_TOPLEFT');
   GameTooltip:SetBackdropColor(0.0, 0.0, 0.0);
   if (tip ~= nil) then
      GameTooltip:SetText(tip, 1.0, 1.0, 1.0);
   end
   if CastParty_TweakTipPosition then
      CastParty_TweakTipPosition();
   end

end

--***************************************************************************
--***************************************************************************
-- Gets the index of an item in a list
function GetDropDownID(list, value)
   for i = 1, table.getn(list), 1 do
      if (list[i] == value) then
         return i;
      end
   end
   return -1;
end


--***************************************************************************
--***************************************************************************
-- Uses AlternateCapitalization to find the endings of words,
-- and adds the specified chars after each word
function AddChars(str, chars)
   local retVal = "";
   local index = 1;
   local lower_str = strlower(str);
   for i=2, strlen(str), 1 do
      if (strbyte(str, i) ~= strbyte(lower_str, i)) then
         retVal = retVal .. strsub(str, index, i-1) .. chars;
         index = i;
      end
   end
   retVal = retVal .. strsub(str, index, i);
   return retVal;
end

--***************************************************************************
--***************************************************************************
function CastPartyOptions_ShowTab(id)
   CastPartyOptionsGeneralFrame:Hide()
   CastPartyOptionsBuffsFrame:Hide()
   CastPartyOptionsBarsFrame:Hide()
   CastPartyOptionsBehaviorFrame:Hide()
   CastPartyOptionsMessagesFrame:Hide()
   CastPartyOptionsColorsFrame:Hide()
   CastPartyOptionsAdvancedFrame:Hide()

   getglobal('CastPartyOptions'..id..'Frame'):Show();
   getglobal('CastPartyOptionsTitle'):SetText('CPO : '..id);
end

--***************************************************************************
--***************************************************************************
function CastPartyOptions_SetOptionValues()

   -- General Tab
   CastPartyOptionsGeneralFrameCBShowCPPlayer:SetChecked(CastPartyConfig.showPlayer);
   CastPartyOptionsGeneralFrameCBHidePartyFrame:SetChecked(CastPartyConfig.hide_party_frame);
   CastPartyOptionsGeneralFrameCBHidePlayerFrame:SetChecked(CastPartyConfig.hide_player_frame);
   CastPartyOptionsGeneralFrameCBShowStatusBarFrames:SetChecked(CastPartyConfig.show_statusbar_frames);
   CastPartyOptionsGeneralFrameCBShowCP:SetChecked(CastPartyConfig.showParty);
   CastPartyOptionsGeneralFrameCBHideTargetFrame:SetChecked(CastPartyConfig.hide_target_frame);
   CastPartyOptionsGeneralFrameCBShowTargetCP:SetChecked(CastPartyConfig.showTarget);
   CastPartyOptionsGeneralFrameCBLockCP:SetChecked(CastPartyConfig.locked);
   CastPartyOptionsGeneralFrameCBDisableRange:SetChecked(CastPartyConfig.update_range);
   CastPartyOptionsGeneralFrameCBCustomBlizzClick:SetChecked(CastPartyConfig.cp_blizz_clicks);
   CastPartyOptionsGeneralFrameCBCPClicks:SetChecked(CastPartyConfig.cp_clicks);

   UIDropDownMenu_Initialize(CastPartyOptionsGeneralFrameDDPetAlignment,     DDPetAlignment_Initialize);
   UIDropDownMenu_SetSelectedID(CastPartyOptionsGeneralFrameDDPetAlignment,  GetDropDownID(PET_ALIGNMENT_DDLIST, CastPartyConfig.pet_alignment));

   if EzDismount_onload then
      CastPartyOptionsGeneralFrameEZDismount:Show();
   end

   --Buffs Tab
   CastPartyOptionsBuffsFrameCBShowDeBuffs:SetChecked(CastPartyConfig.show_debuffs);
   CastPartyOptionsBuffsFrameCBShowBuffs:SetChecked(CastPartyConfig.show_buffs);
   CastPartyOptionsBuffsFrameCBFilterBuffs:SetChecked(CastPartyConfig.filter_buffs);
   CastPartyOptionsBuffsFrameCBFilterDeBuffs:SetChecked(CastPartyConfig.filter_debuffs);
   CastPartyOptionsBuffsFrameCBShowHOTs:SetChecked(CastPartyConfig.show_hots);
   CastPartyOptionsBuffsFrameCBShowCommonBuffs:SetChecked(CastPartyConfig.show_common_buffs);
   CastPartyOptionsBuffsFrameCBShowAuraTooltips:SetChecked(CastPartyConfig.show_aura_tooltips);

   UIDropDownMenu_Initialize(CastPartyOptionsBuffsFrameDDBuffAlignment,    DDBuffAlignment_Initialize);
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDBuffAlignment,       GetDropDownID(AURA_ALIGNMENT_DDLIST, CastPartyConfig.buff_alignment));

   UIDropDownMenu_Initialize(CastPartyOptionsBuffsFrameDDDebuffAlignment,  DDDebuffAlignment_Initialize);
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDDebuffAlignment,     GetDropDownID(AURA_ALIGNMENT_DDLIST, CastPartyConfig.debuff_alignment));

   UIDropDownMenu_Initialize(CastPartyOptionsMessagesFrameDDMessageChannel, DDMessageChannel_Initialize);
   UIDropDownMenu_SetSelectedID(CastPartyOptionsMessagesFrameDDMessageChannel,   GetDropDownID(MESSAGE_CHANNEL_DDLIST, CastPartyConfig.message_channel));

   UIDropDownMenu_Initialize(CastPartyOptionsBuffsFrameDDPetBuffAlignment, DDPetBuffAlignment_Initialize);
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDPetBuffAlignment,    GetDropDownID(AURA_ALIGNMENT_DDLIST, CastPartyConfig.pet_buff_alignment));

   UIDropDownMenu_Initialize(CastPartyOptionsBuffsFrameDDPetDebuffAlignment, DDPetDebuffAlignment_Initialize);
   UIDropDownMenu_SetSelectedID(CastPartyOptionsBuffsFrameDDPetDebuffAlignment,  GetDropDownID(AURA_ALIGNMENT_DDLIST, CastPartyConfig.pet_debuff_alignment));

   CastPartyOptionsBuffsFrameSLMaxAurasHigh:SetText(tostring(CastPartyConfig.max_debuffs + CastPartyConfig.max_buffs+8));
   CastPartyOptionsBuffsFrameSLMaxAurasLow:SetText('1');
   CastPartyOptionsBuffsFrameSLMaxAuras:SetMinMaxValues(1, CastPartyConfig.max_debuffs + CastPartyConfig.max_buffs + 8);
   CastPartyOptionsBuffsFrameSLMaxAuras:SetValueStep(1);
   CastPartyOptionsBuffsFrameSLMaxAuras:SetValue(CastPartyConfig.max_auras);

   --Bars Tab
   CastPartyOptionsBarsFrameCBShowPartyTooltips:SetChecked(CastPartyConfig.show_party_tooltips);
   CastPartyOptionsBarsFrameCBShowPower:SetChecked(CastPartyConfig.show_power);

   CastPartyOptionsBarsFrameCBShowFlags:SetChecked(CastPartyConfig.show_flags);
   CastPartyOptionsBarsFrameCBFlowUp:SetChecked(CastPartyConfig.flow_up);
   CastPartyOptionsBarsFrameCBColorNames:SetChecked(CastPartyConfig.color_names);
   CastPartyOptionsBarsFrameCBColorLevel:SetChecked(CastPartyConfig.color_level);

   CastPartyOptionsBarsFrameSLHealthBarHeightHigh:SetText('50 pix');
   CastPartyOptionsBarsFrameSLHealthBarHeightLow:SetText('0 pix');
   CastPartyOptionsBarsFrameSLHealthBarHeight:SetMinMaxValues(0, 50);
   CastPartyOptionsBarsFrameSLHealthBarHeight:SetValueStep(1);
   CastPartyOptionsBarsFrameSLHealthBarHeight:SetValue(CastPartyConfig.health_bar_height);

   CastPartyOptionsBarsFrameSLManaBarHeightHigh:SetText('50 pix');
   CastPartyOptionsBarsFrameSLManaBarHeightLow:SetText('0 pix');
   CastPartyOptionsBarsFrameSLManaBarHeight:SetMinMaxValues(0, 50);
   CastPartyOptionsBarsFrameSLManaBarHeight:SetValueStep(1);
   CastPartyOptionsBarsFrameSLManaBarHeight:SetValue(CastPartyConfig.mana_bar_height);

   CastPartyOptionsBarsFrameSLBarWidthHigh:SetText('500 pix');
   CastPartyOptionsBarsFrameSLBarWidthLow:SetText('0 pix');
   CastPartyOptionsBarsFrameSLBarWidth:SetMinMaxValues(0, 500);
   CastPartyOptionsBarsFrameSLBarWidth:SetValueStep(1);
   CastPartyOptionsBarsFrameSLBarWidth:SetValue(CastPartyConfig.bar_width);

   if CastPartyConfig.unit_text_template then
      CastPartyOptionsBarsFrameEBUnitTextTemplate:SetText(CastPartyConfig.unit_text_template);
   end

   if CastPartyConfig.target_text_template then
      CastPartyOptionsBarsFrameEBTargetUnitTextTemplate:SetText(CastPartyConfig.target_text_template);
   end

   --Behavior Tab
   CastPartyOptionsBehaviorFrameCBEmergencyInCombat:SetChecked(CastPartyConfig.emergency_in_combat);

   CastPartyOptionsBehaviorFrameCBGrowWithDepletionHealth:SetChecked(CastPartyConfig.grow_with_depletion_health);
   CastPartyOptionsBehaviorFrameCBGrowWithDepletionMana:SetChecked(CastPartyConfig.grow_with_depletion_mana);
   CastPartyOptionsBehaviorFrameCBGrowWithDepletionRage:SetChecked(CastPartyConfig.grow_with_depletion_rage);
   CastPartyOptionsBehaviorFrameCBGrowWithDepletionFocus:SetChecked(CastPartyConfig.grow_with_depletion_energy);
   CastPartyOptionsBehaviorFrameCBGrowWithDepletionEnergy:SetChecked(CastPartyConfig.grow_with_depletion_focus);

   CastPartyOptionsBehaviorFrameCBResurrectDead:SetChecked(CastPartyConfig.resurrect_dead);
   CastPartyOptionsBehaviorFrameCBClickToRebuff:SetChecked(CastPartyConfig.click_to_rebuff);
   CastPartyOptionsBehaviorFrameCBClickToDebuff:SetChecked(CastPartyConfig.click_to_debuff);
   CastPartyOptionsBehaviorFrameCBRightClickToRemove:SetChecked(CastPartyConfig.rightclick_to_remove);

   CastPartyOptionsBehaviorFrameSLSpellChoiceThresholdHigh:SetText('200%');
   CastPartyOptionsBehaviorFrameSLSpellChoiceThresholdLow:SetText('0%');
   CastPartyOptionsBehaviorFrameSLSpellChoiceThreshold:SetMinMaxValues(0, 200);
   CastPartyOptionsBehaviorFrameSLSpellChoiceThreshold:SetValueStep(1);
   CastPartyOptionsBehaviorFrameSLSpellChoiceThreshold:SetValue(CastPartyConfig.spell_choice_threshold * 100);

   CastPartyOptionsBehaviorFrameSLHealCancelThresholdHigh:SetText('100%');
   CastPartyOptionsBehaviorFrameSLHealCancelThresholdLow:SetText('0%');
   CastPartyOptionsBehaviorFrameSLHealCancelThreshold:SetMinMaxValues(0, 100);
   CastPartyOptionsBehaviorFrameSLHealCancelThreshold:SetValueStep(1);
   CastPartyOptionsBehaviorFrameSLHealCancelThreshold:SetValue(CastPartyConfig.heal_cancel_threshold * 100);

   CastPartyOptionsBehaviorFrameSLAutoGroupThresholdHigh:SetText('200%');
   CastPartyOptionsBehaviorFrameSLAutoGroupThresholdLow:SetText('0%');
   CastPartyOptionsBehaviorFrameSLAutoGroupThreshold:SetMinMaxValues(0, 200);
   CastPartyOptionsBehaviorFrameSLAutoGroupThreshold:SetValueStep(1);
   CastPartyOptionsBehaviorFrameSLAutoGroupThreshold:SetValue(CastPartyConfig.auto_group_threshold * 100);

   CastPartyOptionsBehaviorFrameSLEmergencyHealthPercentHigh:SetText('100%');
   CastPartyOptionsBehaviorFrameSLEmergencyHealthPercentLow:SetText('0%');
   CastPartyOptionsBehaviorFrameSLEmergencyHealthPercent:SetMinMaxValues(0, 100);
   CastPartyOptionsBehaviorFrameSLEmergencyHealthPercent:SetValueStep(1);
   CastPartyOptionsBehaviorFrameSLEmergencyHealthPercent:SetValue(CastPartyConfig.emergency_health_percent * 100);

   CastPartyOptionsBehaviorFrameSLEmergencyDamageWindowHigh:SetText('10 sec');
   CastPartyOptionsBehaviorFrameSLEmergencyDamageWindowLow:SetText('0 sec');
   CastPartyOptionsBehaviorFrameSLEmergencyDamageWindow:SetMinMaxValues(0, 10);
   CastPartyOptionsBehaviorFrameSLEmergencyDamageWindow:SetValueStep(1);
   CastPartyOptionsBehaviorFrameSLEmergencyDamageWindow:SetValue(CastPartyConfig.emergency_damage_window);

   --Messages Tab
   CastPartyOptionsMessagesFrameCBMessageHeals:SetChecked(CastPartyConfig.message_heals);
   CastPartyOptionsMessagesFrameCBMessageNonHeals:SetChecked(CastPartyConfig.message_non_heals);
   CastPartyOptionsMessagesFrameCBMessageFailures:SetChecked(CastPartyConfig.message_failures);
   CastPartyOptionsMessagesFrameCBMessageRes:SetChecked(CastPartyConfig.message_res);

   CastPartyOptionsMessagesFrameSLMessageHealthPercentHigh:SetText('100%');
   CastPartyOptionsMessagesFrameSLMessageHealthPercentLow:SetText('0%');
   CastPartyOptionsMessagesFrameSLMessageHealthPercent:SetMinMaxValues(0, 100);
   CastPartyOptionsMessagesFrameSLMessageHealthPercent:SetValueStep(1);
   CastPartyOptionsMessagesFrameSLMessageHealthPercent:SetValue(CastPartyConfig.message_health_percent * 100);

   if CastPartyConfig.message_spell_text then
      CastPartyOptionsMessagesFrameEBMessageText:SetText(CastPartyConfig.message_spell_text);
   end

   CastPartyOptionsMessagesFrameSLMessageFailPercentHigh:SetText('100%');
   CastPartyOptionsMessagesFrameSLMessageFailPercentLow:SetText('0%');
   CastPartyOptionsMessagesFrameSLMessageFailPercent:SetMinMaxValues(0, 100);
   CastPartyOptionsMessagesFrameSLMessageFailPercent:SetValueStep(1);
   CastPartyOptionsMessagesFrameSLMessageFailPercent:SetValue(CastPartyConfig.message_failure_percent * 100);

   CastPartyOptionsMessagesFrameSLMessageSpamPercentHigh:SetText('100%');
   CastPartyOptionsMessagesFrameSLMessageSpamPercentLow:SetText('0%');
   CastPartyOptionsMessagesFrameSLMessageSpamPercent:SetMinMaxValues(0, 100);
   CastPartyOptionsMessagesFrameSLMessageSpamPercent:SetValueStep(1);
   CastPartyOptionsMessagesFrameSLMessageSpamPercent:SetValue(CastPartyConfig.message_disable_mana * 100);

   --Advanced Tab

   CastPartyOptionsAdvancedFrameSLRangeCheckIntervalHigh:SetText('60 sec');
   CastPartyOptionsAdvancedFrameSLRangeCheckIntervalLow:SetText('1 sec');
   CastPartyOptionsAdvancedFrameSLRangeCheckInterval:SetMinMaxValues(1, 60);
   CastPartyOptionsAdvancedFrameSLRangeCheckInterval:SetValueStep(1);
   CastPartyOptionsAdvancedFrameSLRangeCheckInterval:SetValue(CastPartyConfig.range_check_interval);

   CastPartyOptionsAdvancedFrameCBShowMonitor:SetChecked(CastPartyConfig.showMonitor);
   CastPartyOptionsAdvancedFrameCBInnerFire:SetChecked(CastPartyConfig.auto_cast_inner_fire);
   CastPartyOptionsAdvancedFrameCBAutoCast:SetChecked(CastPartyConfig.stop_autocast);

   CastPartyOptionsAdvancedFrameSLFrameSpacingHigh:SetText('200%');
   CastPartyOptionsAdvancedFrameSLFrameSpacingLow:SetText('0%');
   CastPartyOptionsAdvancedFrameSLFrameSpacing:SetMinMaxValues(0, 200);
   CastPartyOptionsAdvancedFrameSLFrameSpacing:SetValueStep(1);
   CastPartyOptionsAdvancedFrameSLFrameSpacing:SetValue(CastPartyConfig.frameSpacing * 100);

   CastPartyOptionsAdvancedFrameCBAdvancedSpells:SetChecked(CastPartyConfig.advanced_spells);
   CastPartyOptionsAdvancedFrameCBOverHealProtection:SetChecked(CastPartyConfig.overheal_protection);
   CastPartyOptionsAdvancedFrameCBShieldDetect:SetChecked(CastPartyConfig.shield_detection);
   CastPartyOptionsAdvancedFrameCBMaxHot:SetChecked(CastPartyConfig.max_rank_hot);
   CastPartyOptionsAdvancedFrameCBAutoShield:SetChecked(CastPartyConfig.shield_if_critical);

   CastPartyOptionsAdvancedFrameSLManaConserveThresholdHigh:SetText('100%');
   CastPartyOptionsAdvancedFrameSLManaConserveThresholdLow:SetText('0%');
   CastPartyOptionsAdvancedFrameSLManaConserveThreshold:SetMinMaxValues(0, 100);
   CastPartyOptionsAdvancedFrameSLManaConserveThreshold:SetValueStep(1);
   CastPartyOptionsAdvancedFrameSLManaConserveThreshold:SetValue(CastPartyConfig.mana_conserve_threshold * 100);

   CastPartyOptionsAdvancedFrameSLBandageThresholdHigh:SetText('100%');
   CastPartyOptionsAdvancedFrameSLBandageThresholdLow:SetText('0%');
   CastPartyOptionsAdvancedFrameSLBandageThreshold:SetMinMaxValues(0, 100);
   CastPartyOptionsAdvancedFrameSLBandageThreshold:SetValueStep(1);
   CastPartyOptionsAdvancedFrameSLBandageThreshold:SetValue(CastPartyConfig.bandage_threshold * 100);

   CastPartyOptionsAdvancedFrameSLPetHealthValueHigh:SetText('200%');
   CastPartyOptionsAdvancedFrameSLPetHealthValueLow:SetText('0%');
   CastPartyOptionsAdvancedFrameSLPetHealthValue:SetMinMaxValues(0, 200);
   CastPartyOptionsAdvancedFrameSLPetHealthValue:SetValueStep(1);
   CastPartyOptionsAdvancedFrameSLPetHealthValue:SetValue(CastPartyConfig.pet_health_value * 100);

   CastPartyOptionsAdvancedFrameSLDebugLevelHigh:SetText('5');
   CastPartyOptionsAdvancedFrameSLDebugLevelLow:SetText('1');
   CastPartyOptionsAdvancedFrameSLDebugLevel:SetMinMaxValues(1, 5);
   CastPartyOptionsAdvancedFrameSLDebugLevel:SetValueStep(1);
   CastPartyOptionsAdvancedFrameSLDebugLevel:SetValue(CastParty.DebugLevel);


   --scan the player for healing bonus items...
   CastParty.State.healing_base = 0;
   if (BonusScanner and BonusScanner.active) then
      CastParty.State.healing_base = BonusScanner:GetBonus('HEAL')
      if tonumber(CastParty.State.healing_base) > 0 then
		   CastPartyOptionsGeneralFrameHealingBonus:SetText(CASTPARTY_HEALING_BONUS .. GRN .. CastParty.State.healing_base);
		else
		   CastPartyOptionsGeneralFrameHealingBonus:SetText("");
		end
   end
end


